#<profile4xi profile = "12" />
# =================================================================================================
#<program4xi program = "hpu2kernel4xi.py">
#<abstract4xi abstract = "HPU kernel management"/>
#<refer4xi reference = "kernel4xi.py"/>
#<verify4xi verification = "10" target = "hpu2kernel4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API  
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'HPU2Kernel4Xi',                       # ACK 5.7.1  p157    

            'add2kernel4hpu',                      # ACK               

            'execute2kernel4hpu',                  # ACK 5.8    p169                                             
            'execute2task4hpu',                    # ACK 5.8    p172   
            'execute2nativekernel4hpu',            # ACK 5.8    p174     
            
            'create2kernel4hpu',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram4hpu',         # ACK 5.7.1  p158  
                       
            'delete2kernel4hpu',                   # ACK

            'fetch2kernel4hpu',                    # ACK 
            
            'get2kernelinfo4hpu',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo4hpu',         # ACK 5.7.3  p164  
            'get2kernelarginfo4hpu',               # ACK 5.7.3  p166                                  
            
            'release2kernel4hpu',                  # ACK 5.7.1  p159                                         
            'retain2kernel4hpu',                   # ACK 5.7.1  p159   
 
            'set2kernel4hpu',                      # ACK 
            'set2kernelcallback4hpu',              # ACK 
            'set2kernelarg4hpu',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel4hpu'                     # ACK 

          ] 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
from platform import processor
import sys
import threading                
import _thread   
from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi

# -------------------------------------------------------------------------------------------------
# Buffer                           
# -------------------------------------------------------------------------------------------------
from hpu2buffer4xi import get2bufferinfo4hpu

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from hpu2commandqueue4xi import HPU2CommandQueue4Xi
from hpu2commandqueue4xi import create2commandqueue4hpu 
from hpu2commandqueue4xi import flush2commandqueue4hpu
from hpu2commandqueue4xi import finish2commandqueue4hpu
from hpu2commandqueue4xi import get2commandqueueinfo4hpu
from hpu2commandqueue4xi import release2commandqueue4hpu
from hpu2commandqueue4xi import retain2commandqueue4hpu
from hpu2commandqueue4xi import set2commandqueue4hpu
from hpu2commandqueue4xi import trace2commandqueue4hpu

# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from hpu2context4xi import HPU2Context4Xi 
from hpu2context4xi import create2context4hpu
from hpu2context4xi import get2context4hpu
from hpu2context4xi import release2context4hpu
from hpu2context4xi import retain2context4hpu
from hpu2context4xi import set2context4hpu


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from hpu2device4xi import HPU4Xi
from hpu2device4xi import init2hpu4xi 
from hpu2device4xi import set2hpu4xi
from hpu2device4xi import get2hpu4xi

# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
from hpu2event4xi import HPU2Event4Xi
from hpu2event4xi import create2event4hpu
from hpu2event4xi import get2eventinfo4hpu
from hpu2event4xi import release2event4hpu
from hpu2event4xi import retain2event4hpu
from hpu2event4xi import set2eventcallback4hpu 
from hpu2event4xi import set2event4hpu
from hpu2event4xi import trace2event4hpu
from hpu2event4xi import wait2event4hpu


# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platformids4xi  import get2platformids4xi
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Program module                           
# -------------------------------------------------------------------------------------------------
from hpu2program4xi import HPU2Program4Xi
from hpu2program4xi import add2programwithsource4hpu
from hpu2program4xi import add2programwithbinary4hpu
from hpu2program4xi import build2program4hpu
from hpu2program4xi import compile2program4hpu
from hpu2program4xi import create2programwithsource4hpu
from hpu2program4xi import create2programwithbinary4hpu
from hpu2program4xi import delete2programwithsource4hpu
from hpu2program4xi import delete2programwithbinary4hpu
from hpu2program4xi import get2programinfo4hpu
# from hpu2program4xi import get2programbuildinfo4hpu
from hpu2program4xi import link2program4hpu
from hpu2program4xi import release2program4hpu
from hpu2program4xi import retain2program4hpu
from hpu2program4xi import set2programcallback4hpu 
from hpu2program4xi import set2programwithsource4hpu
from hpu2program4xi import set2programwithbinary4hpu
from hpu2program4xi import trace2program4hpu
# from hpu2program4xi import unload2compiler4hpu

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from arena4xi import Arena4Xi
from cpu_corecount4xi import cpu_corecount4xi
from dummyprocess4xi import DummyProcess4Xi
from print4xi import print4xi
from pipe4xi import Pipe4Xi
from process4xi import Process4Xi
from queue4xi import Queue4Xi  
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                         
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global hpu2kernel4xi                                                    # Kernel of HPU
global hpu2build4xi                                                     # Build of HPU
global hpu2compile4xi                                                   # Compile of HPU
global hpu2trace4xi                                                     # TRACE

global fetch2code4hpu                                                   # Fetched code

global import2use4hpu                                                   # Imports of target function for Process4Xi

global kb2fetch4hpu                                                     # Knowledgebase for fetching
global kb2kernel4hpu                                                    # Knowledgebase for kernel   

global folder2lib4hpu                                                   # Folder of HPU library

global profile2fetch                                                       # Profile knowledgebase for fetching
global keys2profile4hpu

global target2function4hpu                                              # Target function for Process4Xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
temp2hpu = 'hpu'
key2dir = temp2hpu[0]                                                                                               # MORE COMPLICATED WAY DUE TO AUTOMATIC SOFTWARE GENERATION
folder2lib4hpu = VersionKB4Xi[key2dir] 

profile2fetch = {}                                                                                                  # PROFILES FOR FETCHING
profile2fetch ['.py']  = 'ACK'                                                                                    
profile2fetch ['.pyc'] = 'ACK'                                                                                    
profile2fetch ['.cpp'] = 'ACK'                                                                                   
profile2fetch ['.exe'] = 'ACK'       
keys2profile4hpu = profile2fetch.keys()

kb2fetch4hpu = {}                                                                                                   # PROGRAMS TO BE FETCHED - ALWAYS DEFINE BOTH SOURCE AND BINARY PAIRS                               
kb2fetch4hpu[1] = folder2lib4hpu + 'hpu2sampler4xi5test.py'                                                         # Python code
kb2fetch4hpu[2] = folder2lib4hpu + '__pycache__//hpu2sampler4xi.cpython-33.pyc'   
kb2fetch4hpu[3] = folder2lib4hpu + 'hpu2dummy4xi5test.cpp'                                                          # C++ code
kb2fetch4hpu[4] = folder2lib4hpu + "bin//hpu2dummy4xi5test.exe"                                                     # C++ binary

# kb2fetch4hpu[1]  = folder2lib4hpu + 'hpu2sampler4xi5test.py'                                                      
# kb2fetch4hpu[2]  = folder2lib4hpu + '__pycache__//hpu2sampler4xi.cpython-33.pyc'                                  
# kb2fetch4hpu[3]  = folder2lib4hpu + 'hpu2image4xi5test.py'
# kb2fetch4hpu[4]  = folder2lib4hpu + '__pycache__//hpu2image4xi.cpython-33.pyc'
# kb2fetch4hpu[5]  = folder2lib4hpu + 'hpu3image4xi5test.py'
# kb2fetch4hpu[6]  = folder2lib4hpu + '__pycache__//hpu3image4xi.cpython-33.pyc'
# kb2fetch4hpu[7]  = folder2lib4hpu + 'hpu2commandqueue4xi5test.py'
# kb2fetch4hpu[8]  = folder2lib4hpu + '__pycache__//hpu2commandqueue4xi.cpython-33.pyc'
# kb2fetch4hpu[9]  = folder2lib4hpu + 'hpu2event4xi5test.py'
# kb2fetch4hpu[10] = folder2lib4hpu + '__pycache__//hpu2event4xi.cpython-33.pyc'
# kb2fetch4hpu[10]  = folder2lib4hpu + 'HPU2kernel4xi5test.py'
# kb2fetch4hpu[11] = folder2lib4hpu + '__pycache__//hpu2program.cpython-33.pyc'

fetch2code4hpu = {}                                                                                                 # reception arena in memory for code

kb2kernel4hpu = {}
kb2kernel4hpu ['.py'] = {}
kb2kernel4hpu ['.py'] ['TAG']            = "<function4xi function ="                                                
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4hpu ['.py'] ['VALUE']          = "hpu2sampler4xi5test" 
kb2kernel4hpu ['.py'] ['ATTRIBUTE']      = 'usage = "' 

kb2kernel4hpu ['.cpp'] = {}
kb2kernel4hpu ['.cpp'] ['TAG']            = "<function4xi function ="                                               
#</function4xi>                                                                                                     # added for parsing!
kb2kernel4hpu ['.cpp'] ['VALUE']          = "hpu2dummy4xi5test" 
kb2kernel4hpu ['.cpp'] ['ATTRIBUTE']      = 'usage = "kernel'                                                       

#"/>

# -------------------------------------------------------------------------------------------------
# Command queue module of HPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importcreate2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import create2commandqueue4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importflush2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importflush2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import flush2commandqueue4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importfinish2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importfinish2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import finish2commandqueue4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2commandqueueinfo4hpu" usage = " importing target function for Process4Xi">
def importget2commandqueueinfo4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import get2commandqueueinfo4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importrelease2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importrelease2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import release2commandqueue4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importretain2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importretain2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import retain2commandqueue4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importset2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importset2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import set2commandqueue4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importtrace2commandqueue4hpu" usage = " importing target function for Process4Xi">
def importtrace2commandqueue4hpu():
   global target2function4hpu
   from hpu2commandqueue4xi import trace2commandqueue4hpu as target2function4hpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Context module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2context4hpu" usage = " importing target function for Process4Xi">
def importcreate2context4hpu():
   global target2function4hpu
   from hpu2context4xi import create2context4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2context4hpu" usage = " importing target function for Process4Xi">
def importget2context4hpu():
   global target2function4hpu
   from hpu2context4xi import get2context4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importrelease2context4hpu" usage = " importing target function for Process4Xi">
def importrelease2context4hpu():
   global target2function4hpu
   from hpu2context4xi import release2context4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importretain2context4hpu" usage = " importing target function for Process4Xi">
def importretain2context4hpu():
   global target2function4hpu
   from hpu2context4xi import retain2context4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importset2context4hpu" usage = " importing target function for Process4Xi">
def importset2context4hpu():
   global target2function4hpu
   from hpu2context4xi import set2context4hpu as target2function4hpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Device module of HPU imports for target function                           
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importinit2hpu4xi" usage = " importing target function for Process4Xi">
def importinit2hpu4xi():
   global target2function4hpu
   from hpu2device4xi import init2hpu4xi as target2function4hpu 
#</function4xi>
 
#<function4xi function = "importset2hpu4xi" usage = " importing target function for Process4Xi">
def importset2hpu4xi():
   global target2function4hpu
   from hpu2device4xi import set2hpu4xi   as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2hpu4xi" usage = " importing target function for Process4Xi">
def importget2hpu4xi():
   global target2function4hpu
   from hpu2device4xi import get2hpu4xi   as target2function4hpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Event module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2event4hpu" usage = " importing target function for Process4Xi">
def importcreate2event4hpu():
   global target2function4hpu
   from hpu2event4xi import create2event4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2eventinfo4hpu" usage = " importing target function for Process4Xi">
def importget2eventinfo4hpu():
   global target2function4hpu
   from hpu2event4xi import get2eventinfo4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importrelease2event4hpu" usage = " importing target function for Process4Xi">
def importrelease2event4hpu():
   global target2function4hpu
   from hpu2event4xi import release2event4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importretain2event4hpu" usage = " importing target function for Process4Xi">
def importretain2event4hpu():
   global target2function4hpu
   from hpu2event4xi import retain2event4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importset2eventcallback4hpu" usage = " importing target function for Process4Xi">
def importset2eventcallback4hpu():
   global target2function4hpu
   from hpu2event4xi import set2eventcallback4hpu as target2function4hpu 
#</function4xi>
 
#<function4xi function = "importset2event4hpu" usage = " importing target function for Process4Xi">
def importset2event4hpu():
   global target2function4hpu
   from hpu2event4xi import set2event4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importtrace2event4hpu" usage = " importing target function for Process4Xi">
def importtrace2event4hpu():
   global target2function4hpu
   from hpu2event4xi import trace2event4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importwait2event4hpu" usage = " importing target function for Process4Xi">
def importwait2event4hpu():
   global target2function4hpu
   from hpu2event4xi import wait2event4hpu as target2function4hpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# 2D Image module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2image4hpu" usage = " importing target function for Process4Xi">
def importcreate2image4hpu():
   global target2function4hpu
   from hpu2image4xi import create2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2imageinfo4hpu" usage = " importing target function for Process4Xi">
def importget2imageinfo4hpu():
   global target2function4hpu
   from hpu2image4xi import get2imageinfo4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2supportedimageformats4hpu" usage = " importing target function for Process4Xi">
def importget2supportedimageformats4hpu():
   global target2function4hpu
   from hpu2image4xi import get2supportedimageformats4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimage4hpu():
   global target2function4hpu
   from hpu2image4xi import manoeuvre2copyimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copyimagetobuffer4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copyimagetobuffer4hpu():
   global target2function4hpu
   from hpu2image4xi import manoeuvre2copyimagetobuffer4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2copybuffertoimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2copybuffertoimage4hpu():
   global target2function4hpu
   from hpu2image4xi import manoeuvre2copybuffertoimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2readimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2readimage4hpu():
   global target2function4hpu
   from hpu2image4xi import manoeuvre2readimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2writeimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2writeimage4hpu():
   global target2function4hpu
   from hpu2image4xi import manoeuvre2writeimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre2mapimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre2mapimage4hpu():
   global target2function4hpu
   from hpu2image4xi import manoeuvre2mapimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importcopy2image4hpu" usage = " importing target function for Process4Xi">
def importcopy2image4hpu():
   global target2function4hpu
   from hpu2image4xi import copy2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importcopy2imagetobuffer4hpu" usage = " importing target function for Process4Xi">
def importcopy2imagetobuffer4hpu():
   global target2function4hpu
   from hpu2image4xi import copy2imagetobuffer4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importcopy2buffertoimage4hpu" usage = " importing target function for Process4Xi">
def importcopy2buffertoimage4hpu():
   global target2function4hpu
   from hpu2image4xi import copy2buffertoimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importread2image4hpu" usage = " importing target function for Process4Xi">
def importread2image4hpu():
   global target2function4hpu
   from hpu2image4xi import read2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmap2image4hpu" usage = " importing target function for Process4Xi">
def importmap2image4hpu():
   global target2function4hpu
   from hpu2image4xi import map2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importrelease2image4hpu" usage = " importing target function for Process4Xi">
def importrelease2image4hpu():
   global target2function4hpu
   from hpu2image4xi import release2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importretain2image4hpu" usage = " importing target function for Process4Xi">
def importretain2image4hpu():
   global target2function4hpu
   from hpu2image4xi import retain2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importset2imagecallback4hpu" usage = " importing target function for Process4Xi">
def importset2imagecallback4hpu():
   global target2function4hpu
   from hpu2image4xi import set2imagecallback4hpu as target2function4hpu 
#</function4xi>
 
#<function4xi function = "importset2image4hpu" usage = " importing target function for Process4Xi">
def importset2image4hpu():
   global target2function4hpu
   from hpu2image4xi import set2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importtrace2image4hpu" usage = " importing target function for Process4Xi">
def importtrace2image4hpu():
   global target2function4hpu
   from hpu2image4xi import trace2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importwait2image4hpu" usage = " importing target function for Process4Xi">
def importwait2image4hpu():
   global target2function4hpu
   from hpu2image4xi import wait2image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importwrite2image4hpu" usage = " importing target function for Process4Xi">
def importwrite2image4hpu():
   global target2function4hpu
   from hpu2image4xi import write2image4hpu as target2function4hpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# 3D Image module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate3image4hpu" usage = " importing target function for Process4Xi">
def importcreate3image4hpu():
   global target2function4hpu
   from hpu3image4xi import create3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget3imageinfo4hpu" usage = " importing target function for Process4Xi">
def importget3imageinfo4hpu():
   global target2function4hpu
   from hpu3image4xi import get3imageinfo4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget3supportedimageformats4hpu" usage = " importing target function for Process4Xi">
def importget3supportedimageformats4hpu():
   global target2function4hpu
   from hpu3image4xi import get3supportedimageformats4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimage4hpu():
   global target2function4hpu
   from hpu3image4xi import manoeuvre3copyimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copyimagetobuffer4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copyimagetobuffer4hpu():
   global target2function4hpu
   from hpu3image4xi import manoeuvre3copyimagetobuffer4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3copybuffertoimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3copybuffertoimage4hpu():
   global target2function4hpu
   from hpu3image4xi import manoeuvre3copybuffertoimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3readimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3readimage4hpu():
   global target2function4hpu
   from hpu3image4xi import manoeuvre3readimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3writeimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3writeimage4hpu():
   global target2function4hpu
   from hpu3image4xi import manoeuvre3writeimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmanoeuvre3mapimage4hpu" usage = " importing target function for Process4Xi">
def importmanoeuvre3mapimage4hpu():
   global target2function4hpu
   from hpu3image4xi import manoeuvre3mapimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importcopy3image4hpu" usage = " importing target function for Process4Xi">
def importcopy3image4hpu():
   global target2function4hpu
   from hpu3image4xi import copy3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importcopy3imagetobuffer4hpu" usage = " importing target function for Process4Xi">
def importcopy3imagetobuffer4hpu():
   global target2function4hpu
   from hpu3image4xi import copy3imagetobuffer4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importcopy3buffertoimage4hpu" usage = " importing target function for Process4Xi">
def importcopy3buffertoimage4hpu():
   global target2function4hpu
   from hpu3image4xi import copy3buffertoimage4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importread3image4hpu" usage = " importing target function for Process4Xi">
def importread3image4hpu():
   global target2function4hpu
   from hpu3image4xi import read3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importmap3image4hpu" usage = " importing target function for Process4Xi">
def importmap3image4hpu():
   global target2function4hpu
   from hpu3image4xi import map3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importrelease3image4hpu" usage = " importing target function for Process4Xi">
def importrelease3image4hpu():
   global target2function4hpu
   from hpu3image4xi import release3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importretain3image4hpu" usage = " importing target function for Process4Xi">
def importretain3image4hpu():
   global target2function4hpu
   from hpu3image4xi import retain3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importset3imagecallback4hpu" usage = " importing target function for Process4Xi">
def importset3imagecallback4hpu():
   global target2function4hpu
   from hpu3image4xi import set3imagecallback4hpu as target2function4hpu 
#</function4xi>
 
#<function4xi function = "importset3image4hpu" usage = " importing target function for Process4Xi">
def importset3image4hpu():
   global target2function4hpu
   from hpu3image4xi import set3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importtrace3image4hpu" usage = " importing target function for Process4Xi">
def importtrace3image4hpu():
   global target2function4hpu
   from hpu3image4xi import trace3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importwait3image4hpu" usage = " importing target function for Process4Xi">
def importwait3image4hpu():
   global target2function4hpu
   from hpu3image4xi import wait3image4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importwrite3image4hpu" usage = " importing target function for Process4Xi">
def importwrite3image4hpu():
   global target2function4hpu
   from hpu3image4xi import write3image4hpu as target2function4hpu
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Sampler module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2sampler4hpu" usage = " importing target function for Process4Xi">
def importcreate2sampler4hpu():
   global target2function4hpu
   from hpu2sampler4xi import create2sampler4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importget2samplerinfo4hpu" usage = " importing target function for Process4Xi">
def importget2samplerinfo4hpu():
   global target2function4hpu
   from hpu2sampler4xi import get2samplerinfo4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importrelease2sampler4hpu" usage = " importing target function for Process4Xi">
def importrelease2sampler4hpu():
   global target2function4hpu
   from hpu2sampler4xi import release2sampler4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importretain2sampler4hpu" usage = " importing target function for Process4Xi">
def importretain2sampler4hpu():
   global target2function4hpu
   from hpu2sampler4xi import retain2sampler4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importset2samplercallback4hpu" usage = " importing target function for Process4Xi">
def importset2samplercallback4hpu():
   global target2function4hpu
   from hpu2sampler4xi import set2samplercallback4hpu as target2function4hpu 
#</function4xi>
 
#<function4xi function = "importset2sampler4hpu" usage = " importing target function for Process4Xi">
def importset2sampler4hpu():
   global target2function4hpu
   from hpu2sampler4xi import set2sampler4hpu as target2function4hpu
#</function4xi>
 
#<function4xi function = "importtrace2sampler4hpu" usage = " importing target function for Process4Xi">
def importtrace2sampler4hpu():
   global target2function4hpu
   from hpu2sampler4xi import trace2sampler4hpu as target2function4hpu
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
# Program module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importcreate2programwithsource4hpu" usage = " importing target function for Process4Xi">
def importcreate2programwithsource4hpu():
   global target2function4hpu
   from hpu2kernel4xi import create2programwithsource4hpu as target2function4hpu
#</function4xi> 

#<function4xi function = "importcreate2programwithbinary4hpu" usage = " importing target function for Process4Xi">
def importcreate2programwithbinary4hpu():
   global target2function4hpu
   from hpu2kernel4xi import create2programwithbinary4hpu as target2function4hpu
#</function4xi> 

#<function4xi function = "importadd2programwithsource4hpu" usage = " importing target function for Process4Xi">
def importadd2programwithsource4hpu():
   global target2function4hpu
   from hpu2kernel4xi import add2programwithsource4hpu as target2function4hpu
#</function4xi> 

#<function4xi function = "importadd2programwithbinary4hpu" usage = " importing target function for Process4Xi">
def importadd2programwithbinary4hpu():
   global target2function4hpu
   from hpu2kernel4xi import add2programwithbinary4hpu as target2function4hpu
#</function4xi>

#<function4xi function = "importbuild2program4hpu" usage = " importing target function for Process4Xi">
def importbuild2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import build2program4hpu as target2function4hpu
#</function4xi>

#<function4xi function = "importbuild2program4hpu" usage = " importing target function for Process4Xi">
def importbuild2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import build2program4hpu as target2function4hpu
#</function4xi>

#<function4xi function = "importcompile2program4hpuX" usage = " importing target function for Process4Xi">
def importcompile2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import compile2program4hpu as target2function4hpu
#</function4xi>

#<function4xi function = "importdelete2programwithsource4hpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithsource4hpu():
   global target2function4hpu
   from hpu2kernel4xi import delete2programwithsource4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importdelete2programwithbinary4hpuX" usage = " importing target function for Process4Xi">
def importdelete2programwithbinary4hpu():
   global target2function4hpu
   from hpu2kernel4xi import delete2programwithbinary4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importget2programinfo4hpuX" usage = " importing target function for Process4Xi">
def importget2programinfo4hpu():
   global target2function4hpu
   from hpu2kernel4xi import get2programinfo4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importlink2program4hpuX" usage = " importing target function for Process4Xi">
def importlink2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import link2program4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importrelease2program4hpuX" usage = " importing target function for Process4Xi">
def importrelease2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import release2program4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importretain2program4hpuX" usage = " importing target function for Process4Xi">
def importretain2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import retain2program4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importset2programcallback4hpuX" usage = " importing target function for Process4Xi">
def importset2programcallback4hpu():
   global target2function4hpu
   from hpu2kernel4xi import set2programcallback4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importset2programwithsource4hpuX" usage = " importing target function for Process4Xi">
def importset2programwithsource4hpu():
   global target2function4hpu
   from hpu2kernel4xi import set2programwithsource4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importset2programwithbinary4hpuX" usage = " importing target function for Process4Xi">
def importset2programwithbinary4hpu():
   global target2function4hpu
   from hpu2kernel4xi import set2programwithbinary4hpu as target2function4hpu
#</function4xi>    

#<function4xi function = "importtrace2program4hpuX" usage = " importing target function for Process4Xi">
def importtrace2program4hpu():
   global target2function4hpu
   from hpu2kernel4xi import trace2program4hpu as target2function4hpu
#</function4xi>    

# -------------------------------------------------------------------------------------------------
# Test modules of HPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "importhpu2commandqueue4xi5test" usage = " importing target function for Process4Xi">
def importhpu2commandqueue4xi5test():
   global target2function4hpu
   from hpu2commandqueue4xi5test import hpu2commandqueue4xi5test as target2function4hpu
#</function4xi> 

#<function4xi function = "importhpu2event4xi5test" usage = " importing target function for Process4Xi">
def importhpu2event4xi5test():
   global target2function4hpu
   from hpu2event4xi5test import hpu2event4xi5test as target2function4hpu
#</function4xi>
 
#<function4xi function = "importhpu2image4xi5test" usage = " importing target function for Process4Xi">
def importhpu2image4xi5test():
   global target2function4hpu
   from hpu2image4xi5test import hpu2image4xi5test as target2function4hpu
#</function4xi>
 
#<function4xi function = "importhpu3image4xi5test" usage = " importing target function for Process4Xi">
def importhpu3image4xi5test():
   global target2function4hpu
   from hpu3image4xi5test import hpu3image4xi5test as target2function4hpu
#</function4xi>
 
#<function4xi function = "importhpu2sampler4xi5test" usage = " importing target function for Process4Xi">
def importhpu2sampler4xi5test():
   global target2function4hpu
   from hpu2sampler4xi5test import hpu2sampler4xi5test as target2function4hpu
#</function4xi>
 
#<function4xi function = "importHPU2kernel4xi5test" usage = " importing target function for Process4Xi">
def importhpu2kernel4xi5test():
   global target2function4hpu
   from hpu2kernel4xi5test import hpu2kernel4xi5test as target2function4hpu
#</function4xi> 

# -------------------------------------------------------------------------------------------------
# Error handler of HPU imports for target function                             
# -------------------------------------------------------------------------------------------------
#<function4xi function = "handle2error4hpu" usage = " Error handling for importing target function for Process4Xi">
def handle2error4hpu():
   global import2use4hpu
   print ("HANDLE2ERROR4HPU OF HPU2KERNEL4XI.PY: *** FAILED TO IMPORT TARGET FUNCTION ***")
   keys2import4hpu = import2use4hpu.keys()
   for key2import4hpu in keys2import4hpu:
       print(key2import4hpu,import2use4hpu[key2import4hpu]) 
#</function4xi> 


import2use4hpu = {}
# -------------------------------------------------------------------------------------------------
# Command queue module of HPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4hpu["create2commandqueue4hpu"] = importcreate2commandqueue4hpu        
import2use4hpu["flush2commandqueue4hpu"] = importflush2commandqueue4hpu 
import2use4hpu["finish2commandqueue4hpu"] = importfinish2commandqueue4hpu 
import2use4hpu["get2commandqueueinfo4hpu"] = importget2commandqueueinfo4hpu 
import2use4hpu["release2commandqueue4hpu"] = importrelease2commandqueue4hpu 
import2use4hpu["retain2commandqueue4hpu"] = importretain2commandqueue4hpu 
import2use4hpu["set2commandqueue4hpu"] = importset2commandqueue4hpu 
import2use4hpu["trace2commandqueue4hpu"] = importtrace2commandqueue4hpu 

# -------------------------------------------------------------------------------------------------
# Context module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4hpu["create2context4hpu"] = importcreate2context4hpu 
import2use4hpu["get2context4hpu"] = importget2context4hpu 
import2use4hpu["release2context4hpu"] = importrelease2context4hpu 
import2use4hpu["retain2context4hpu"] = importretain2context4hpu 
import2use4hpu["set2context4hpu"] = importset2context4hpu 

# -------------------------------------------------------------------------------------------------
# Device module of HPU imports for target function                           
# -------------------------------------------------------------------------------------------------
import2use4hpu["init2hpu4xi"] = importinit2hpu4xi 
import2use4hpu["set2hpu4xi"] = importset2hpu4xi 
import2use4hpu["get2hpu4xi"] = importget2hpu4xi 

# -------------------------------------------------------------------------------------------------
# Event module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4hpu["create2event4hpu"] = importcreate2event4hpu 
import2use4hpu["get2eventinfo4hpu"] = importget2eventinfo4hpu 
import2use4hpu["release2event4hpu"] = importrelease2event4hpu 
import2use4hpu["retain2event4hpu"] = importretain2event4hpu 
import2use4hpu["set2eventcallback4hpu"] = importset2eventcallback4hpu 
import2use4hpu["set2event4hpu"] = importset2event4hpu 
import2use4hpu["trace2event4hpu"] = importtrace2event4hpu 
import2use4hpu["wait2event4hpu"] = importwait2event4hpu 

# -------------------------------------------------------------------------------------------------
# 2D Image module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4hpu["create2image4hpu"] = importcreate2image4hpu 
import2use4hpu["get2imageinfo4hpu"] = importget2imageinfo4hpu 
import2use4hpu["get2supportedimageformats4hpu"] = importget2supportedimageformats4hpu 
import2use4hpu["manoeuvre2copyimage4hpu"] = importmanoeuvre2copyimage4hpu 
import2use4hpu["manoeuvre2copyimagetobuffer4hpu"] = importmanoeuvre2copyimagetobuffer4hpu 
import2use4hpu["manoeuvre2copybuffertoimage4hpu"] = importmanoeuvre2copybuffertoimage4hpu 
import2use4hpu["manoeuvre2readimage4hpu"] = importmanoeuvre2readimage4hpu 
import2use4hpu["manoeuvre2writeimage4hpu"] = importmanoeuvre2writeimage4hpu 
import2use4hpu["manoeuvre2mapimage4hpu"] = importmanoeuvre2mapimage4hpu 
import2use4hpu["copy2image4hpu"] = importcopy2image4hpu 
import2use4hpu["copy2imagetobuffer4hpu"] = importcopy2imagetobuffer4hpu 
import2use4hpu["copy2buffertoimage4hpu"] = importcopy2buffertoimage4hpu 
import2use4hpu["read2image4hpu"] = importread2image4hpu 
import2use4hpu["map2image4hpu"] = importmap2image4hpu 
import2use4hpu["release2image4hpu"] = importrelease2image4hpu 
import2use4hpu["retain2image4hpu"] = importretain2image4hpu 
import2use4hpu["set2imagecallback4hpu"] = importset2imagecallback4hpu 
import2use4hpu["set2image4hpu"] = importset2image4hpu 
import2use4hpu["trace2image4hpu"] = importtrace2image4hpu 
import2use4hpu["wait2image4hpu"] = importwait2image4hpu 
import2use4hpu["write2image4hpu"] = importwrite2image4hpu 

# -------------------------------------------------------------------------------------------------
# 3D Image module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4hpu["create3image4hpu"] = importcreate3image4hpu 
import2use4hpu["get3imageinfo4hpu"] = importget3imageinfo4hpu 
import2use4hpu["get3supportedimageformats4hpu"] = importget3supportedimageformats4hpu 
import2use4hpu["manoeuvre3copyimage4hpu"] = importmanoeuvre3copyimage4hpu 
import2use4hpu["manoeuvre3copyimagetobuffer4hpu"] = importmanoeuvre3copyimagetobuffer4hpu 
import2use4hpu["manoeuvre3copybuffertoimage4hpu"] = importmanoeuvre3copybuffertoimage4hpu 
import2use4hpu["manoeuvre3readimage4hpu"] = importmanoeuvre3readimage4hpu 
import2use4hpu["manoeuvre3writeimage4hpu"] = importmanoeuvre3writeimage4hpu 
import2use4hpu["manoeuvre3mapimage4hpu"] = importmanoeuvre3mapimage4hpu 
import2use4hpu["copy3image4hpu"] = importcopy3image4hpu 
import2use4hpu["copy3imagetobuffer4hpu"] = importcopy3imagetobuffer4hpu 
import2use4hpu["copy3buffertoimage4hpu"] = importcopy3buffertoimage4hpu 
import2use4hpu["read3image4hpu"] = importread3image4hpu 
import2use4hpu["map3image4hpu"] = importmap3image4hpu 
import2use4hpu["release3image4hpu"] = importrelease3image4hpu 
import2use4hpu["retain3image4hpu"] = importretain3image4hpu 
import2use4hpu["set3imagecallback4hpu"] = importset3imagecallback4hpu 
import2use4hpu["set3image4hpu"] = importset3image4hpu 
import2use4hpu["trace3image4hpu"] = importtrace3image4hpu 
import2use4hpu["wait3image4hpu"] = importwait3image4hpu 
import2use4hpu["write3image4hpu"] = importwrite3image4hpu 

# -------------------------------------------------------------------------------------------------
# Sampler module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4hpu["create2sampler4hpu"] = importcreate2sampler4hpu 
import2use4hpu["get2samplerinfo4hpu"] = importget2samplerinfo4hpu 
import2use4hpu["release2sampler4hpu"] = importrelease2sampler4hpu 
import2use4hpu["retain2sampler4hpu"] = importretain2sampler4hpu 
import2use4hpu["set2samplercallback4hpu"] = importset2samplercallback4hpu 
import2use4hpu["set2sampler4hpu"] = importset2sampler4hpu 
import2use4hpu["trace2sampler4hpu"] = importtrace2sampler4hpu 

# -------------------------------------------------------------------------------------------------
# Program module of HPU imports for target function                              
# -------------------------------------------------------------------------------------------------
import2use4hpu["trace2program4hpu"] = importtrace2program4hpu
import2use4hpu["set2programwithbinary4hpu"] = importset2programwithbinary4hpu
import2use4hpu["set2programwithsource4hpu"] = importset2programwithsource4hpu
import2use4hpu["set2programcallback4hpu"] = importset2programcallback4hpu
import2use4hpu["retain2program4hpu"] = importretain2program4hpu
import2use4hpu["release2program4hpu"] = importrelease2program4hpu
import2use4hpu["link2program4hpu"] = importlink2program4hpu
import2use4hpu["get2programinfo4hpu"] = importget2programinfo4hpu
import2use4hpu["delete2programwithbinary4hpu"] = importdelete2programwithbinary4hpu
import2use4hpu["delete2programwithsource4hpu"] = importdelete2programwithsource4hpu
import2use4hpu["compile2program4hpu"] = importcompile2program4hpu
import2use4hpu["build2program4hpu"] = importbuild2program4hpu
import2use4hpu["build2program4hpu"] = importbuild2program4hpu
import2use4hpu["add2programwithbinary4hpu"] = importadd2programwithbinary4hpu
import2use4hpu["add2programwithsource4hpu"] = importadd2programwithsource4hpu
import2use4hpu["create2programwithbinary4hpu"] = importcreate2programwithbinary4hpu
import2use4hpu["create2programwithsource4hpu"] = importcreate2programwithsource4hpu



# -------------------------------------------------------------------------------------------------
# Test modules of HPU imports for target function                             
# -------------------------------------------------------------------------------------------------
import2use4hpu["hpu2commandqueue4xi5test"] = importhpu2commandqueue4xi5test 
import2use4hpu["hpu2event4xi5test"] = importhpu2event4xi5test 
import2use4hpu["hpu2image4xi5test"] = importhpu2image4xi5test 
import2use4hpu["hpu3image4xi5test"] = importhpu3image4xi5test 
import2use4hpu["hpu2sampler4xi5test"] = importhpu2sampler4xi5test 
import2use4hpu["hpu2kernel4xi5test"] = importhpu2kernel4xi5test 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "trace2kernel4hpu" usage = "
#
#   print('=' *33)          
#   print('(Step 15A/25) OF HPU2KERNEL4XI5TEST - TRYING TO TRACE HPU: ', time4xi())      
#   print('=' *33)      
#   trace2hpu = None
#   try:
#       trace2hpu = trace2kernel4hpu() 
#       print('(Step 15B/25) OF HPU2KERNEL4XI5TEST - TRACE2HPU: ', trace2hpu)  
#       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4hpu-failed {}; time: 04:32:25 11/07/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4hpu', 'METHOD': 'trace2kernel4hpu'} 
#   except:
#       print('(Step 15Z1/25) OF HPU2KERNEL4XI5TEST *** FAILED TO TRACE HPU: ', trace2hpu) 
#      
#">

# -------------------------------------------------------------------------------------------------   
def trace2kernel4hpu(task4trace2hpu=None):  

    '''
    creates callback to hpu2kernel4xi
    '''
    
    global hpu2trace4xi
    global folder2lib4hpu    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "trace2kernel4hpu" 
    method2print = "trace2kernel4hpu"

    message2print = "{(Step 1A/33) started" + "; trace2kernel4hpu-started: " + str(trace2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                               
    # 
  
             
    message2print = "{(Step 1B/33) passed" + "; task4trace2hpu-to-trace2kernel4hpu: " + str(task4trace2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    hpu2trace4xi = {}                                                                                               # INITIALIZES TO EMPTY DICTIONARY
      
    if task4trace2hpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN BY HPUIZED CALLBACK !
        # -----------------------------------------------------------------------------------------    
        task4trace2hpu = {}                                                                                            
            
        task4trace2hpu['CLASS']   = "trace2kernel4hpu"                                                              # HPUIZE ZPU TRACE!
        task4trace2hpu['METHOD']  = "trace2kernel4hpu" 
        task4trace2hpu['MESSAGE'] = "{(Step 2Z0/33) failed" + "; trace2kernel4hpu-failed " + str(hpu2trace4xi)  + "; time: " + time4xi() + "}"               
  
        
        message2print = "{(Step 2A/33) set" + "; task4trace2hpu-set-by-trace2kernel4hpu to: " + str(task4trace2hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # PARAMETER GIVEN BY HPUIZED CALLBACK !
    # -----------------------------------------------------------------------------------------          
    message2print = "{(Step 3A/33) try" + "; task4trace2hpu-try-by-trace2kernel4hpu: " + str(task4trace2hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    
    # 

    try:
        hpu2trace4xi ['CLASS']  = task4trace2hpu['CLASS']                                                           # HPUIZE HPU TRACE!
        hpu2trace4xi ['METHOD']  = task4trace2hpu['METHOD']
        hpu2trace4xi ['MESSAGE'] = task4trace2hpu['MESSAGE']
        
        message2print = "{(Step 3B/33) set" + "; hpu2trace4xi-set-by-trace2kernel4hpu to: " + str(hpu2trace4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 

        code2ack = code2ack + '3B-'         
    except:
        message2print = "{(Step 3Z1/33) failed" + "; hpu-trace-failed-by-trace2kernel4hpu: " + str(task4trace2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z1-' 
        
    try:
        # =================================
        # SIMULATE HPU TRACE
        # =================================
        class2print   = task4trace2hpu['CLASS']                                                                     # HPUIZE HPU TRACE!
        method2print  = task4trace2hpu['METHOD']
        
        message2print = task4trace2hpu['MESSAGE']
        print4xi(class2print, method2print, message2print)                                                          # HPUIZED TRACE FOR OPENCL CALLBACK!
        # 
        
        
        code2ack = code2ack + '3C-'         
    except:
        class2print = "trace2kernel4hpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4hpu"   
        message2print = "{(Step 3Z2/33) failed" + "; simulation-of-hpu-trace-failed-by-trace2kernel4hpu: " + str(task4trace2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z2-' 
        
    try:
        # =================================
        # NORMAL TRACE
        # =================================                     
        class2print = "trace2kernel4hpu"                                                                            # SET TRACE BACK TO THIS FUNCTION!
        method2print = "trace2kernel4hpu"                
        message2print = "{(Step 3D/33) performed" + "; hpu-trace-performed-by-trace2kernel4hpu: " + str(task4trace2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        code2ack = code2ack + '3D-' 
    except:
        message2print = "{(Step 3Z3/33) failed" + "; hpu-trace-failed-by-trace2kernel4hpu: " + str(task4trace2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                    
        code2nack = code2nack + '3Z3-' 

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; hpu2trace4xi-returning-by-trace2kernel4hpu: " + str(hpu2trace4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return hpu2trace4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2kernel4hpu" usage = "
#
#   response4execute2kernel = execute2kernel4hpu()
#      
#">

# -------------------------------------------------------------------------------------------------   
def execute2kernel4hpu(task4execute2hpu=None):  

    '''
    executes kernel to HPU 
    '''
    global folder2lib4hpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)         
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2kernel4hpu" 
    method2print = "execute2kernel4hpu"

    message2print = "{(Step 1A/33) started" + "; execute2kernel4hpu-started: " + str(execute2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
  
          
    message2print = "{(Step 1B/33) passed" + "; task4execute2hpu-to-execute2kernel4hpu: " + str(task4execute2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                            # 
    # 
    status4execute2hpu = 'CL_SUCCESS'
    
    code2ack  = ' '
    code2nack = ' '    
    
                                                                                                                  #       
    if task4execute2hpu is None:
        # -----------------------------------------------------------------------------------------
        # NO PARAMETERS GIVEN - BUILD THEM
        # -----------------------------------------------------------------------------------------    
        task4execute2hpu = {}                                                                                            

        message2print = "{(Step 2A/33) set" + "; task4execute2hpu-set-by-execute2kernel4hpu to: " + str(task4execute2hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
    
        code2ack = code2ack + '2A-'            


    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------          
    status4execute2hpu = 'CL_SUCCESS'
    message2print = "{(Step 3A/33) set" + "; status4execute2hpu-set-by-execute2kernel4hpu to: " + str(status4execute2hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
    

    # -----------------------------------------------------------------------------------------
    # (Step 33/3)           
    # -----------------------------------------------------------------------------------------
    message2print = "{(Step 33/33) returning" + "; status4execute2hpu-returning-by-execute2kernel4hpu: " + str(status4execute2hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    
    return status4execute2hpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelcallback4hpu" usage = "
#
#   print('(Step 14A/700) OF HPU2KERNEL4XI5TEST - TRYING TO SET PROGRAM CALLBACK OF HPU ', time4xi())  
#   try:                               
#       response4setcallback2program = set2kernelcallback4hpu()                                                                                                 
#       print('(Step 14B/700) OF HPU2KERNEL4XI5TEST - SET PROGRAM CALLBACK OF HPU TO: ', response4setcallback2program)   
#       # 
#   except:
#       print('(Step 14Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SET PROGRAM CALLBACK OF HPU ', time4xi())  
# 
#">

# ------------------------------------------------------------------------------------------------- 
 
def set2kernelcallback4hpu(task4set2kernelcallback=None):

    '''
    registers callback function to hpu2kernel4xi
    '''
    global hpu2kernel4xi
    global folder2lib4hpu  
        
    class2print = "set2kernelcallback4hpu" 
    method2print = "set2kernelcallback4hpu"
    
    message2print = "{(Step 2A/70) started" + "; set2kernelcallback4hpu-started: " + str(set2kernelcallback4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # set2kernelcallback4hpu-started
    
    try:
    
        hpu2kernel4xi ['CALLBACK'] = trace2kernel4hpu
        
        
        message2print = "{(Step 2C/70) returning" + "; callback-of-hpu2kernel4xi-returning-by-set2kernelcallback4hpu: " + str(hpu2kernel4xi ['CALLBACK']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print) 
        # 
        
        return hpu2kernel4xi ['CALLBACK']      
        
    except:
        message2print = "{(Step 2Z1/70) failed" + "; callback2program-failed-by-set2kernelcallback4hpu: " + str(callback2program) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         

        message2print = "{(Step 2Z2/70) returning" + "; trace2kernel4hpu-returning-by-set2kernelcallback4hpu: " + str(trace2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)      
            
        return trace2kernel4hpu
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2task4hpu" usage = "
#
#   try:                               
#       response4execute2task = execute2task4hpu(task4execute2task)
#       print('(Step 99B/700) OF HPU2KERNEL4XI5TEST - BUILT PROGRAM OF HPU DEVICE ', time4xi())
#   except:
#       print('(Step 99Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO EXECUTE PROGRAM OF HPU DEVICE ', time4xi())  
#                 
#">

# -------------------------------------------------------------------------------------------------   
def execute2task4hpu(task4execute2hpu=None):

    '''
    executes  program to HPU 
    '''
    global hpu2execute4xi
    global folder2lib4hpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2task4hpu"
    method2print = "execute2task4hpu" 

    message2print = "{(Step 1A/33) started" + "; execute2task4hpu-started: " + str(execute2task4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # execute2task4hpu-started
    
    
    message2print = "{(Step 1B/33) passed" + "; task4execute2hpu-to-execute2task4hpu: " + str(task4execute2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
             
    code2ack  = ' '
    code2nack = ' '

    message2print = "{(Step 1A/70) try" + "; execute-try-by-execute2task4hpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    try:             
        if task4execute2hpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - EXECUTE TASK TO HPU! 
            # -----------------------------------------------------------------------------------------    
            task4execute2hpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4execute2hpu-initialized-by-execute2task4hpu: " + str(task4execute2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 
            
            # ---------------------------------------------------------------------------------------------
            # (1) KERNEL REQUIRED                         
            # ---------------------------------------------------------------------------------------------    
            program2hpu = {}
            message2print = "{(Step 1A/70) trying" + "; program2hpu-trying-by-create2kernel4hpu: " + str(program2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                program2hpu = create2kernel4hpu()                                                                     
                
                message2print = "{(Step 1B/70) got" + "; program2hpu-got-by-create2kernel4hpu: " + str(program2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                #                 
                code2ack  = code2ack + '1B-'         
            except:
                message2print = "{(Step 1Z/70) failed" + "; program2hpu-failed-by-create2kernel4hpu: " + str(program2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '1Z-'
                
            task4execute2hpu ['PROGRAM'] = program2hpu
            
            # ---------------------------------------------------------------------------------------------
            # (2) OPTIONS - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            task4execute2task  ['OPTIONS'] = {}
          
            
            # ---------------------------------------------------------------------------------------------
            # (3) CALLBACK - REQUIRED                         
            # --------------------------------------------------------------------------------------------- 
            function2callback4hpu = trace2kernel4hpu                                                               # CALLBACK FUNCTION FOR HPU
            
            message2print = "{(Step 3A/70) initialized" + "; function2callback4hpu-created-by-execute2task4hpu: " + str(function2callback4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 
            
            code2ack  = code2ack + '3A-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "execute2task4hpu"                                                            # MODULE OF HPUIZED OPENCL MODULE
            args2callback['METHOD']  = "execute2task4hpu"                                                            # FUNCTION OF HPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 3Z1/33) failed" + "; execute2task4hpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR HPUIZED OPENCL TO RETURN    

            message2print = "{(Step 3B/70) initialized" + "; args2callback-created-by-execute2task4hpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # 

            code2ack  = code2ack + '3B-'
            
           
            task4execute2hpu['DATA2CALLBACK'] = args2callback                                                       # USER DATA PASSED TO HPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4execute2hpu['FUNCTION2CALLBACK'] = function2callback4hpu                                           # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '3C-'

            
            # ---------------------------------------------------------------------------------------------
            # (4) USERDATA - REQUIRED                         
            # ---------------------------------------------------------------------------------------------
            task4execute2hpu['USERDATA'] = None 
            
            message2print = "{(Step 4A/70) initialized" + "; task4execute2hpu-created-by-execute2task4hpu: " + str(task4execute2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            #
        else:
            pass                                                                  
    except:
        message2print = "{(Step 1Z1/70) yielded" + "; task4execute2hpu-yielded-by-execute2task4hpu: " + str(task4execute2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-'  
                                                                                                 
    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4execute2hpu.keys()        
    message2print = "{(Step 9/70) using" + "; keys2task-using-by-execute2task4hpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    # 
  
    # ---------------------------------------------------------------------------------------------
    # (Step 10A/70) - CREATE EXECUTE FOR HPU ! 
    # ---------------------------------------------------------------------------------------------    
    hpu2execute4xi = {}                                                                                                                                                                               
    message2print = "{(Step 10A/70) initialized" + "; hpu2execute4xi-initialized-by-execute2task4hpu to: " + str(hpu2execute4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    message2print = "{(Step 11A0/70) try" + "; program-try-by-execute2task4hpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 11A/70) - PROGRAM - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        hpu2execute4xi['PROGRAM'] = task4execute2hpu['PROGRAM']
        
        message2print = "{(Step 11A1/70) initialized" + "; program-created-by-execute2task4hpu: " + str(hpu2execute4xi['PROGRAM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '11A1-'
    except: 
        message2print = "{(Step 11Z1/70) yielded" + "; program-hpu2execute4xi-yielded-by-execute2task4hpu: " + str(hpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '11Z1-' 
           
    message2print = "{(Step 12A0/70) try" + "; options-try-by-execute2task4hpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 12A/70) - OPTIONS - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        hpu2execute4xi['OPTIONS'] = task4execute2hpu['OPTIONS']
        
        message2print = "{(Step 12A1/70) initialized" + "; options-created-by-execute2task4hpu: " + str(hpu2execute4xi['OPTIONS'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '12A1-'
    except: 
        message2print = "{(Step 12Z1/70) yielded" + "; options-hpu2execute4xi-yielded-by-execute2task4hpu: " + str(hpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '12Z1-' 
        
    message2print = "{(Step 13A0/70) try" + "; callback-try-by-execute2task4hpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 13A/70) - CALLBACK - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        hpu2execute4xi['CALLBACK'] = task4execute2hpu['CALLBACK']
        
        message2print = "{(Step 13A1/70) initialized" + "; callback-created-by-execute2task4hpu: " + str(hpu2execute4xi['CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '13A1-'
    except: 
        message2print = "{(Step 13Z1/70) yielded" + "; callback-hpu2execute4xi-yielded-by-execute2task4hpu: " + str(hpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '13Z1-' 
        
    message2print = "{(Step 14A0/70) try" + "; userdata-try-by-execute2task4hpu: {}" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 14A/70) - USERDATA - REQUIRED 
        # -----------------------------------------------------------------------------------------               
        hpu2execute4xi['USERDATA'] = task4execute2hpu['USERDATA']
        
        message2print = "{(Step 14A1/70) initialized" + "; userdata-created-by-execute2task4hpu: " + str(hpu2execute4xi['USERDATA'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '14A1-'
    except: 
        message2print = "{(Step 14Z1/70) yielded" + "; userdata-hpu2execute4xi-yielded-by-execute2task4hpu: " + str(hpu2execute4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '14Z1-'
                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2execute4xi ['ACK2RETURN']  = code2ack
    hpu2execute4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; hpu2execute4xi-returning-by-execute2task4hpu: " + str(hpu2execute4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # 
    
    return hpu2execute4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernel4hpu" usage = "
#     
#   print('(Step 2A1/700) OF HPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR HPU ', time4xi())       
#   try:
#       response4create2kernel = create2kernel4hpu()
#   except:
#       print('(Step 2Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR HPU *** ', time4xi())
#          
#">

# -------------------------------------------------------------------------------------------------   
def create2kernel4hpu(task4kernel2hpu=None):

    '''
    creates kernel for HPU
    '''
    global hpu2kernel4xi                                                                                            # Kernel of HPU    
    global folder2lib4hpu  
    global kb2kernel4hpu                                                                                            # Knowledgebase for kernel      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernel4hpu" 
    method2print = "create2kernel4hpu"

    message2print = "{(Step 1A/70) started" + "; create2kernel4hpu-started: " + str(create2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function create2kernel4hpu at 0x0000000003AAD8C8> 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2hpu-to-create2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    #1: None
    #2: 
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    hpu2kernel4xi = {}                                                                                              # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernel2hpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER FOR CREATION - BUILD TASK TO HPU! 
            # -----------------------------------------------------------------------------------------    
            
            task4kernel2hpu = {}                                                                                                                                                                                       
            
            message2print = "{(Step 1C/70) initialized" + "; task4kernel2hpu-created-by-create2kernel4hpu: " + str(task4kernel2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {}
            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - EXTRA                 
            # ---------------------------------------------------------------------------------------------
                        
            function2callback4hpu = trace2kernel4hpu                                                                # CALLBACK FUNCTION FOR HPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4hpu-created-by-create2kernel4hpu: " + str(function2callback4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4hpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4hpu"                                                          # MODULE OF HPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4hpu"                                                          # FUNCTION OF HPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4hpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR HPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4hpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4hpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4hpu',
            #  'METHOD': 'create2kernel4hpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2hpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO HPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2hpu['FUNCTION2CALLBACK'] = function2callback4hpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2hpu-created-by-create2kernel4hpu: " + str(task4kernel2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4hpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4hpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4hpu',
            #  'METHOD': 'create2kernel4hpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}


            
            # ---------------------------------------------------------------------------------------------
            # (2) PLATFORM - EXTRA                      
            # ---------------------------------------------------------------------------------------------             
            platform2xi = {}
            message2print = "{(Step 2A/70) initialized" + "; platform2xi-created-by-create2kernel4hpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            try:
                platform2xi = get2platformids4xi()                                                                  # PLATFORM IS COMMON TO ALL DEVICES I.E TO DEVICE XI
                message2print = "{(Step 2B/70) got" + "; platform2xi-got-by-create2kernel4hpu: " + str(platform2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 03:33:11 12/06/11 Pacific Standard Time}
                 
                code2ack  = code2ack + '2B-'
            except:
                message2print = "{(Step 2Z/70) failed" + "; platform2xi-failed-by-create2kernel4hpu: " + str(failed)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                                
                code2nack  = code2nack + '2Z-'
                 
            task4kernel2hpu['PLATFORM'] = platform2xi                                                               # PLATFORM OF SYSTEM 
              
            
            # ---------------------------------------------------------------------------------------------
            # (3) CONTEXT - EXTRA                   
            # ---------------------------------------------------------------------------------------------    
            context2hpu = {}
            message2print = "{(Step 3A/70) trying" + "; context2hpu-trying-by-create2kernel4hpu: " + str(context2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                context2hpu = get2context4hpu()                                                                     # NO PARAMETERS - THE SYSTEM CREATES CONTEXT IF REQUIRED  
                
                message2print = "{(Step 3B/70) got" + "; context2hpu-got-by-create2kernel4hpu: " + str(context2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK': ...
                
                code2ack  = code2ack + '3B-'         
            except:
                message2print = "{(Step 3Z/70) failed" + "; context2hpu-failed-by-create2kernel4hpu: " + str(context2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '3Z-'
                
            task4kernel2hpu ['CONTEXT'] = context2hpu           
            
            # ---------------------------------------------------------------------------------------------
            # (4) DEVICE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------    
            device2hpu = {}
            
            message2print = "{(Step 4A/70) trying" + "; device2hpu-trying-by-create2kernel4hpu: " + str(device2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            try:
                device2hpu = get2hpu4xi()                                                                           # THE SYSTEM CREATES DEVICE INFO, IF NECESSARY    
                
                message2print = "{(Step 4B/70) got" + "; device2hpu-got-by-create2kernel4hpu: " + str(device2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
                
                code2ack  = code2ack + '4B-'  
            except:
                message2print = "{(Step 4Z/70) failed" + "; device2hpu-failed-by-create2kernel4hpu: " + str(device2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '4Z-'
                
            task4kernel2hpu ['DEVICE'] = device2hpu
            
                   
            # ---------------------------------------------------------------------------------------------
            # (5) ERROR CODE - REQUIRED                            
            # ---------------------------------------------------------------------------------------------         
            task4kernel2hpu ['CODE2ERROR'] = 0             
            code2ack  = code2ack + '5B-'              

            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - EXTRA                          
            # ---------------------------------------------------------------------------------------------         
            queue2hpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2hpu-trying-by-create2kernel4hpu: " + str(queue2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2hpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2hpu-got-by-create2kernel4hpu: " + str(queue2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2hpu-failed-by-create2kernel4hpu: " + str(queue2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2hpu ['QUEUE'] = queue2hpu

            
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - EXTRA                              
            # ---------------------------------------------------------------------------------------------         
            pipe2hpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2hpu-trying-by-create2kernel4hpu: " + str(pipe2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2hpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2hpu-got-by-create2kernel4hpu: " + str(pipe2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2hpu-failed-by-create2kernel4hpu: " + str(pipe2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2hpu ['PIPE'] = pipe2hpu 
            
            # ---------------------------------------------------------------------------------------------
            # (8) COMMAND QUEUE INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            commandqueueinfo2hpu = {}
           
            message2print = "{(Step 8A/70) trying" + "; commandqueueinfo2hpu-trying-by-create2kernel4hpu: " + str(commandqueueinfo2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
                        
            try:
                commandqueueinfo2hpu = get2commandqueueinfo4hpu()                                                   # SYSTEM CREATES COMMAND QUEUE, IF NECESSARY   
                message2print = "{(Step 8B/70) got" + "; commandqueueinfo2hpu-got-by-create2kernel4hpu: " + str(commandqueueinfo2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '8B-'  
            except:
                message2print = "{(Step 8Z/70) failed" + "; commandqueueinfo2hpu-failed-by-create2kernel4hpu: " + str(commandqueueinfo2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '8Z-'
        
            task4kernel2hpu ['COMMANDQUEUE'] = commandqueueinfo2hpu
            
            
            
            # ---------------------------------------------------------------------------------------------
            # (9) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            bufferinfo2hpu = {}
           
            message2print = "{(Step 9A/70) trying" + "; bufferinfo2hpu-trying-by-create2kernel4hpu: " + str(bufferinfo2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                bufferinfo2hpu = get2bufferinfo4hpu()                                                               # SYSTEM CREATES BUFFER FOR HPU, IF NECESSARY
                message2print = "{(Step 9B/70) got" + "; bufferinfo2hpu-got-by-create2kernel4hpu: " + str(bufferinfo2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                
                code2ack  = code2ack + '9B-' 
            except:
                message2print = "{(Step 9Z/70) failed" + "; bufferinfo2hpu-failed-by-create2kernel4hpu: " + str(bufferinfo2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '9Z-'
        
            task4kernel2hpu ['BUFFER'] = bufferinfo2hpu 
            
            # ---------------------------------------------------------------------------------------------
            # (10) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
            eventinfo2hpu = {}
           
            message2print = "{(Step 10A/70) trying" + "; eventinfo2hpu-trying-by-create2kernel4hpu: " + str(eventinfo2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
                        
            try:
                eventinfo2hpu = get2eventinfo4hpu()                                                                 # SYSTEM CREATES EVENT IF NECESSAY   
                message2print = "{(Step 10B/70) got" + "; eventinfo2hpu-got-by-create2kernel4hpu: " + str(eventinfo2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # {'CODE2ERROR': 0, 'DATA2CALLBACK': ... 
                
                code2ack  = code2ack + '10B-' 
            except:
                message2print = "{(Step 10Z/70) failed" + "; eventinfo2hpu-failed-by-create2kernel4hpu: " + str(eventinfo2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '10Z-'
        
            task4kernel2hpu ['EVENT'] = eventinfo2hpu             

            
            task4kernel2hpu ['CODE4PY']       = {}                                                                  
            task4kernel2hpu ['CODE4CPP']      = {}                                                                  
            task4kernel2hpu ['CODE4C']        = {} 
            task4kernel2hpu ['CODE4CL']       = {} 
                       
            task4kernel2hpu ['CODE4PYC']      = {}                                                                  
            task4kernel2hpu ['CODE4BIN']      = {}
 
            task4kernel2hpu ['DIRECTORY4PY']  = {}                                                                  
            task4kernel2hpu ['DIRECTORY4CPP'] = {}
            task4kernel2hpu ['DIRECTORY4C']   = {}
            task4kernel2hpu ['DIRECTORY4CL']  = {}
                                                                                                       
            task4kernel2hpu ['DIRECTORY4PYC'] = {}                                                                  
            task4kernel2hpu ['DIRECTORY4BIN'] = {}                                                                  
                                               
            # ---------------------------------------------------------------------------------------------
            # (12A0) DIRECTORY4PY - PYTHON                 
            # ---------------------------------------------------------------------------------------------             
            dir2py4hpu = folder2lib4hpu                                                                                                                                                            
            message2print = "{(Step 12A0/70) set" + "; dir2py4hpu-set-by-create2kernel4hpu to: " + str(dir2py4hpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu 
            code2ack  = code2ack + '12A0-' 
        
            task4kernel2hpu ['DIRECTORY4PY'] = dir2py4hpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A0) CODE4PY - PYTHON         
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A0/70) using" + "; DirectoryWalker-using-by-create2kernel4hpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2py4hpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B0/70) examining" + "; directory-examining-by-create2kernel4hpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C0/70) examining" + "; file-examining-by-create2kernel4hpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4hpu + hpu2sampler4xi5test.py; hpu2dummy4xi5test.cpp 
                    
                    message2print = "{(Step 14D0/70) calling" + "; fetch2kernel4hpu-calling-by-create2kernel4hpu: " + str(fetch2kernel4hpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4hpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E0/70) passing" + "; file2walk-passing-to-fetch2kernel4hpu-by-create2kernel4hpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4hpu + hpu2sampler4xi5test.py; hpu2dummy4xi5test.cpp 
                    
                    fetch2kernel4hpu(file2walk)                                                                     # FETCHES KERNEL FILES INTO FETCH2CODE4HPU DICTIONARY 
                    
                    message2print = "{(Step 14E0/70) performed" + "; fetch2kernel4hpu-performed-by-create2kernel4hpu: " + str(fetch2kernel4hpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4hpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14F0/70) got" + "; fetch2code4hpu-got-by-create2kernel4hpu: " + str(fetch2code4hpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # ...  {1: '...profile = "11" />\n', 2: '# --
            
            
                     
            keys2explore4hpu = fetch2code4hpu.keys()
            message2print = "{(Step 14G0/70) using" + "; keys2explore4hpu-using-by-create2kernel4hpu: " + str(keys2explore4hpu) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # folder2lib4hpu + hpu2sampler4xi5test.py; hpu2dummy4xi5test.cpp
            
            for key2explore4hpu in keys2explore4hpu:
                name2program4hpu=os.path.splitext(key2explore4hpu)                                                  # hpu2sampler4xi5test + py
                key2extension4hpu = name2program4hpu[1]                                                              
                if key2extension4hpu == '.py':                          
                    task4kernel2hpu ['CODE4PY'] [key2explore4hpu] = fetch2code4hpu[key2explore4hpu]                 # Python code(s)      

            # ---------------------------------------------------------------------------------------------
            # (14H0) SIZE4PY - PYTHON SOURCE            
            # ---------------------------------------------------------------------------------------------                                                
            size2py4hpu  = {}
            keys2py4hpu = fetch2code4hpu.keys()                                                                     # hpu2sampler4xi5test.py
            for key2py4hpu in keys2py4hpu:
                name2program4hpu=os.path.splitext(key2py4hpu)                                                       # hpu2sampler4xi5test + py
                key2extension4hpu = name2program4hpu[1]                                                             # py   
                if key2extension4hpu == '.py':                          
                    size2py4hpu[key2py4hpu] = len(fetch2code4hpu[key2py4hpu])                                       # length of saved py code 

            task4kernel2hpu ['SIZE4PY'] = size2py4hpu
                               
            message2print = "{(Step 14H0/70) set" + "; size2py4hpu-set-by-create2kernel4hpu to: " + str(size2py4hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {folder2lib4hpu + hpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '14H1-' 
            

            # ---------------------------------------------------------------------------------------------
            # (12A1) C, C++, CL SOURCE                   
            # ---------------------------------------------------------------------------------------------             
            dir2c4hpu = folder2lib4hpu                                                                                                                                                            
            message2print = "{(Step 12A1/70) set" + "; dir2c4hpu-set-by-create2kernel4hpu to: " + str(dir2c4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # folder2lib4hpu 
            code2ack  = code2ack + '12A1-' 
        
            task4kernel2hpu ['DIRECTORY4CPP']  = dir2c4hpu
            task4kernel2hpu ['DIRECTORY4C']    = dir2c4hpu
            task4kernel2hpu ['DIRECTORY4CLPP'] = dir2c4hpu
            task4kernel2hpu ['CODE4CPP'] = {} 
            task4kernel2hpu ['CODE4C']   = {} 
            task4kernel2hpu ['CODE4CL']  = {}            
            
            # ---------------------------------------------------------------------------------------------
            # (14A1) C, C++, CL SOURCE   
            # ---------------------------------------------------------------------------------------------             
            keys2c4hpu = fetch2code4hpu.keys()
            for key2c4hpu in keys2c4hpu:
                name2c4hpu=os.path.splitext(key2c4hpu)                                                  
                key2extension4hpu = name2c4hpu[1]                                                             # C++, C, CL 
                if key2extension4hpu == '.cpp':                          
                    task4kernel2hpu ['CODE4CPP'] [key2c4hpu] = fetch2code4hpu[key2c4hpu]                     
                    message2print = "{(Step 14G1/70) set" + "; key2c4hpu-set-by-create2kernel4hpu to: " + str(key2c4hpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4hpu + hpu2dummy4xi5test.cpp
                if key2extension4hpu == '.c':                          
                    task4kernel2hpu ['CODE4C'] [key2c4hpu] = fetch2code4hpu[key2c4hpu]                     
                    message2print = "{(Step 14G2/70) set" + "; key2c4hpu-set-by-create2kernel4hpu to: " + str(key2c4hpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4hpu +
                if key2extension4hpu == '.cl':                          
                    task4kernel2hpu ['CODE4CL'] [key2c4hpu] = fetch2code4hpu[key2c4hpu]                     
                    message2print = "{(Step 14G3/70) set" + "; key2c4hpu-set-by-create2kernel4hpu to: " + str(key2c4hpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4hpu + 
                                                                
            # ----------------------------------------------------------------------------------------------
            # (14H1) SIZE4C - C C++ CL SOURCE HAS THE SAME FOLDER AS FOR PYTHON SOURCE - ALREADY FETCHED           
            # ----------------------------------------------------------------------------------------------                                                
            size2c4hpu  = {}
            keys2c4hpu = fetch2code4hpu.keys()                                                                # 
            for key2c4hpu in keys2c4hpu:
                name2program4hpu=os.path.splitext(key2c4hpu)                                                  # 
                key2extension4hpu = name2program4hpu[1]                                                       #    
                if key2extension4hpu == '.cpp':                          
                    size2c4hpu[key2c4hpu] = len(fetch2code4hpu[key2c4hpu])                                    # length of saved C++ code
                    task4kernel2hpu ['SIZE4CPP'] = size2c4hpu 
                if key2extension4hpu == '.c':                          
                    size2c4hpu[key2c4hpu] = len(fetch2code4hpu[key2c4hpu])                                    # length of saved C code
                    task4kernel2hpu ['SIZE4C'] = size2c4hpu
                if key2extension4hpu == '.cl':                          
                    size2c4hpu[key2c4hpu] = len(fetch2code4hpu[key2c4hpu])                                    # length of saved CL code
                    task4kernel2hpu ['SIZE4CL'] = size2c4hpu 
                                       
            
                               
            message2print = "{(Step 14H1/70) set" + "; size2c4hpu-set-by-create2kernel4hpu to: " + str(size2c4hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu + hpu2dummy4xi5test.cpp': 331}
            code2ack  = code2ack + '14H1-' 
            
                                                  
            # ---------------------------------------------------------------------------------------------
            # (12B2) DIRECTORY FOR PYTHON CACHE - REQUIRED                      
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4hpu = folder2lib4hpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 12B2/70) set" + "; dir2pycache4hpu-set-by-create2kernel4hpu to: " + str(dir2pycache4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu + '__pycache__//'
            code2ack  = code2ack + '12B2-' 
        
            task4kernel2hpu ['DIRECTORY4PYC'] = dir2pycache4hpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A2) CODE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A2/70) using" + "; DirectoryWalker-using-by-create2kernel4hpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2pycache4hpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B2/70) examining" + "; directory-examining-by-create2kernel4hpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C2/70) examining" + "; file-examining-by-create2kernel4hpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4hpu + __pycache__//hpu2sampler4xi5test.cpython-33.pyc
                    
                    message2print = "{(Step 14D2/70) calling" + "; fetch2kernel4hpu-calling-by-create2kernel4hpu: " + str(fetch2kernel4hpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4hpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E2/70) passing" + "; file2walk-passing-to-fetch2kernel4hpu-by-create2kernel4hpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    #folder2lib4hpu + __pycache__//hpu2sampler4xi5test.cpython-33.pyc
                    
                    fetch2kernel4hpu(file2walk)                                                                     # fetches kernel files into fetch2code4hpu dictionary 
                    
                    message2print = "{(Step 14F2/70) performed" + "; fetch2kernel4hpu-performed-by-create2kernel4hpu: " + str(fetch2kernel4hpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4hpu at 0x0000000003AADB48>
                    
                    # message2print = "{(Step 14G2/70) got" + "; fetch2code4hpu-got-by-create2kernel4hpu: " + str(fetch2code4hpu) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)                                      
                    # 
            
            task4kernel2hpu ['CODE4PYC'] = {}
            keys2pyc4hpu = fetch2code4hpu.keys()
            for key2pyc4hpu in keys2pyc4hpu:
                name2program4hpu=os.path.splitext(key2pyc4hpu)                                                      # hpu2sampler4xi5test.cpython-33.pyc
                key2extension4hpu = name2program4hpu[1]                                                             # pyc 
   
                if key2extension4hpu == '.pyc':                          
                    task4kernel2hpu ['CODE4PYC'] [key2pyc4hpu] = fetch2code4hpu[key2pyc4hpu]                        # binary code(s)
                    message2print = "{(Step 14H2/70) set" + "; key2pyc4hpu-set-by-create2kernel4hpu to: " + str(key2pyc4hpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    #    
                                     
            size2pyc4hpu  = {}

            for key2pyc4hpu in keys2pyc4hpu:
                name2program4hpu=os.path.splitext(key2pyc4hpu)                                                      # hpu2sampler4xi5test.cpython-32 + pyc
                key2extension4hpu = name2program4hpu[1]                                                             # pyc 
                if key2extension4hpu == '.pyc':                          
                    size2pyc4hpu[key2pyc4hpu] = len(fetch2code4hpu[key2pyc4hpu])                                    # length of saved binary code
                    message2print = "{(Step 14I2/70) set" + "; key2pyc4hpu-set-by-create2kernel4hpu to: " + str(key2pyc4hpu)  + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)  
                    # 
                                              
            # ---------------------------------------------------------------------------------------------
            # (14I2) SIZE4PYC - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2hpu ['SIZE4PYC'] = size2pyc4hpu
                               
            message2print = "{(Step 14J2/70) set" + "; size2pyc4hpu-set-by-create2kernel4hpu to: " + str(size2pyc4hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 
            code2ack  = code2ack + '14J2-' 

                                               
            # ---------------------------------------------------------------------------------------------
            # (12A3) DIRECTORY FOR C++, C, CL BIN - REQUIRED                    
            # ---------------------------------------------------------------------------------------------             
            dir2bin4hpu = folder2lib4hpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4hpu-set-by-create2kernel4hpu to: " + str(dir2bin4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2hpu ['DIRECTORY4BIN'] = dir2bin4hpu
            
                        
            # ---------------------------------------------------------------------------------------------
            # (14A3) CODE4BIN FOR C++, C, CL - REQUIRED              
            # ---------------------------------------------------------------------------------------------             
            message2print = "{(Step 14A3/70) using" + "; DirectoryWalker-using-by-create2kernel4hpu: " + str(DirectoryWalker)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            
            for file2walk in DirectoryWalker(dir2bin4hpu):
                if os.path.isdir(file2walk):
                    message2print = "{(Step 14B3/70) examining" + "; directory-examining-by-create2kernel4hpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                      
                if os.path.isfile(file2walk):
                    message2print = "{(Step 14C3/70) examining" + "; file-examining-by-create2kernel4hpu: " + str(file2walk)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    #folder2lib4hpu + bin//hpu2dummy4xi5test.exe
                    
                    message2print = "{(Step 14D3/70) calling" + "; fetch2kernel4hpu-calling-by-create2kernel4hpu: " + str(fetch2kernel4hpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # <function fetch2kernel4hpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14E3/70) passing" + "; file2walk-passing-to-fetch2kernel4hpu-by-create2kernel4hpu: " + str(file2walk) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)  
                    # folder2lib4hpu + bin//hpu2dummy4xi5test.exe
                    
                    fetch2kernel4hpu(file2walk)                                                                     # fetches kernel files into fetch2code4hpu dictionary 
                    
                    message2print = "{(Step 14E3/70) performed" + "; fetch2kernel4hpu-performed-by-create2kernel4hpu: " + str(fetch2kernel4hpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # <function fetch2kernel4hpu at 0x0000000003AADB48>
                    
                    message2print = "{(Step 14F3/70) got" + "; fetch2code4hpu-got-by-create2kernel4hpu: " + str(fetch2code4hpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                                      
                    # 

            task4kernel2hpu ['CODE4BIN'] = {}
            
            keys2bin4hpu = fetch2code4hpu.keys()
            message2print = "{(Step 14G3/70) using" + "; keys2bin4hpu-using-by-create2kernel4hpu: " + str(keys2bin4hpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4hpu + 'hpu2dummy4xi5test.cpp', 'hpu2sampler4xi5test.py']
            
            for key2bin4hpu in keys2bin4hpu:
                name2program4hpu=os.path.splitext(key2bin4hpu)                                                      # hpu2dummy4xi5test.exe
                key2extension4hpu = name2program4hpu[1]                                                             # bin 
   
                if key2extension4hpu == '.exe':                          
                    task4kernel2hpu ['CODE4BIN'] [key2bin4hpu] = fetch2code4hpu[key2bin4hpu]                        # binary code(s)   
                                        
            size2bin4hpu  = {}
            keys2bin4hpu = fetch2code4hpu.keys()                                                                    # hpu2dummy4xi5test.exe
            for key2bin4hpu in keys2bin4hpu:
                name2program4hpu=os.path.splitext(key2bin4hpu)                                                      # hpu2sampler4xi5test.cpython-32 + bin
                key2extension4hpu = name2program4hpu[1]                                                             # bin 
                if key2extension4hpu == '.exe':                          
                    size2bin4hpu[key2bin4hpu] = len(fetch2code4hpu[key2bin4hpu])                                    # length of saved binary code
                        
            # ---------------------------------------------------------------------------------------------
            # (14H3) SIZE4BIN - REQUIRED              
            # ---------------------------------------------------------------------------------------------          
            task4kernel2hpu ['SIZE4BIN'] = size2bin4hpu
                               
            message2print = "{(Step 14H3/70) set" + "; size2bin4hpu-set-by-create2kernel4hpu to: " + str(size2bin4hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # {}
            code2ack  = code2ack + '14H3-' 

            # ---------------------------------------------------------------------------------------------
            # (14J) COUNT4PY, COUNT4C,COUNT4PYC,COUNT4BIN                
            # ---------------------------------------------------------------------------------------------             
            task4kernel2hpu ['COUNT4PY']     = 0
            task4kernel2hpu ['COUNT4CPP']    = 0
            task4kernel2hpu ['COUNT4C']      = 0
            task4kernel2hpu ['COUNT4CL']     = 0
            task4kernel2hpu ['COUNT4PYC']    = 0
            task4kernel2hpu ['COUNT4BIN']    = 0

            keys2code4hpu = fetch2code4hpu.keys()
            message2print = "{(Step 14J/70) using" + "; keys2code4hpu-using-by-create2kernel4hpu: " + str(keys2code4hpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # [folder2lib4hpu + 'hpu2dummy4xi5test.cpp', folder2lib4hpu + 'hpu2sampler4xi5test.py']

            
            for key2code4hpu in keys2code4hpu:
                name2program4hpu=os.path.splitext(key2code4hpu)                                                    
                key2extension4hpu = name2program4hpu[1]                                                             
                if key2extension4hpu == '.py':                          
                    task4kernel2hpu ['COUNT4PY']     = task4kernel2hpu ['COUNT4PY']  + 1 
                if key2extension4hpu == '.cpp':                          
                    task4kernel2hpu ['COUNT4CPP']    = task4kernel2hpu ['COUNT4CPP'] + 1                                            
                if key2extension4hpu == '.c':                          
                    task4kernel2hpu ['COUNT4C']      = task4kernel2hpu ['COUNT4C']   + 1              
                if key2extension4hpu == '.cl':                          
                    task4kernel2hpu ['COUNT4CL']     = task4kernel2hpu ['COUNT4CL']  + 1                                  
                if key2extension4hpu == '.pyc':                          
                    task4kernel2hpu ['COUNT4PYC']    = task4kernel2hpu ['COUNT4PYC'] + 1                            
                if key2extension4hpu == '.exe':                          
                    task4kernel2hpu ['COUNT4BIN']    = task4kernel2hpu ['COUNT4BIN'] + 1                                                                                 
            
            message2print = "{(Step 14K/70) set" + "; count4py-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['COUNT4PY'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            
            message2print = "{(Step 14L/70) set" + "; count4cpp-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['COUNT4CPP'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 1
            message2print = "{(Step 14M/70) set" + "; count4c-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['COUNT4C'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0 
            message2print = "{(Step 14N/70) set" + "; count4cl-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['COUNT4CL'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                         
            
            message2print = "{(Step 14M/70) set" + "; count4pyc-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['COUNT4PYC'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0
            
            message2print = "{(Step 14N/70) set" + "; count4bin-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['COUNT4BIN'])  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # 0                                                
            code2ack  = code2ack + '14N-'
            
            # ---------------------------------------------------------------------------------------------
            # (15) LANGUAGE - EXTRA                             
            # ---------------------------------------------------------------------------------------------             
            task4kernel2hpu ['LANGUAGE'] = {}
            
            for key2code4hpu in keys2code4hpu:
                name2program4hpu=os.path.splitext(key2code4hpu)                                                     
                key2extension4hpu = name2program4hpu[1]                                                             
                if key2extension4hpu == '.py':                          
                    task4kernel2hpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4hpu == '.cpp':                          
                    task4kernel2hpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4hpu == '.c':                          
                    task4kernel2hpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4hpu == '.cl':                          
                    task4kernel2hpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '15B-' 
                      
            # ---------------------------------------------------------------------------------------------
            # (16) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            count2reference2hpu  = 1
           
            message2print = "{(Step 16B/70) set" + "; count2reference2hpu-set-by-create2kernel4hpu to: " + str(count2reference2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '16B-' 
        
            task4kernel2hpu ['COUNT2REFERENCE'] = count2reference2hpu                                 
                                    
            # ---------------------------------------------------------------------------------------------
            # (17) PROGRAM - REQUIRED                           
            # ---------------------------------------------------------------------------------------------             
            task4kernel2hpu ['PROGRAM'] = None
            message2print = "{(Step 17A/70) try" + "; program2hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2hpu ['PROGRAM'] = create2programwithsource4hpu()
                keys2program = task4kernel2hpu ['PROGRAM'].keys()
                
                message2print = "{(Step 17B/70) set" + "; program-set-by-create2kernel4hpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'COUNT2REFERENCE', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '17B-'
            except:
                message2print = "{(Step 17Z1/70) failed" + "; task4kernel2hpu-failed-by-create2kernel4hpu: " + str(task4kernel2hpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '17Z-'
                                    
            # ---------------------------------------------------------------------------------------------
            # (18) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2hpu ['FUNCTION'] = {}
            message2print = "{(Step 18A0/70) set" + "; function4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2hpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 18A1/70) set" + "; pythonfunction4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4hpu  = kb2kernel4hpu ['.py'] ['TAG']
            message2print = "{(Step 18A2/70) using" + "; tag2search4hpu-using-by-create2kernel4hpu: " + str(tag2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4hpu    = kb2kernel4hpu ['.py'] ['VALUE']
            message2print = "{(Step 18A3/70) using" + "; value2search4hpu-using-by-create2kernel4hpu: " + str(value2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # hpu2sampler4xi5test
            
            attribute2search4hpu= kb2kernel4hpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 18A4/70) using" + "; attribute2search4hpu-using-by-create2kernel4hpu: " + str(attribute2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4hpu in keys2code4hpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu]
                    keys2line4hpu = code2examine4hpu.keys()
                    for key2line4hpu in keys2line4hpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu] [key2line4hpu]
                        # message2print = "{(Step 18A5/70) examining" + "; line2examine4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4hpu,tag2search4hpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 18B/70) examining" + "; line2function4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # <... hpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4hpu,value2search4hpu)
                            if index2function == -1:
                                message2print = "{(Step 18C/70) skipped" + "; line2function4hpu-skipped-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # <... set2trace4sampler" ... # ...function = "hpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4hpu,attribute2search4hpu)             # ...function = "hpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 18D/70) warning" + "; line2function4hpu-warning-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 18E/70) accepted" + "; line2examine4hpu-accepted-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ...function = "hpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4hpu = line2examine4hpu[index2function:index2usage-2]
                                    
                                    task4kernel2hpu ['FUNCTION'] ['.py'] [key2pythonfunction4hpu] = {}                                  

                                    message2print = "{(Step 18F/70) used" + "; key2pythonfunction4hpu-used-by-create2kernel4hpu: " + str(key2pythonfunction4hpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # hpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '18F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 18Z1/70) failed" + "; task4kernel2hpu-failed-by-create2kernel4hpu: " + str(task4kernel2hpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '18Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (19) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2hpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 19A0F/70) set" + "; cplusfunction4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4hpu      = kb2kernel4hpu ['.cpp'] ['TAG']
            message2print = "{(Step 19A2/70) using" + "; tag2search4hpu-using-by-create2kernel4hpu: " + str(tag2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <...            
            attribute2search4hpu= kb2kernel4hpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 19A4/70) using" + "; attribute2search4hpu-using-by-create2kernel4hpu: " + str(attribute2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4hpu in keys2code4hpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu]
                    message2print = "{(Step 19A5/70) using" + "; key2code4hpu-using-by-create2kernel4hpu: " + str(key2code4hpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # hpu2dummy4xi5test.cpp
                       
                    keys2line4hpu = code2examine4hpu.keys()
                    # message2print = "{(Step 19A6/70) using" + "; keys2line4hpu-using-by-create2kernel4hpu: " + str(keys2line4hpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4hpu in keys2line4hpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu] [key2line4hpu]
                        # message2print = "{(Step 19A7/70) examining" + "; line2examine4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # /*<... nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4hpu,tag2search4hpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 19B1/70) examining" + "; line2function4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # ... function = "OCLError" usage = "error code checking"*/
                            # ... function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 19B2/70) using" + "; attribute2search4hpu-using-by-create2kernel4hpu: " + str(attribute2search4hpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4hpu,attribute2search4hpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 19C/70) skipped" + "; line2function4hpu-skipped-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 19E/70) accepted" + "; line2examine4hpu-accepted-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # ... function = "nbody_kern" usage = "kernel example 1"*/; 
                                # ... function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4hpu = line2examine4hpu[27:index2usage-2]  
                                task4kernel2hpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4hpu] =  {}                                       

                                message2print = "{(Step 19F/70) used" + "; key2kernelfunction4hpu-used-by-create2kernel4hpu: " + str(key2kernelfunction4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '19F-'
                                    
                                    
            except:
                message2print = "{(Step 19Z1/70) failed" + "; task4kernel2hpu-failed-by-create2kernel4hpu: " + str(task4kernel2hpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #   
                #             
                code2nack  = code2nack + '19Z-'           
                                                      
            # ---------------------------------------------------------------------------------------------
            # EOF CREATING TASK4KERNEL2HPU                  
            # ---------------------------------------------------------------------------------------------                                                                                                                                                          
        else:
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernel2hpu-yielded-by-create2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '1Z1-' 

    # ---------------------------------------------------------------------------------------------
    # TASK EITHER GENERATED BY THIS PROGRAM (NONE GIVEN) OR GIVEN BY USER    
    # ---------------------------------------------------------------------------------------------
    keys2task = task4kernel2hpu.keys()        
    message2print = "{(Step 19A/70) using" + "; keys2task-using-by-create2kernel4hpu: " + str(sorted(keys2task))  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    #1 this program created:
    # ['BUFFER'  ... 'LANGUAGE', 'PIPE', 
    #  'PLATFORM', 'PROGRAM', 'QUEUE' ....']
    #2 caller passed:
    # ['FUNCTION', 'PROGRAM']
    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - CREATE PROGRAM OBJECT FOR HPU - BUILD REQUIRED ONES IF USER HAS FORGOTTEN ! 
    # ---------------------------------------------------------------------------------------------    
    hpu2kernel4xi = {}                                                                                             # CREATE INITIALIZES DICTIONARY!                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; hpu2kernel4xi-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}
    
    if (('DATA2CALLBACK' not in keys2task) or ('FUNCTION2CALLBACK' not in keys2task)):
        try:            
            # ---------------------------------------------------------------------------------------------
            # (1) CALLBACKS - REQUIRED                
            # ---------------------------------------------------------------------------------------------
                     
            function2callback4hpu = trace2kernel4hpu                                                                # CALLBACK FUNCTION FOR HPU
            
            message2print = "{(Step 1D/70) initialized" + "; function2callback4hpu-created-by-create2kernel4hpu: " + str(function2callback4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # <function trace2kernel4hpu at 0x0000000003AAD6C8> 
            
            code2ack  = code2ack + '1D-'
           
            args2callback = {}                                                                                      # CREATE ARGUMENT DICTIONARY FOR CALLBACK FUNCTION             
            args2callback['CLASS']   = "create2kernel4hpu"                                                          # MODULE OF HPUIZED OPENCL MODULE
            args2callback['METHOD']  = "create2kernel4hpu"                                                          # FUNCTION OF HPUIZED OPENCL MODULE
            args2callback['MESSAGE'] = "{(Step 1Z1/33) failed" + "; create2kernel4hpu-failed " + "; time: " + time4xi() + "}" # ERROR MESSAGE FOR HPUIZED OPENCL TO RETURN    

            message2print = "{(Step 1E/70) initialized" + "; args2callback-created-by-create2kernel4hpu: " + str(args2callback)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4hpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4hpu',
            #  'METHOD': 'create2kernel4hpu'}; time: 03:33:11 12/06/11 Pacific Standard Time}

            code2ack  = code2ack + '1E-'
              
            task4kernel2hpu['DATA2CALLBACK'] = args2callback                                                        # USER DATA PASSED TO HPUIZED OPENCL - SEVERAL ARGS PASSED IN ONE DICTIONARY
            task4kernel2hpu['FUNCTION2CALLBACK'] = function2callback4hpu                                            # CALLBACK FUNCTION TO CALLED BY OPENCL IN EXCEPTIONS
            code2ack  = code2ack + '2C-'
            message2print = "{(Step 1F/70) initialized" + "; task4kernel2hpu-created-by-create2kernel4hpu: " + str(task4kernel2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # {'FUNCTION2CALLBACK': <function trace2kernel4hpu at 0x0000000003AAD6C8>,
            #  'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4hpu-failed ; time: 03:33:11 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4hpu',
            #  'METHOD': 'create2kernel4hpu'}}; time: 03:33:11 12/06/11 Pacific Standard Time}
        except: 
            message2print = "{(Step 1Z2/70) yielded" + "; callbacks-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z2-'     
                
    if 'DATA2CALLBACK' in keys2task:
        message2print = "{(Step 21A0/70) try" + "; data2callback-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 21A/70) - DATA2CALLBACK - REQUIRED 
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['DATA2CALLBACK'] = task4kernel2hpu['DATA2CALLBACK']
            
            message2print = "{(Step 21A1/70) initialized" + "; data2callback-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'MESSAGE': '{(Step 1Z1/33) failed; create2kernel4hpu-failed ; time: 04:42:53 12/06/11 Pacific Standard Time}',
            #  'CLASS': 'create2kernel4hpu',
            #  'METHOD': 'create2kernel4hpu'}
    
            code2ack  = code2ack + '21A1-'
        except: 
            message2print = "{(Step 21Z1/70) yielded" + "; data2callback-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '21Z1-'
    
    if 'FUNCTION2CALLBACK' in keys2task:    
        message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22B/70) - FUNCTION2CALLBACK - REQUIRED
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernel2hpu['FUNCTION2CALLBACK']
            
            message2print = "{(Step 22B1/70) initialized" + "; function2callback-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function trace2kernel4hpu at 0x000000000422F6C8>
            
            code2ack  = code2ack + '22B1-'
        except: 
            message2print = "{(Step 22Z2/70) yielded" + "; function2callback-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z2-' 
        
        message2print = "{(Step 22C0/70) try" + "; platform-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #

        
    if 'PLATFORM' in keys2task:         
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 22C/70) - PLATFORM - EXTRA
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['PLATFORM'] = task4kernel2hpu['PLATFORM']
            
            message2print = "{(Step 22C1/70) initialized" + "; platform-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
    
    
            code2ack  = code2ack + '22C1-'
        except: 
            message2print = "{(Step 22Z3/70) yielded" + "; platform-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '22Z3-' 
            
    
    if 'CONTEXT' in keys2task:        
        message2print = "{(Step 23A/70) try" + "; context2hpu-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 23/70) - CONTEXT  - EXTRA
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['CONTEXT'] = task4kernel2hpu['CONTEXT']
            
            message2print = "{(Step 23B/70) initialized" + "; context-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...      
            
            code2ack  = code2ack + '23B-'
        except: 
            message2print = "{(Step 23Z1/70) yielded" + "; context-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
        
            code2nack  = code2nack + '23Z1-' 
    
    if 'DEVICE' in keys2task:        
        message2print = "{(Step 24A/70) try" + "; device-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 24/70) - DEVICE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['DEVICE'] = task4kernel2hpu['DEVICE']
            
            message2print = "{(Step 24B/70) initialized" + "; device-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #  {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568' ...
            
            code2ack  = code2ack + '24B-'
        except: 
            message2print = "{(Step 24Z1/70) yielded" + "; device-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '24Z1-'
    
    if 'CODE2ERROR' in keys2task:                     
        message2print = "{(Step 25A/70) try" + "; code2error-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 25/70) - ERROR CODE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['CODE2ERROR'] = task4kernel2hpu['CODE2ERROR']
            
            message2print = "{(Step 25B/70) initialized" + "; code2error-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0
            
            code2ack  = code2ack + '25B-'
        except: 
            message2print = "{(Step 25Z1/70) yielded" + "; code2error-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '25Z1-'
                            
    if 'QUEUE' not in keys2task: 
        try:
            # ---------------------------------------------------------------------------------------------
            # (6) QUEUE - REQUIRED                          
            # ---------------------------------------------------------------------------------------------         
            queue2hpu = None
            
            message2print = "{(Step 6A/70) trying" + "; queue2hpu-trying-by-create2kernel4hpu: " + str(queue2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                queue2hpu = Queue4Xi()                                                                              # THE SYSTEM CREATES QUEUE    
                
                message2print = "{(Step 6B/70) got" + "; queue2hpu-got-by-create2kernel4hpu: " + str(queue2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # <queue4xi.Queue4Xi object at 0x0000000003C63DD8>
                
                code2ack  = code2ack + '6B-'  
            except:
                message2print = "{(Step 6Z/70) failed" + "; queue2hpu-failed-by-create2kernel4hpu: " + str(queue2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '6Z-'
                
            task4kernel2hpu ['QUEUE'] = queue2hpu
        except:
            message2print = "{(Step 26Z1/70) yielded" + "; queue-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z1-'             

    if 'QUEUE' in keys2task:          
        message2print = "{(Step 26A/70) try" + "; queue-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 26/70) - QUEUE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['QUEUE'] = task4kernel2hpu['QUEUE']
            
            message2print = "{(Step 26B/70) initialized" + "; queue-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <queue4xi.Queue4Xi object at 0x0000000003E72828> 
            
            code2ack  = code2ack + '26B-'
        except: 
            message2print = "{(Step 26Z2/70) yielded" + "; queue-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '26Z2-' 
              
    if 'PIPE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (7) PIPE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------         
            pipe2hpu = None
           
            message2print = "{(Step 7A/70) trying" + "; pipe2hpu-trying-by-create2kernel4hpu: " + str(pipe2hpu)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            try:
                pipe2hpu = Pipe4Xi()                                                                                # THE SYSTEM CREATES PIPE    
                
                message2print = "{(Step 7B/70) got" + "; pipe2hpu-got-by-create2kernel4hpu: " + str(pipe2hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                                  
                # (<read-write PipeConnection, handle 384>, <read-write PipeConnection, handle 388>)
                
                code2ack  = code2ack + '7B-'  
            except:
                message2print = "{(Step 7Z/70) failed" + "; pipe2hpu-failed-by-create2kernel4hpu: " + str(pipe2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                code2nack  = code2nack + '7Z-'
                
            task4kernel2hpu ['PIPE'] = pipe2hpu 
        except: 
            message2print = "{(Step 27Z1/70) yielded" + "; pipe-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z1-'
                                 
    if 'PIPE' in keys2task:                                
        message2print = "{(Step 27A/70) try" + "; pipe-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                     
        try:
            # -----------------------------------------------------------------------------------------
            # (Step 27/70) - PIPE - REQUIRED
            # -----------------------------------------------------------------------------------------               
            hpu2kernel4xi['PIPE'] = task4kernel2hpu['PIPE']
            
            message2print = "{(Step 27B/70) initialized" + "; pipe-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # (<read-write PipeConnection, handle 388>, <read-write PipeConnection, handle 392>)
            
            code2ack  = code2ack + '27B-'
        except: 
            message2print = "{(Step 27Z2/70) yielded" + "; pipe-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '27Z2-' 

    if 'COMMANDQUEUE' in keys2task:
        message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (28) COMMAND QUEUE - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['COMMANDQUEUE']  = task4kernel2hpu['COMMANDQUEUE']  
     
            message2print = "{(Step 28B/70) initialized" + "; commandqueue-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK' ...
                    
            code2ack  = code2ack + '28B-'
        except: 
            message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # 
                  
            code2nack  = code2nack + '28Z1-'    
    
    if 'BUFFER' in keys2task:
        message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (29) BUFFER INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['BUFFER']  = task4kernel2hpu['BUFFER']  
     
            message2print = "{(Step 29B/70) initialized" + "; bufferinfo-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            
            
            code2ack  = code2ack + '29B-'
        except: 
            message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '29Z1-'            
    
    if 'EVENT' in keys2task:
        message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (30) EVENT INFO - EXTRA                              
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['EVENT']  = task4kernel2hpu['EVENT']  
     
            message2print = "{(Step 30B/70) initialized" + "; eventinfo-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0, 'DATA2CALLBACK' ... 
            
            code2ack  = code2ack + '30B-'
        except: 
            message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '30Z1-'
                        
    
    if 'COUNT4PY' in keys2task:               
        message2print = "{(Step 31A1/70) try" + "; count2py4hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PY - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['COUNT4PY']  = task4kernel2hpu['COUNT4PY']  
    
            message2print = "{(Step 31A2/70) initialized" + "; count2py4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31A2-'
        except: 
            message2print = "{(Step 31Z1/70) yielded" + "; count2py4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z1-'     
    
    if 'COUNT4CPP' in keys2task:               
        message2print = "{(Step 31B1/70) try" + "; count2cpp4hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu['COUNT4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CPP - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['COUNT4CPP']  = task4kernel2hpu['COUNT4CPP']  
    
            message2print = "{(Step 31B2/70) initialized" + "; count2cpp4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31B2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cpp4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
            
    
    if 'COUNT4C' in keys2task:               
        message2print = "{(Step 31C1/70) try" + "; count2c4hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4C - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['COUNT4C']  = task4kernel2hpu['COUNT4C']  
    
            message2print = "{(Step 31C2/70) initialized" + "; count2c4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31C2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2c4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
    
    if 'COUNT4CL' in keys2task:               
        message2print = "{(Step 31D1/70) try" + "; count2cl4hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu['COUNT4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4CL - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['COUNT4CL']  = task4kernel2hpu['COUNT4CL']  
    
            message2print = "{(Step 31D2/70) initialized" + "; count2cl4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '31D2-'
        except: 
            message2print = "{(Step 31Z3/70) yielded" + "; count2cl4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z3-'     
                
    if 'COUNT4PYC' in keys2task:               
        message2print = "{(Step 31E1/70) try" + "; count4pyc-try-by-create2kernel4hpu: " + str(task4kernel2hpu['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4PYC - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['COUNT4PYC']  = task4kernel2hpu['COUNT4PYC']  
    
            message2print = "{(Step 31E2/70) initialized" + "; count4pyc-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            code2ack  = code2ack + '31E2-'
        except: 
            message2print = "{(Step 31Z4/70) yielded" + "; count4pyc-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z4-'     
    
    if 'COUNT4BIN' in keys2task:               
        message2print = "{(Step 31F1/70) try" + "; count4bin-try-by-create2kernel4hpu: " + str(task4kernel2hpu['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 0 
        try:            
            # ---------------------------------------------------------------------------------------------
            # (31) COUNT4BIN - REQUIRED                        
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['COUNT4BIN']  = task4kernel2hpu['COUNT4BIN']  
    
            message2print = "{(Step 31F2/70) initialized" + "; count4bin-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 0
            code2ack  = code2ack + '31F2-'
        except: 
            message2print = "{(Step 31Z5/70) yielded" + "; count4bin-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '31Z5-' 
                            
    if 'DIRECTORY4PY' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A) DIRECTORY4PY - REQUIRED                
            # ---------------------------------------------------------------------------------------------             
            dir2py4hpu = folder2lib4hpu                                                                                                                                                            
            message2print = "{(Step 32A/70) set" + "; dir2py4hpu-set-by-create2kernel4hpu to: " + str(dir2py4hpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu 
            code2ack  = code2ack + '32A-' 
        
            task4kernel2hpu ['DIRECTORY4PY'] = dir2py4hpu
        except: 
            message2print = "{(Step 32AZ/70) yielded" + "; directory4py-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32AZ-'                         
               
    if 'DIRECTORY4PY' in keys2task:
        message2print = "{(Step 32A1/70) try" + "; directory4py-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PY - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['DIRECTORY4PY']  = task4kernel2hpu['DIRECTORY4PY']  
     
            message2print = "{(Step 32B1/70) initialized" + "; directory2py4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4hpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z1/70) yielded" + "; directory2py4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CPP' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CPP - C++                 
            # ---------------------------------------------------------------------------------------------             
            dir2cpp4hpu = folder2lib4hpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cpp4hpu-set-by-create2kernel4hpu to: " + str(dir2cpp4hpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2hpu ['DIRECTORY4CPP'] = dir2cpp4hpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CPP' in keys2task:
        message2print = "{(Step 32A2/70) try" + "; directory2cpp4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CPP - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['DIRECTORY4CPP']  = task4kernel2hpu['DIRECTORY4CPP']  
     
            message2print = "{(Step 32B2/70) initialized" + "; directory2cpp4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4hpu
            code2ack  = code2ack + '32B2-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2cpp4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
                         
    if 'DIRECTORY4C' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4C - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2c4hpu = folder2lib4hpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2c4hpu-set-by-create2kernel4hpu to: " + str(dir2c4hpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2hpu ['DIRECTORY4C'] = dir2c4hpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4C' in keys2task:
        message2print = "{(Step 32A3/70) try" + "; directory2c4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4C - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['DIRECTORY4C']  = task4kernel2hpu['DIRECTORY4C']  
     
            message2print = "{(Step 32B3/70) initialized" + "; directory2c4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DIRECTORY4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4hpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2c4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-' 
             
    if 'DIRECTORY4CL' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4CL - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2cl4hpu = folder2lib4hpu                                                                                                                                                            
            message2print = "{(Step 32A0/70) set" + "; dir2cl4hpu-set-by-create2kernel4hpu to: " + str(dir2cl4hpu)  + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu 
            code2ack  = code2ack + '32A0-' 
        
            task4kernel2hpu ['DIRECTORY4CL'] = dir2cl4hpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'
                                        
    if 'DIRECTORY4CL' in keys2task:
        message2print = "{(Step 32A4/70) try" + "; directory2cl4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4CL - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['DIRECTORY4CL']  = task4kernel2hpu['DIRECTORY4CL']  
     
            message2print = "{(Step 32B4/70) initialized" + "; directory2cl4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DIRECTORY4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4hpu
            code2ack  = code2ack + '32B1-'
        except: 
            message2print = "{(Step 32Z4/70) yielded" + "; directory2cl4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z1-'
              
    if 'DIRECTORY4PYC' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4PYC - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2pycache4hpu = folder2lib4hpu + '__pycache__//'                                                                                                                                                           
            message2print = "{(Step 32B2/70) set" + "; dir2pycache4hpu-set-by-create2kernel4hpu to: " + str(dir2pycache4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu + '__pycache__//'
            code2ack  = code2ack + '32B2-' 
        
            task4kernel2hpu ['DIRECTORY4PYC'] = dir2pycache4hpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4py-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-'                     
                                                    
    if 'DIRECTORY4PYC' in keys2task:
        message2print = "{(Step 32C/70) try" + "; directory2pyc4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4PYC - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['DIRECTORY4PYC']  = task4kernel2hpu['DIRECTORY4PYC']  
     
            message2print = "{(Step 32D/70) initialized" + "; directory2pyc4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4hpu + __pycache__//
            code2ack  = code2ack + '32D-'
        except: 
            message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z2-' 
             
    if 'DIRECTORY4BIN' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (32A0) DIRECTORY4BIN - C                 
            # ---------------------------------------------------------------------------------------------             
            dir2bin4hpu = folder2lib4hpu + 'bin//'                                                                                                                                                           
            message2print = "{(Step 12A3/70) set" + "; dir2bin4hpu-set-by-create2kernel4hpu to: " + str(dir2bin4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            # folder2lib4hpu + 'bin//'
            code2ack  = code2ack + '12A3-' 
        
            task4kernel2hpu ['DIRECTORY4BIN'] = dir2bin4hpu
        except: 
            message2print = "{(Step 32Z0/70) yielded" + "; directory4bin-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z0-' 
                                        
    if 'DIRECTORY4BIN' in keys2task:
        message2print = "{(Step 32E/70) try" + "; directory2bin4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (32) DIRECTORY4BIN - REQUIRED                            
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['DIRECTORY4BIN']  = task4kernel2hpu['DIRECTORY4BIN']  
     
            message2print = "{(Step 32F/70) initialized" + "; directory2bin4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # folder2lib4hpu + bin//
            code2ack  = code2ack + '32F-'
        except: 
            message2print = "{(Step 32Z3/70) yielded" + "; directory2bin4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '32Z3-'  
    
                     
    if 'CODE4PY' in keys2task:            
        message2print = "{(Step 33A1/70) try" + "; code2py4hputask-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4hpu + 'hpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: ...
        
        hpu2kernel4xi['CODE4PY'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PY - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['CODE4PY'] = task4kernel2hpu ['CODE4PY']
    
     
            message2print = "{(Step 33B1/70) created" + "; code2py4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 'hpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2:
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z1/70) yielded" + "; code2py4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4PY']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2py4hpu2nack  = code2py4hpu2nack + '33Z1-'     
                     
    if 'CODE4CPP' in keys2task:            
        message2print = "{(Step 33A2/70) try" + "; code2cpp4hputask-try-by-create2kernel4hpu: " + str(len(task4kernel2hpu ['CODE4CPP']))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4hpu +  hpu2dummy4xi5test.cpp
        
        hpu2kernel4xi['CODE4CPP'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CPP - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['CODE4CPP'] = task4kernel2hpu ['CODE4CPP']
    
     
            message2print = "{(Step 33B2/70) created" + "; code2cpp4hpu-created-by-create2kernel4hpu: " + str(len(hpu2kernel4xi['CODE4CPP']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + hpu2dummy4xi5test.cpp
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2cpp4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4CPP']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cpp4hpu2nack  = code2cpp4hpu2nack + '33Z2-'     
                     
    if 'CODE4C' in keys2task:            
        message2print = "{(Step 33A3/70) try" + "; code2c4hputask-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['CODE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4hpu + 
        
        hpu2kernel4xi['CODE4C'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4C - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['CODE4C'] = task4kernel2hpu ['CODE4C']
    
     
            message2print = "{(Step 33B3/70) created" + "; code2c4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2c4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4C']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2c4hpu2nack  = code2c4hpu2nack + '33Z3-'                             
                     
    if 'CODE4CL' in keys2task:            
        message2print = "{(Step 33A4/70) try" + "; code2cl4hputask-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['CODE4CL'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4hpu + 
        
        hpu2kernel4xi['CODE4CL'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4CL - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['CODE4CL'] = task4kernel2hpu ['CODE4CL']
    
     
            message2print = "{(Step 33B4/70) created" + "; code2cl4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
             
            code2ack  = code2ack + '33B1-'
        except: 
            message2print = "{(Step 33Z4/70) yielded" + "; code2cl4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4CL']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2cl4hpu2nack  = code2cl4hpu2nack + '33Z1-'     
                                        
    if 'CODE4PYC' in keys2task:            
        message2print = "{(Step 33C/70) try" + "; code2pyc4hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4hpu + 
        
        hpu2kernel4xi['CODE4PYC'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['CODE4PYC'] = task4kernel2hpu ['CODE4PYC']
    
     
            message2print = "{(Step 33D/70) created" + "; code2pyc4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
             
            code2ack  = code2ack + '33D-'
        except: 
            message2print = "{(Step 33Z2/70) yielded" + "; code2pyc4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4PYC']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2pyc4hpu2nack  = code2pyc4hpu2nack + '33Z2-'     
                            
    if 'CODE4BIN' in keys2task:            
        message2print = "{(Step 33E/70) try" + "; code2bin4hpu2bin4hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # {folder2lib4hpu + 
        
        hpu2kernel4xi['CODE4BIN'] = {}
        try:            
            # ---------------------------------------------------------------------------------------------
            # (33) CODE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['CODE4BIN'] = task4kernel2hpu ['CODE4BIN']
    
     
            message2print = "{(Step 33F/70) created" + "; code2bin4hpu-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
             
            code2ack  = code2ack + '33F-'
        except: 
            message2print = "{(Step 33Z3/70) yielded" + "; code2bin4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi['CODE4BIN']) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2bin4hpu2nack  = code2bin4hpu2nack + '33Z3-'     
            
    if 'SIZE4PY' in keys2task:        
        message2print = "{(Step 34A1/70) try" + "; size2py4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['SIZE4PY']  = task4kernel2hpu['SIZE4PY']  
     
            message2print = "{(Step 34B1/70) initialized" + "; size2py4hpu-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 'hpu2sampler4xi5test.py': 1337}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z1/70) yielded" + "; size2py4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
            
    if 'SIZE4CPP' in keys2task:        
        message2print = "{(Step 34A2/70) try" + "; size2cpp4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['SIZE4CPP']  = task4kernel2hpu['SIZE4CPP']  
     
            message2print = "{(Step 34B2/70) initialized" + "; size2cpp4hpu-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4CPP'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + hpu2dummy4xi5test.cpp': 333}
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z2/70) yielded" + "; size2cpp4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4C' in keys2task:        
        message2print = "{(Step 34A3/70) try" + "; size2c4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['SIZE4C']  = task4kernel2hpu['SIZE4C']  
     
            message2print = "{(Step 34B3/70) initialized" + "; size2c4hpu-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size2c4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
            
    if 'SIZE4CL' in keys2task:        
        message2print = "{(Step 34A4/70) try" + "; size2cl4hpu-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34B) SIZE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['SIZE4CL']  = task4kernel2hpu['SIZE4CL']  
     
            message2print = "{(Step 34B4/70) initialized" + "; size2cl4hpu-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4CL'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
            code2ack  = code2ack + '34B1-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size2cl4hpu-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z1-'     
                                    
                        
    if 'SIZE4PYC' in keys2task:        
        message2print = "{(Step 34E/70) try" + "; size-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34F) SIZE4PYC - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['SIZE4PYC']  = task4kernel2hpu['SIZE4PYC']  
     
            message2print = "{(Step 34F/70) initialized" + "; size-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
            code2ack  = code2ack + '34F-'
        except: 
            message2print = "{(Step 34Z3/70) yielded" + "; size-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z3-'     
            
    if 'SIZE4BIN' in keys2task:        
        message2print = "{(Step 34G/70) try" + "; size-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (34G) SIZE4BIN - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
            hpu2kernel4xi['SIZE4BIN']  = task4kernel2hpu['SIZE4BIN']  
     
            message2print = "{(Step 34H/70) initialized" + "; size-initialized-by-create2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {folder2lib4hpu + 
            code2ack  = code2ack + '34H-'
        except: 
            message2print = "{(Step 34Z4/70) yielded" + "; size-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '34Z4-'
                 
    if 'LANGUAGE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (35A0) LANGUAGE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2hpu ['LANGUAGE'] = {}
            
            for key2code4hpu in keys2code4hpu:
                name2program4hpu=os.path.splitext(key2code4hpu)                                                     
                key2extension4hpu = name2program4hpu[1]                                                             
                if key2extension4hpu == '.py':                          
                    task4kernel2hpu ['LANGUAGE'] ['PY']  = "Python"  
                if key2extension4hpu == '.cpp':                          
                    task4kernel2hpu ['LANGUAGE'] ['CPP'] = "C++"
                if key2extension4hpu == '.c':                          
                    task4kernel2hpu ['LANGUAGE'] ['C']   = "C"  
                if key2extension4hpu == '.cl':                          
                    task4kernel2hpu ['LANGUAGE'] ['CL']  = "CL"                                     
                    
            message2print = "{(Step 15B/70) set" + "; language2task4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-' 
        except: 
            message2print = "{(Step 35Z0/70) yielded" + "; language-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z0-'
                                     
    if 'LANGUAGE' in keys2task:        
        message2print = "{(Step 35A/70) try" + "; language-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (35) LANGUAGE - PYTHON, C++, C, CL                              
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['LANGUAGE']  = task4kernel2hpu['LANGUAGE']  
     
            message2print = "{(Step 35B/70) initialized" + "; language-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CPP': 'C++', 'PY': 'Python'}
            code2ack  = code2ack + '35B-'
        except: 
            message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '35Z1-'  
                     
    if 'COUNT2REFERENCE' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (36A0) COUNT2REFERENCE - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            count2reference2hpu  = 1
           
            message2print = "{(Step 36B/70) set" + "; count2reference2hpu-set-by-create2kernel4hpu to: " + str(count2reference2hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1 
            code2ack  = code2ack + '36B-' 
        
            task4kernel2hpu ['COUNT2REFERENCE'] = count2reference2hpu     
        except: 
            message2print = "{(Step 36Z0/70) yielded" + "; count2reference2hpu-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z0-'             
                
    if 'COUNT2REFERENCE' in keys2task:                
        message2print = "{(Step 36A/70) try" + "; count2reference-try-by-create2kernel4hpu: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (36) COUNT2REFERENCE - REQUIRED                              
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['COUNT2REFERENCE']  = task4kernel2hpu['COUNT2REFERENCE']  
     
            message2print = "{(Step 36B/70) initialized" + "; count2reference-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 1
            code2ack  = code2ack + '36B-'
        except: 
            message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '36Z1-' 
                
    if 'PROGRAM' not in keys2task:
        message2print = "{(Step 37/70) warned" + "; keys2task4program-warned-by-create2kernel4hpu: " + " ** " + str(keys2task)  + " ** " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        try:             
            # ---------------------------------------------------------------------------------------------
            # (37A0) PROGRAM - REQUIRED                 
            # ---------------------------------------------------------------------------------------------             
            task4kernel2hpu ['PROGRAM'] = None
            message2print = "{(Step 37A/70) try" + "; program2hpu-try-by-create2kernel4hpu: " + str(task4kernel2hpu ['PROGRAM'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            #             
            try:
                task4kernel2hpu ['PROGRAM'] = create2programwithsource4hpu()
                keys2program = task4kernel2hpu ['PROGRAM'].keys()
                
                message2print = "{(Step 37B/70) set" + "; program-set-by-create2kernel4hpu to: " + str(keys2program)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # ['CODE2ERROR' ... 
                #  'PROGRAM', 'NACK2RETURN', 'CONTEXT', 'COMMANDQUEUE', 'DEVICE', ... 'PIPE']

                code2ack  = code2ack + '37B-'
            except:
                message2print = "{(Step 37Z1/70) failed" + "; task4kernel2hpu-failed-by-create2kernel4hpu: " + str(task4kernel2hpu ['PROGRAM']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '37Z-'    
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; program-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-' 
                            
    if 'PROGRAM' in keys2task:
        message2print = "{(Step 37A/70) try" + "; program-try-by-create2kernel4hpu: {}" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        try:            
            # ---------------------------------------------------------------------------------------------
            # (37) PROGRAM - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['PROGRAM']  = task4kernel2hpu['PROGRAM']  
     
            message2print = "{(Step 37B/70) initialized" + "; program-created-by-create2kernel4hpu: " + str(len(hpu2kernel4xi['PROGRAM']))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'CODE2ERROR': 0 ... 
            
            code2ack  = code2ack + '37B-'
        except: 
            message2print = "{(Step 37Z1/70) yielded" + "; program-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z1-' 
                       
    if 'FUNCTION' not in keys2task:
        try:             
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2hpu ['FUNCTION'] = {}
            message2print = "{(Step 38A0/70) set" + "; function4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
             
            task4kernel2hpu ['FUNCTION'] ['.py'] = {}
            message2print = "{(Step 38A1/70) set" + "; pythonfunction4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['FUNCTION'] ['.py'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}
                        
            tag2search4hpu  = kb2kernel4hpu ['.py'] ['TAG']
            message2print = "{(Step 38A2/70) using" + "; tag2search4hpu-using-by-create2kernel4hpu: " + str(tag2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # ... function =
            
            value2search4hpu    = kb2kernel4hpu ['.py'] ['VALUE']
            message2print = "{(Step 38A3/70) using" + "; value2search4hpu-using-by-create2kernel4hpu: " + str(value2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # hpu2sampler4xi5test
            
            attribute2search4hpu= kb2kernel4hpu ['.py'] ['ATTRIBUTE'] 
            message2print = "{(Step 38A4/70) using" + "; attribute2search4hpu-using-by-create2kernel4hpu: " + str(attribute2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage =
            try:
                keys2code4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4hpu in keys2code4hpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu]
                    keys2line4hpu = code2examine4hpu.keys()
                    for key2line4hpu in keys2line4hpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu] [key2line4hpu]
                        # message2print = "{(Step 38A5/70) examining" + "; line2examine4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        #                             
                        
                        index2pattern = str.find(line2examine4hpu,tag2search4hpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 38B/70) examining" + "; line2function4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            # ... function = "set2trace4sampler" ... # function = "hpu2sampler4xi5test" usage = "
                             
                            index2function = str.find(line2examine4hpu,value2search4hpu)
                            if index2function == -1:
                                message2print = "{(Step 38C/70) skipped" + "; line2function4hpu-skipped-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "set2trace4sampler" ... # function = "hpu2sampler4xi5test" usage = " ...function = "main" usage = "
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                index2usage = str.find(line2examine4hpu,attribute2search4hpu)             # ....function = "hpu2sampler4xi5test" usage = "
                                if index2usage  == -1:                                                
                                    # ------------------------------------------------------------------------------
                                    # NOT OK KERNEL FUNCTION TAG LINE - USAGE ATTRIBUTE MISSING
                                    # ------------------------------------------------------------------------------
                                    message2print = "{(Step 38D/70) warning" + "; line2function4hpu-warning-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # 
                                    
                                else:
                                    # ------------------------------------------------------------------------------
                                    # OK KERNEL FUNCTION TAG LINE
                                    # ------------------------------------------------------------------------------    
                                    message2print = "{(Step 38E/70) accepted" + "; line2examine4hpu-accepted-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # ... function = "hpu2sampler4xi5test" usage = "
                                    # 0123456789012345678901234567890123456789012345678901234
                                    
                                    key2pythonfunction4hpu = line2examine4hpu[index2function:index2usage-2]
                                    
                                    task4kernel2hpu ['FUNCTION'] ['.py'] [key2pythonfunction4hpu] = {}                                  

                                    message2print = "{(Step 38F/70) used" + "; key2pythonfunction4hpu-used-by-create2kernel4hpu: " + str(key2pythonfunction4hpu)  + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print) 
                                    # hpu2sampler4xi5test
                                    
                                    code2ack  = code2ack + '38F-'
                            # -------------------------------------------------------------------------------------
                            # 
                            # -------------------------------------------------------------------------------------                                        
                             
            except:
                message2print = "{(Step 38Z1/70) failed" + "; task4kernel2hpu-failed-by-create2kernel4hpu: " + str(task4kernel2hpu ['FUNCTION']) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                #             
                code2nack  = code2nack + '38Z-'            
                                    
            # ---------------------------------------------------------------------------------------------
            # (39) FUNCTION - KERNEL FUNCTIONS FROM FECTHED C++ FILE(S) - NOT FROM PROGRAM OBJECT                
            # --------------------------------------------------------------------------------------------- 
            task4kernel2hpu ['FUNCTION'] ['.cpp'] = {}            
            message2print = "{(Step 39A0F/70) set" + "; cplusfunction4hpu-set-by-create2kernel4hpu to: " + str(task4kernel2hpu ['FUNCTION'] ['.cpp'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {}   
            
            tag2search4hpu      = kb2kernel4hpu ['.cpp'] ['TAG']
            message2print = "{(Step 39A2/70) using" + "; tag2search4hpu-using-by-create2kernel4hpu: " + str(tag2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # function =
            
            attribute2search4hpu= kb2kernel4hpu ['.cpp'] ['ATTRIBUTE'] 
            message2print = "{(Step 39A4/70) using" + "; attribute2search4hpu-using-by-create2kernel4hpu: " + str(attribute2search4hpu)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # usage = kernel
            

            try:
                keys2code4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'].keys()
                for key2code4hpu in keys2code4hpu:
                    # ---------------------------------------------------------------------------------------------
                    # SOURCE FILE
                    # ---------------------------------------------------------------------------------------------
                    code2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu]
                    message2print = "{(Step 39A5/70) using" + "; key2code4hpu-using-by-create2kernel4hpu: " + str(key2code4hpu)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # hpu2dummy4xi5test.cpp
                       
                    keys2line4hpu = code2examine4hpu.keys()
                    # message2print = "{(Step 39A6/70) using" + "; keys2line4hpu-using-by-create2kernel4hpu: " + str(keys2line4hpu)  + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print) 
                    # 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 ...                    
                    for key2line4hpu in keys2line4hpu:
                        # -----------------------------------------------------------------------------------------
                        # SOURCE LINE
                        # -----------------------------------------------------------------------------------------
                        line2examine4hpu = task4kernel2hpu ['PROGRAM'] ['CODE4SOURCE'] [key2code4hpu] [key2line4hpu]
                        # message2print = "{(Step 39A7/70) examining" + "; line2examine4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print) 
                        # function = "nbody_kern" usage = "kernel example 1"*/                        
                        
                        index2pattern = str.find(line2examine4hpu,tag2search4hpu)  
                        if index2pattern == -1:
                            pass
                        else:
                            # -------------------------------------------------------------------------------------
                            # FUNCTION TAG 
                            # -------------------------------------------------------------------------------------
                            message2print = "{(Step 39B1/70) examining" + "; line2function4hpu-examining-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # function = "OCLError" usage = "error code checking"*/
                            # function = "nbody_kern" usage = "kernel example 1"*/
                            
                            message2print = "{(Step 39B2/70) using" + "; attribute2search4hpu-using-by-create2kernel4hpu: " + str(attribute2search4hpu)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print) 
                            #                                                         
                            index2usage = str.find(line2examine4hpu,attribute2search4hpu)
                            if index2usage == -1:
                                # ----------------------------------------------------------------------------------
                                # NON KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------                            
                                message2print = "{(Step 39C/70) skipped" + "; line2function4hpu-skipped-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "OCLError" usage = "error code checking"*/
                                
                            else:
                                # ----------------------------------------------------------------------------------
                                # KERNEL FUNCTION  
                                # ----------------------------------------------------------------------------------
                                message2print = "{(Step 39E/70) accepted" + "; line2examine4hpu-accepted-by-create2kernel4hpu: " + str(line2examine4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # function = "nbody_kern" usage = "kernel example 1"*/; 
                                # function = "nbody2_kern" usage = "kernel example 2"*/ 
                                # 012345678901234567890123456789012345678901234567890
                                 
                                key2kernelfunction4hpu = line2examine4hpu[27:index2usage-2]  
                                task4kernel2hpu ['FUNCTION'] ['.cpp'] [key2kernelfunction4hpu] =  {}                                       

                                message2print = "{(Step 39F/70) used" + "; key2kernelfunction4hpu-used-by-create2kernel4hpu: " + str(key2kernelfunction4hpu)  + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print) 
                                # nbody_kern; nbody2_kern 
                                    
                                code2ack  = code2ack + '39F-'
                                    
            except: 
                message2print = "{(Step 37Z1/70) yielded" + "; program-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                code2nack  = code2nack + '37Z1-'
        except: 
            message2print = "{(Step 37Z0/70) yielded" + "; function-hpu2kernel4xi-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '37Z0-'                               
                
    if 'FUNCTION' in keys2task:    
        message2print = "{(Step 38A/70) trying" + "; function-trying-by-create2kernel4hpu: " + str(task4kernel2hpu['FUNCTION'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {'.py': {'hpu2sampler4xi5test': {}}, 
        # '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}}    
        try:            
            # ---------------------------------------------------------------------------------------------
            # (38) FUNCTION - REQUIRED                          
            # ---------------------------------------------------------------------------------------------             
                            
            hpu2kernel4xi['FUNCTION']  = task4kernel2hpu['FUNCTION']   
     
            message2print = "{(Step 38B/70) created" + "; function-created-by-create2kernel4hpu: " + str(hpu2kernel4xi['FUNCTION'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # {'.py': {'hpu2sampler4xi5test': {}}, '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}} 
            
            code2ack  = code2ack + '38B-'
        except: 
            message2print = "{(Step 38Z1/70) yielded" + "; function-yielded-by-create2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '38Z1-'            
                                       
                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)     
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack 
     
    keys2kernel4hpu = hpu2kernel4xi.keys()
    message2print = "{(Step 70A/70) returning" + "; keys2kernel4hpu-returning-by-create2kernel4hpu: " + str(keys2kernel4hpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 (no parameters given by caller): 
    # ['DIRECTORY4CL',
    #  'DIRECTORY4PY',
    #  'DIRECTORY4C',
    #  'DIRECTORY4CPP',
    #  'DIRECTORY4PYC',    
    #  'DIRECTORY4BIN',    
    #  'CODE4PY',
    #  'CODE4PYC',
    #  'CODE4CPP',
    #  'CODE4BIN',
    #  'CODE4C',
    #  'CODE4CL',
    #  'COUNT4C',                
    #  'COUNT4CL',    
    #  'COUNT4CPP',
    #  'COUNT4PYC',
    #  'COUNT4PY',
    #  'COUNT4BIN',
    #  'SIZE4PY',    
    #  'SIZE4CPP', <-- OK: C and CL MISSING
    #  'SIZE4PYC',
    #  'SIZE4BIN',
                        
    #  'QUEUE',
    #  'PROGRAM',
    #  'CONTEXT',
    #  'PIPE',
    #  'FUNCTION2CALLBACK',
    #  'COMMANDQUEUE',
    #  'PLATFORM',
    #  'FUNCTION',
    #  'CODE2ERROR',
    #  'ACK2RETURN',
    #  'DATA2CALLBACK',
    #  'BUFFER',
    #  'COUNT2REFERENCE',
    #  'DEVICE',
    #  'LANGUAGE',
    #  'NACK2RETURN',
    #  'EVENT']



    
    #2 (function and program parameters given by user):
    # ['FUNCTION',
    #  'ACK2RETURN',
    #  'PROGRAM',
    #  'NACK2RETURN']

    
    keys2programkernel4hpu = hpu2kernel4xi['PROGRAM'].keys()
    message2print = "{(Step 70B/70) returning" + "; keys2programkernel4hpu-returning-by-create2kernel4hpu: " + str(keys2programkernel4hpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    #1 and 2:
    # ['CODE2ERROR', 'LANGUAGE4SOURCE', 'COUNT4SOURCE' ...
    
    try:
        message2print = "{(Step 70C1/70) returning" + "; count2py4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi ['COUNT4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C2/70) returning" + "; count2cpp4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi ['COUNT4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 1
    except:
        pass    
    
    try:
        message2print = "{(Step 70C3/70) returning" + "; count2c4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi ['COUNT4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
    
    try:
        message2print = "{(Step 70C4/70) returning" + "; count2cl4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi ['COUNT4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 0
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S1/70) returning" + "; size2py4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi['SIZE4PY']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # pu2sampler4xi5test.py': 1337
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S2/70) returning" + "; size2cpp4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi['SIZE4CPP']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # hpu2dummy4xi5test.cpp': 331
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S3/70) returning" + "; size2c4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi['SIZE4C']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    
            
    try:        
        message2print = "{(Step 70S4/70) returning" + "; size2cl4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi['SIZE4CL']) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    except:
        pass    


    message2print = "{(Step 70T/70) returning" + "; function2kernel4hpu-returning-by-create2kernel4hpu: " + str(hpu2kernel4xi['FUNCTION']) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # {'.py':  {'hpu2sampler4xi5test': {}},
    #  '.cpp': {'nbody_kern': {}, 'nbody2_kern': {}}
    # }  
        
    
                         
    return hpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "add2kernel4hpu" usage = "
#     
#   print('(Step 3A2/700) OF HPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4add2kernel = {}
#       task4add2kernel ['CODE4KERNEL'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = {}
#       task4add2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'hpu2dummy4xi.py'] [1] = '... profile = "11" />'
#       task4add2kernel ['SIZE4KERNEL'] = {}
#       task4add2kernel ['SIZE4KERNEL'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = len(task4add2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'hpu2dummy4xi.py'])
#       
#       response4add2kernel = add2kernel4hpu(task4add2kernel)
#       print('(Step 3A3/700) OF HPU2KERNEL4XI5TEST - ADDED KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z2/700) OF HPU2KERNEL4XI5TEST *** FAILED TO PRINT response4add2kernel: ', response4add2kernel)
#          
#">

# -------------------------------------------------------------------------------------------------   
def add2kernel4hpu(task4kernel2hpu):

    '''
    adds to kernel for HPU
    '''
    global hpu2kernel4xi                                                                                            # Kernel of HPU    
    global folder2lib4hpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "add2kernel4hpu" 
    method2print = "add2kernel4hpu"

    message2print = "{(Step 10A/70) started" + "; add2kernel4hpu-started: " + str(add2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2hpu-to-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              
    # 
    code2ack  = ' '
    code2nack = ' ' 
    try:
        keys2kernel4task = task4kernel2hpu ['CODE4KERNEL'].keys()
        message2print = "{(Step 10C/70) using" + "; keys2kernel4task-using-by-add2kernel4hpu: " + str(keys2kernel4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #         
    except: 
        message2print = "{(Step 10Z1/70) failed" + "; keys2kernel4task-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    try:
        keys2exist4task =  hpu2kernel4xi ['CODE4KERNEL'].keys() 
        message2print = "{(Step 10D/70) using" + "; keys2exist4task-using-by-add2kernel4hpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    except:
        try:
            response2createwb4hpu = create2kernelsinkernel4hpu()
            keys2createwb4hpu = response2createwb4hpu.keys()
            for key2createwb4hpu in keys2createwb4hpu:
                if key2createwb4hpu == 'CODE4KERNEL':
                    message2print = "{(Step 10E/70) created" + "; key2createwb4hpu-created-by-add2kernel4hpu: " + str(key2createwb4hpu) + "; time: " + time4xi() + "}" 
                    print4xi(class2print, method2print, message2print)
                    # 
            
            keys2exist4task =  hpu2kernel4xi ['CODE4KERNEL'].keys() 
            message2print = "{(Step 10F/70) using" + "; keys2exist4task-using-by-add2kernel4hpu: " + str(keys2exist4task)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        
        except: 
            message2print = "{(Step 10Z2/70) failed" + "; hpu2kernel4xi-failed-by-add2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - EXPECTED - SEVERAL KERNEL CODE CAN BE ADDED INTO ONE PROGRAM OBJECT                              
        # ---------------------------------------------------------------------------------------------             
        for key2kernel4task in keys2kernel4task:
            try:
                message2print = "{(Step 33A/70) using" + "; key2kernel4task-using-by-add2kernel4hpu: " + str(key2kernel4task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                            
                if key2kernel4task in keys2exist4task:
                    message2print = "{(Step 33Z0/70) yielded" + "; key2kernel4task-yielded-by-add2kernel4hpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # folder2lib4hpu +  
                     
                    code2nack  = code2nack + '33Z0-'
                else: 
                    try:
                        hpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task] = task4kernel2hpu ['CODE4KERNEL'] [key2kernel4task]
                    except:
                        message2print = "{(Step 33Z1/70) failed" + "; task4kernel2hpu-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z1-' 
                    try:             
                        message2print = "{(Step 33B/70) added" + "; key2kernel4task-added-by-add2kernel4hpu to: " + str(key2kernel4task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        #folder2lib4hpu +  
                    except:
                        message2print = "{(Step 33Z2/70) failed" + "; task4kernel2hpu-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z2-' 
                    try:             
                        message2print = "{(Step 33C/70) added" + "; code-added-by-add2kernel4hpu to: " + str(hpu2kernel4xi ['CODE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z3/70) failed" + "; task4kernel2hpu-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        code2nack  = code2nack + '33Z3-'                 
                    try:
                        hpu2kernel4xi ['COUNT4KERNEL'] = hpu2kernel4xi ['COUNT4KERNEL'] + 1
                        message2print = "{(Step 33D/70) added" + "; count4kernel-added-by-add2kernel4hpu to: " + str(hpu2kernel4xi ['COUNT4KERNEL'])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                    except:
                        message2print = "{(Step 33Z4/70) failed" + "; task4kernel2hpu-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z4-' 
                    try:                            
                        hpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task]  = task4kernel2hpu['SIZE4KERNEL'] [key2kernel4task]  
                        message2print = "{(Step 33E/70) set" + "; size4kernel-set-by-add2kernel4hpu to: " + str(hpu2kernel4xi ['SIZE4KERNEL'] [key2kernel4task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print) 
                        # 
                        code2ack  = code2ack + '33D-'
                    except:
                        message2print = "{(Step 33Z5/70) failed" + "; task4kernel2hpu-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        code2nack  = code2nack + '33Z5-'    
            except:
                message2print = "{(Step 33Z6/70) failed" + "; task4kernel2hpu-failed-by-add2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                code2nack  = code2nack + '33Z6-'                     
    except: 
        message2print = "{(Step 33Z7/70) yielded" + "; kernel-yielded-by-add2kernel4hpu: " + str(hpu2kernel4xi ['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '33Z7-'       
          
                                                                                                                   
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernelkernels = hpu2kernel4xi ['CODE4KERNEL'].keys()
    for key2kernelkernel in sorted(keys2kernelkernels):
        message2print = "{(Step 70A/70) got" + "; key2kernelkernel-got-by-add2kernel4hpu: " + str(key2kernelkernel) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        #folder2lib4hpu +  


    keys2kernel4hpu = hpu2kernel4xi.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4hpu-returning-by-add2kernel4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return hpu2kernel4xi
            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "execute2nativekernel4hpu" usage = "
#     
#   print('(Step 2A2/700) OF HPU2KERNEL4XI5TEST - TRYING TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION ', time4xi())           
#   try:
#       response4execute = execute2nativekernel4hpu()
#   except:
#       print('(Step 2Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO EXECUTE NATIVE KERNEL INTO PROGRAM OBJECT WITH FUNCTION *** ', time4xi())                                                                      
#          
#">

# -------------------------------------------------------------------------------------------------   
def execute2nativekernel4hpu(task4program2hpu=None):

    '''
    executes native kernel of HPU
    '''
    global hpu2kernel4xi                                                                                            # Kernel of HPU    
    global import2use4hpu                                                                                           # Imports of HPU
    global target2function4hpu                                                                                      # Target function of Process4Xi
    global folder2lib4hpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "execute2nativekernel4hpu" 
    method2print = "execute2nativekernel4hpu"

    message2print = "{(Step 1A/70) started" + "; execute2nativekernel4hpu-started: " + str(execute2nativekernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4program2hpu-to-execute2nativekernel4hpu: " + str(task4program2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    kernel2program4hpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
    message2print = "{(Step 1C/70) initialized" + "; kernel2program4hpu-initialized-by-execute2nativekernel4hpu to: " + str(kernel2program4hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #                
    try:             
        if task4program2hpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4program2hpu-yielded-by-execute2nativekernel4hpu: " + str(task4program2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - EXECUTE NATIVE KERNELS INSIDE PROGRAM OBJECT FOR HPU ! 
    # ---------------------------------------------------------------------------------------------    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                            
        # ---------------------------------------------------------------------------------------------             
        keys2kernel4hpu = hpu2kernel4xi['CODE4KERNEL'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2kernel4hpu-using-by-execute2nativekernel4hpu: " + str(keys2kernel4hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        unit4processing = "hpu"
        
        for key2kernel4hpu in keys2kernel4hpu:
            index2search=str.find(key2kernel4hpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2execute = key2kernel4hpu[index2search:]                                                          # hpu2sampler4xi5test.py
                index2search=str.find(target2execute,".py")
                if index2search == -1:
                    pass
                else:
                    target2execute4hpu = target2execute[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2execute4hpu-set-by-execute2nativekernel4hpu to: " + str(target2execute4hpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # 

                    p2kernel4hpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4HPU 
                        # ---------------------------------------------------------------------------------------------    
             
                        try:
                            import2use4hpu.get(target2execute4hpu, handle2error4hpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2execute4hpu-imported-by-execute2nativekernel4hpu: " + str(target2execute4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4hpu-failed-by-execute2nativekernel4hpu: " + str(import2use4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2execute4hpu-used-by-execute2nativekernel4hpu: " + str(target2execute4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4HPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2hpu = Process4Xi(target=target2function4hpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2hpu-created-by-execute2nativekernel4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-1, initial)>
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2hpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2hpu-started-by-execute2nativekernel4hpu: " + str(p2hpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-1
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4hpu = p2hpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-execute2nativekernel4hpu: " + str(status2process4hpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2hpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2hpu-run-by-execute2nativekernel4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-execute2nativekernel4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-execute2nativekernel4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-execute2nativekernel4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2kernel4hpu-failed-by-execute2nativekernel4hpu: " + str(p2kernel4hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    
            # ---------------------------------------------------------------------------------------------
            # SAVE SOURCE WITHOUT END OF LINES
            # ---------------------------------------------------------------------------------------------        
            keys2lines = hpu2kernel4xi['CODE4KERNEL'][key2kernel4hpu].keys()     
            kernel2program4hpu[key2kernel4hpu] = ""
            for key2line in keys2lines:
                code2add4hpu = hpu2kernel4xi ['CODE4KERNEL'] [key2kernel4hpu] [key2line]
                kernel2program4hpu[key2kernel4hpu] = kernel2program4hpu[key2kernel4hpu] + code2add4hpu.replace("\n","")
        
            message2print = "{(Step 34A/70) saved" + "; lenght-kernel4hpu-saved-by-execute2nativekernel4hpu to: " + str(len(kernel2program4hpu[key2kernel4hpu]))  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #     
                
 
        message2print = "{(Step 38A/70) set" + "; lenght-kernel2program4hpu-set-by-execute2nativekernel4hpu to: " + str(len(kernel2program4hpu))  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; kernel-yielded-by-execute2nativekernel4hpu: " + str(hpu2kernel4xi['CODE4KERNEL']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2kernel4hpu = kernel2program4hpu.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4hpu-returning-by-execute2nativekernel4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)                                                              
        # 
    
    return kernel2program4hpu
            
#</function4xi> 
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "delete2kernel4hpu" usage = "
#     
#   print('(Step 3A3/700) OF HPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())        
#   try:
#       task4delete2kernel = {}
#       task4delete2kernel ['CODE4KERNEL'] = {}
#       task4delete2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'hpu2program4xi.py'] = 'Yes'
#       task4delete2kernel ['SIZE4KERNEL'] = {}
#       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4hpu + 'hpu2program4xi.py'] = 'Yes'
#       
#       response4delete2kernel = delete2kernel4hpu(task4delete2kernel) 
#       print('(Step 3A3/700) OF HPU2KERNEL4XI5TEST - DELETED KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF HPU2KERNEL4XI5TEST *** FAILED TO DELETE KERNEL INSIDE PROGRAM OBJECT WITH FUNCTION *** ', time4xi()) 
#          
#">

# -------------------------------------------------------------------------------------------------   
def delete2kernel4hpu(task4kernel2hpu):

    '''
    deletes kernel for HPU
    '''
    global hpu2kernel4xi                                                                                     
    global folder2lib4hpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 10/70)      
    # -----------------------------------------------------------------------------------------          
    class2print = "delete2kernel4hpu" 
    method2print = "delete2kernel4hpu"

    message2print = "{(Step 10A/70) started" + "; delete2kernel4hpu-started: " + str(delete2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # <function delete2kernel4hpu at 0x000000000405CEC8>
  
    message2print = "{(Step 10B/70) passed" + "; task4kernel2hpu-to-delete2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 


    code2ack  = ' '
    code2nack = ' '    
    #
    ack4key2kernelkernel = False
    try:
        # ---------------------------------------------------------------------------------------------
        # TASK MUST HAVE BEEN GIVEN BY USER - CONTAINS KERNEL KEYS    
        # ---------------------------------------------------------------------------------------------
        keys2delete4kernel = task4kernel2hpu ['CODE4KERNEL'].keys()        
        message2print = "{(Step 19A/70) using" + "; keys2delete4kernel-using-by-delete2kernel4hpu: " + str(sorted(keys2delete4kernel))  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        # ---------------------------------------------------------------------------------------------
        # (Step 20A/70) - DELETE KERNEL INSIDE PROGRAM OBJECT FOR HPU ! 
        # ---------------------------------------------------------------------------------------------    
        message2print = "{(Step 20A0/70) try" + "; key-try-by-delete2kernel4hpu: None" + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)      

        for key2delete4kernel in keys2delete4kernel:
            try:            
                del hpu2kernel4xi ['CODE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20C/70) deleted" + "; code4kernel-deleted-by-delete2kernel4hpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20C-' 
                
                del hpu2kernel4xi ['SIZE4KERNEL'] [key2delete4kernel]        
               
                message2print = "{(Step 20D/70) deleted" + "; size4kernel-deleted-by-delete2kernel4hpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                # 
                
                code2ack  = code2ack + '20D-' 
                
                hpu2kernel4xi ['COUNT4KERNEL'] = hpu2kernel4xi ['COUNT4KERNEL'] - 1
                message2print = "{(Step 20E/70) upgraded" + "; count4kernel-upgraded-by-delete2kernel4hpu: " + str(hpu2kernel4xi ['COUNT4KERNEL'] ) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                    
                #                                
                
            except:
                message2print = "{(Step 20Z1/70) yielded" + "; key2delete4kernel-yielded-by-delete2kernel4hpu: " + str(key2delete4kernel) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #                
                code2nack  = code2nack + '20Z1-' 
    except: 
        message2print = "{(Step 20Z0/70) failed" + "; task4kernel2hpu-hpu2kernel4xi-failed-by-delete2kernel4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '20Z0-'    
                                                                                            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack  
    try:
        keys2kernelkernels = hpu2kernel4xi ['CODE4KERNEL'] .keys()
        for key2kernelkernels in keys2kernelkernels:
            message2print = "{(Step 70A/70) got" + "; key2kernelkernels-got-by-delete2kernel4hpu: " + str(key2kernelkernels) + "; time: " + time4xi() + "}"  
            print4xi(class2print, method2print, message2print)                                                              
            #  
    except:
        pass 
               
     
    keys2kernel4hpu = hpu2kernel4xi.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70B/70) returning" + "; key2kernel4hpu-returning-by-delete2kernel4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 


    return hpu2kernel4xi
            
#</function4xi> 
 



# -------------------------------------------------------------------------------------------------
#<function4xi function = "create2kernelsinprogram4hpu" usage = "
#     
#   print('(Step 3A1/700) OF HPU2KERNEL4XI5TEST - TRYING TO CREATE KERNELS IN PROGRAM FOR HPU ', time4xi())          
#   try:
#       response4create2kernelsinprogram = create2kernelsinprogram4hpu()
#       print('(Step 3A2/700) OF HPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRAM FOR HPU ', time4xi())
#   except:
#       print('(Step 3Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNELS IN PROGRAM FOR HPU *** ', time4xi())
#
#">

# -------------------------------------------------------------------------------------------------   
def create2kernelsinprogram4hpu(task4kernel2hpu=None):

    '''
    creates kernels in program for HPU
    '''
    global hpu2kernel4xi                                                                                            # Kernel of HPU    
    global folder2lib4hpu  
      
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - START            
    # -----------------------------------------------------------------------------------------          
    class2print = "create2kernelsinprogram4hpu" 
    method2print = "create2kernelsinprogram4hpu"

    message2print = "{(Step 1A/70) started" + "; create2kernelsinprogram4hpu-started: " + str(create2kernelsinprogram4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernel2hpu-to-create2kernelsinprogram4hpu: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    

    
    keys2kernel4hpu = hpu2kernel4xi.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4hpu-returning-by-create2kernelsinprogram4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return hpu2kernel4xi
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fetch2kernel4hpu" usage = "
#   fetch2kernel4hpu(file2walk)
#"> 
# -------------------------------------------------------------------------------------------------
def fetch2kernel4hpu(program2explore4hpu):
    global fetch2code4hpu                                                                                           # dictionary to receive files 
        
    global kb2fetch4hpu                                                                                             # knowledgebase for fetching
    global profile2fetch                                                                                            # profiles
    global keys2profile4hpu                                                                                         # file extensions 
    
    global folder2lib4hpu  

    class2print  = "fetch2kernel4hpu"
    method2print = "fetch2kernel4hpu" 
     
    message2print = "{(Step 1A/33) passed" + "; program2explore4hpu-passed-to-fetch2kernel4hpu: " + str(program2explore4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # folder2lib4hpu + hpu2buffer4xi.py          ... hpu2sampler4xi5test.py ... hpu2dummy4xi5test.cpp ...           # Python and C++ programs
    # __pycache__\hpu2buffer4xi.cpython-33.pyc   ... hpu2sampler4xi5test.cpython-33.pyc ...                         # Cache of Python binaries
    # //bin\hpu2dummy4xi5test.exe                                                                                   # Built C++ exe files
                  
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program4hpu=os.path.splitext(program2explore4hpu)                                                          # hpu2sampler4xi5test + py

    key2extension4hpu = name2program4hpu[1]                                                                         # py,pyc,cpp,exe 
    message2print = "{(Step 1B/33) set" + "; key2extension4hpu-set-by-fetch2kernel4hpu to: " + str(key2extension4hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # .py; .pyc
    message2print = "{(Step 1C/33) using" + "; profile2fetch-using-by-fetch2kernel4hpu: " + str(profile2fetch)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    # {'.pyc': 'NACK', '.py': 'ACK', '.cpp': 'ACK', '.exe': 'NACK'}  
        
    if profile2fetch [key2extension4hpu] == 'ACK':                                                                  # profile2fetch ['py']  = 'ACK'       
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - EXTENSION IN PROFILE 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore4hpu-analyzing-by-fetch2kernel4hpu: " + str(program2explore4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # folder2lib4hpu +  hpu2buffer4xi.py ; hpu2sampler4xi5test.py ...  ... __pycache__\hpu2sampler4xi5test.cpython-33.pyc
        # hpu2dummy4xi5test.cpp
             
        path2input4hpu = program2explore4hpu
        message2print = "{(Step 1B/33) set" + "; path2input4hpu-set-by-fetch2kernel4hpu to: " + str(path2input4hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # folder2lib4hpu +  hpu2buffer4xi.py ; __pycache__\hpu2sampler4xi5test.cpython-33.pyc; hpu2dummy4xi5test.cpp

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER PROGRAM MUST BE FETCHED 
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A1/33) analyzing" + "; path2input4hpu-analyzing-by-fetch2kernel4hpu: " + str(path2input4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #folder2lib4hpu +  hpu2buffer4xi.py ; hpu2dummy4xi5test.cpp 
            
        keys2fetch4hpu = kb2fetch4hpu.keys()
        message2print = "{(Step 2A2/33) using" + "; keys2fetch4hpu-using-by-fetch2kernel4hpu: " + str(keys2fetch4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #        
        ack2match4file = False
        for key2fecth4hpu in keys2fetch4hpu:                                                                        # 1,2 ...
            # -----------------------------------------------------------------------------------------
            # 
            # -----------------------------------------------------------------------------------------
            index2search=str.find(path2input4hpu,kb2fetch4hpu[key2fecth4hpu])                                       
            if index2search == -1:                                         
                # -----------------------------------------------------------------------------------------
                # VALID FILE TYPE BUT NOT SELECTED TO BE FETCHED - OK ONE MAY ALSO PASS HERE!
                # -----------------------------------------------------------------------------------------               
                message2print = "{(Step 2C1/33) skipped" + "; path2input4hpu-skipped-by-fetch2kernel4hpu: " + str(path2input4hpu)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # folder2lib4hpu +  hpu2buffer4xi.py 
                
            else:
                ack2match4file = True
                
                message2print = "{(Step 2D/33) decided" + "; program-to-read-decided-by-fetch2kernel4hpu: " + str(path2input4hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                #folder2lib4hpu +  hpu2sampler4xi5test.py; __pycache__//hpu2sampler4xi.cpython-33.pyc; 
                #               +  hpu2dummy4xi5test.cpp

                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT FILE - READ MODE SET ACCORDING TO FILE TYPE
                # -----------------------------------------------------------------------------------------
                if ((key2extension4hpu == '.py') or (key2extension4hpu == '.cpp') or (key2extension4hpu == '.c') or (key2extension4hpu == '.cl')):
                    file2input4hpu = open(path2input4hpu,'r')
                    message2print = "{(Step 3A/33) opened" + "; file2input4hpu-opened-by-fetch2kernel4hpu: " + str(file2input4hpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # <_io.TextIOWrapper name=folder2lib4hpu + 'hpu2sampler4xi5test.py' mode='r' encoding='cp1252'> 
                     
                if ((key2extension4hpu == '.pyc') or (key2extension4hpu == '.exe')):
                    file2input4hpu = open(path2input4hpu,'rb')
                    message2print = "{(Step 3B/33) opened" + "; file2input4hpu-opened-by-fetch2kernel4hpu: " + str(file2input4hpu) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    #  __pycache__//hpu2sampler4xi.cpython-33.pyc               
                    
                # -----------------------------------------------------------------------------------------
                # (Step 4/33) OF FETCH2SCOPE4XI - OUTPUT 
                # -----------------------------------------------------------------------------------------
                key2save4hpu = path2input4hpu
                fetch2code4hpu[key2save4hpu] = {}                                                                   # fetch2code4hpu['hpu2sampler4xi5test.py'] = {}
                number2line4hpu = 0  
                message2print = "{(Step 3B/33) saving" + "; key2fecth4hpu-saving-by-fetch2kernel4hpu: " + str(key2fecth4hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)              
                # 
         
                while 1:
                    # -------------------------------------------------------------------------------------
                    # (Step 5/33) OF FETCH2SCOPE4XI - PROCESS FILE
                    # -------------------------------------------------------------------------------------             
                    line2process4hpu = file2input4hpu.readline()  
                    if not line2process4hpu:
                        # ---------------------------------------------------------------------------------
                        # (Step 30/33) OF FETCH2SCOPE4XI - ALL LINES READ, FINISH
                        # ---------------------------------------------------------------------------------             
                        break                                               
                    else:
                        # ---------------------------------------------------------------------------------
                        # (Step 7/33) OF FETCH2SCOPE4XI - SAVE LINE
                        # ---------------------------------------------------------------------------------
                        # message2print = "{(Step 7A/33) read" + "; line2process4hpu-read-by-fetch2kernel4hpu: " + str(line2process4hpu) + "; time: " + time4xi() + "}"
                        # print4xi(class2print, method2print, message2print)              
                        # ... profile = "11" />
                        # ...
                        # # end of hpu2sampler4xi5test.py 
                        # #/> 
                        try:
                            number2line4hpu = number2line4hpu + 1
                            fetch2code4hpu[key2save4hpu][number2line4hpu] = line2process4hpu
                        except:
                            message2print = "{(Step 7Z1/33) failed" + "; key2fecth4hpu-failed-by-fetch2kernel4hpu: " + str(key2fecth4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z2/33) failed" + "; line2process4hpu-failed-by-fetch2kernel4hpu: " + str(line2process4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            
                            message2print = "{(Step 7Z3/33) failed" + "; number2line4hpu-failed-by-fetch2kernel4hpu: " + str(number2line4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                                                             
                # -----------------------------------------------------------------------------------------
                # (Step 31/33) OF FETCH2SCOPE4XI - CLOSE INPUT
                # -----------------------------------------------------------------------------------------            
                file2input4hpu.close()
                message2print = "{(Step 31A/33) closed" + "; file2input4hpu-closed-by-fetch2kernel4hpu: " + str(file2input4hpu) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name=folder2lib4hpu + 'hpu2sampler4xi5test.py' mode='r' encoding='cp1252'>     # Python source files
                # {folder2lib4hpu + 'hpu2sampler4xi5test.py': {1: '... profile = "11" />\n', 2: '# -- 
                # hpu2dummy4xi5test.cpp                                                                             # C++ source files
                # __pycache__//hpu2sampler4xi.cpython-33.pyc                                                        # Cached binary files of Python
                # hpu2dummy4xi5test.exe                                                                             # C++ exe files
        
                message2print = "{(Step 31B1/33) saved" + "; fetch2code4hpu-saved-by-fetch2kernel4hpu: " + str(fetch2code4hpu[key2save4hpu] [1]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... profile = "11" />
                
                message2print = "{(Step 31B2/33) saved" + "; fetch2code4hpu-saved-by-fetch2kernel4hpu: " + str(fetch2code4hpu[key2save4hpu] [2]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # hpu2dummy4xi5test.cpp
                
                message2print = "{(Step 31B3/33) saved" + "; fetch2code4hpu-saved-by-fetch2kernel4hpu: " + str(fetch2code4hpu[key2save4hpu] [3]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ... program = "hpu2sampler4xi5test.py">
                
                message2print = "{(Step 31B4/33) saved" + "; fetch2code4hpu-saved-by-fetch2kernel4hpu: " + str(fetch2code4hpu[key2save4hpu] [4]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # ...  abstract = "tests hpu2sampler4xi.py"/>
                                                                 
                # ---------------------------------------------------------------------------------------------
                #
                # ---------------------------------------------------------------------------------------------                                          


    else:
        # -----------------------------------------------------------------------------------------
        # FILE TYPE - NOT IN PROFILE
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 1F/33) skipped" + "; name2program4hpu-skipped-by-fetch2kernel4hpu: " + str(name2program4hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # folder2lib4hpu + '__pycache__//hpu2buffer4xi.cpython-32', '.pyc')
        
        extension2skip = name2program4hpu[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-fetch2kernel4hpu: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # pyc

        message2print = "{(Step 1H/33) returning" + "; fetch2kernel4hpu-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
 
    message2print = "{(Step 1H/33) returning" + "; fetch2kernel4hpu-returning: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)            
    #   
                                            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernel4hpu" usage = "
#
#   ... prepare task4set2kernelws ...    
#
#   response4set2kernel = {} 
#   print('(Step 17F/700) OF HPU2KERNEL4XI5TEST - TRYING TO SET KERNEL: ', set2kernel4hpu)   
#   # 
#   try:                               
#       response4set2kernel = set2kernel4hpu(task4set2kernelws)
#       print('(Step 17G/700) OF HPU2KERNEL4XI5TEST - SET KERNEL: ', response4set2kernel)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL: ', set2kernel4hpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernel4hpu(task4kernelset2hpu=None):

    '''
    sets kernels for HPU
    '''
    global hpu2kernel4xi  
    global folder2lib4hpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernel4hpu"
    method2print = "set2kernel4hpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernel4hpu-started: " + str(set2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernel4hpu at 0x0000000003837948> 
    
    keys2task = task4kernelset2hpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernel4hpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
        
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if hpu2kernel4xi is None:
            hpu2kernel4xi = create2kernel4hpu()                                                                              # INITIALIZE PROGRAM FOR HPU 
            message2print = "{(Step 1C/70) set" + "; hpu2kernel4xi-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4hpu-skipped-by-set2kernel4hpu: " + str(create2kernel4hpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            hpu2kernel4xi = create2kernel4hpu()
            message2print = "{(Step 1E/70) set" + "; hpu2kernel4xi-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            hpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['DATA2CALLBACK'] = task4kernelset2hpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelset2hpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['PLATFORM'] = task4kernelset2hpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2hpu-try-by-set2kernel4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['CONTEXT'] = task4kernelset2hpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernel4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['DEVICE'] = task4kernelset2hpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['CODE2ERROR'] = task4kernelset2hpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['QUEUE'] = task4kernelset2hpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['PIPE'] = task4kernelset2hpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-hpu2kernel4xi-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernel4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['COMMANDQUEUE']  = task4kernelset2hpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernel4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['BUFFER']  = task4kernelset2hpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernel4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['EVENT']  = task4kernelset2hpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'
                    
              
    message2print = "{(Step 31A/70) try" + "; count2py4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4PY                           
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['COUNT4PY']  = task4kernelset2hpu['COUNT4PY']  
 
        message2print = "{(Step 31B/70) set" + "; count2py4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['COUNT4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count2py4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  
                
    message2print = "{(Step 31C/70) try" + "; count2pyc4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31C)  - COUNT4PYC                           
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['COUNT4PYC']  = task4kernelset2hpu['COUNT4PYC']  
 
        message2print = "{(Step 31D/70) set" + "; count2pyc4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['COUNT4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31D-'
    except: 
        message2print = "{(Step 31Z2/70) yielded" + "; count2pyc4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z2-'  
                
    message2print = "{(Step 31E/70) try" + "; count2c4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31E)  - COUNT4C                           
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['COUNT4C']  = task4kernelset2hpu['COUNT4C']  
 
        message2print = "{(Step 31F/70) set" + "; count2c4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['COUNT4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31F-'
    except: 
        message2print = "{(Step 31Z3/70) yielded" + "; count2c4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z3-'                  
                
    message2print = "{(Step 31G/70) try" + "; count2bin4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31G)  - COUNT4BIN                           
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['COUNT4BIN']  = task4kernelset2hpu['COUNT4BIN']  
 
        message2print = "{(Step 31H/70) set" + "; count2bin4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['COUNT4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31H-'
    except: 
        message2print = "{(Step 31Z4/70) yielded" + "; count2bin4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z4-'  
        
    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernel4hpu: " + str(task4kernelset2hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # 
    
    try:            
        # ---------------------------------------------------------------------------------------------
        # (32B) DIRECTORY4PY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        hpu2kernel4xi['DIRECTORY4PY']  = task4kernelset2hpu['DIRECTORY4PY'] 
        
        message2print = "{(Step 32B/70) set" + "; directory2py4hpu-set-by-set2kernelwithdirectory2py4hpu4hpu to: " + str(hpu2kernel4xi['DIRECTORY4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory2py4hpu-yielded-by-set2kernelwithdirectory2py4hpu4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32C) DIRECTORY4PYC - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        hpu2kernel4xi['DIRECTORY4PYC']  = task4kernelset2hpu['DIRECTORY4PYC'] 
        
        message2print = "{(Step 32C/70) set" + "; directory2pyc4hpu-set-by-set2kernelwithdirectory2pyc4hpu4hpu to: " + str(hpu2kernel4xi['DIRECTORY4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32C-'
    except: 
        message2print = "{(Step 32Z2/70) yielded" + "; directory2pyc4hpu-yielded-by-set2kernelwithdirectory2pyc4hpu4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z2-'

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32D) DIRECTORY4C - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        hpu2kernel4xi['DIRECTORY4CPP']  = task4kernelset2hpu['DIRECTORY4CPP'] 
        
        message2print = "{(Step 32D/70) set" + "; directory2c4hpu-set-by-set2kernelwithdirectory2c4hpu4hpu to: " + str(hpu2kernel4xi['DIRECTORY4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32D-'
    except: 
        message2print = "{(Step 32Z3/70) yielded" + "; directory2c4hpu-yielded-by-set2kernelwithdirectory2c4hpu4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z3-' 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32E) DIRECTORY4BIN - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        hpu2kernel4xi['DIRECTORY4BIN']  = task4kernelset2hpu['DIRECTORY4BIN'] 
        
        message2print = "{(Step 32E/70) set" + "; directory2bin4hpu-set-by-set2kernelwithdirectory2bin4hpu4hpu to: " + str(hpu2kernel4xi['DIRECTORY4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '32E-'
    except: 
        message2print = "{(Step 32Z4/70) yielded" + "; directory2bin4hpu-yielded-by-set2kernelwithdirectory2bin4hpu4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z34-'         
                         
    message2print = "{(Step 33A/70) try" + "; code2py4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33B) CODE4PY - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['CODE4PY']  = task4kernelset2hpu['CODE4PY']  
 
        message2print = "{(Step 33B/70) set" + "; code2py4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['CODE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4hpu + 'hpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernel = "hpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code2py4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2py4hpu2nack  = code2py4hpu2nack + '33Z1-'        
                         
    message2print = "{(Step 33C/70) try" + "; code2c4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33C) CODE4C - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['CODE4CPP']  = task4kernelset2hpu['CODE4CPP']  
 
        message2print = "{(Step 33D/70) set" + "; code2c4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['CODE4CPP'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4hpu + 
 
        code2c4hpu2ack  = code2c4hpu2ack + '33D-'
    except: 
        message2print = "{(Step 33Z2/70) yielded" + "; code2c4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2c4hpu2nack  = code2c4hpu2nack + '33Z2-'                     
                         
    message2print = "{(Step 33D/70) try" + "; code2pyc4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4PYC - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['CODE4PYC']  = task4kernelset2hpu['CODE4PYC']  
 
        message2print = "{(Step 33E/70) set" + "; code2pyc4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['CODE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4hpu + 
 
        code2pyc4hpu2ack  = code2pyc4hpu2ack + '33E-'
    except: 
        message2print = "{(Step 33Z3/70) yielded" + "; code2pyc4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2pyc4hpu2nack  = code2pyc4hpu2nack + '33Z3-'        
                         
    message2print = "{(Step 33F/70) try" + "; code2bin4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33D) CODE4BIN - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['CODE4BIN']  = task4kernelset2hpu['CODE4BIN']  
 
        message2print = "{(Step 33G/70) set" + "; code2bin4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['CODE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4hpu + 
 
        code2bin4hpu2ack  = code2bin4hpu2ack + '33G-'
    except: 
        message2print = "{(Step 33Z4/70) yielded" + "; code2bin4hpu-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2bin4hpu2nack  = code2bin4hpu2nack + '33Z4-'                
                
    message2print = "{(Step 34A/70) try" + "; size2py4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34B) SIZE4PY - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['SIZE4PY']  = task4kernelset2hpu['SIZE4PY']  
 
        message2print = "{(Step 34B/70) set" + "; size2py4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4PY'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size2py4hpu-yielded-by-set2kernel4hpu: " + str(task4kernelset2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 34C/70) try" + "; size2c4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34C) SIZE4C - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['SIZE4C']  = task4kernelset2hpu['SIZE4C']  
 
        message2print = "{(Step 34D/70) set" + "; size2c4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4C'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34D-'
    except: 
        message2print = "{(Step 34Z2/70) yielded" + "; size2c4hpu-yielded-by-set2kernel4hpu: " + str(task4kernelset2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z2-'
                
    message2print = "{(Step 34E/70) try" + "; size2pyc4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34E) SIZE4PYC - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['SIZE4PYC']  = task4kernelset2hpu['SIZE4PYC']  
 
        message2print = "{(Step 34F/70) set" + "; size2pyc4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4PYC'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34F-'
    except: 
        message2print = "{(Step 34Z3/70) yielded" + "; size2pyc4hpu-yielded-by-set2kernel4hpu: " + str(task4kernelset2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z3-'          
                
    message2print = "{(Step 34G/70) try" + "; size2bin4hpu-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34G) SIZE4BIN - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['SIZE4BIN']  = task4kernelset2hpu['SIZE4BIN']  
 
        message2print = "{(Step 34H/70) set" + "; size2bin4hpu-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['SIZE4BIN'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34H-'
    except: 
        message2print = "{(Step 34Z4/70) yielded" + "; size2bin4hpu-yielded-by-set2kernel4hpu: " + str(task4kernelset2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z4-'  
        
    
                                  
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE (DICTIONARY) - REQUIRED                     
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['LANGUAGE']  = task4kernelset2hpu['LANGUAGE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['LANGUAGE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernel4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['COUNT2REFERENCE']  = task4kernelset2hpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernel4hpu to: " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernel4hpu = hpu2kernel4xi.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4hpu-returning-by-set2kernel4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return hpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2kernelarg4hpu" usage = "
#
#   ... prepare task4set2kernelargws ...    
#
#   response4set2kernelarg = {} 
#   print('(Step 17F/700) OF HPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS : ', set2kernelarg4hpu)   
#   # <function set2kernelarg4hpu at 0x0000000003837948>
#   try:                               
#       response4set2kernel = set2kernelarg4hpu(task4set2kernelargws)
#       print('(Step 17G/700) OF HPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS: ', set2kernelarg4hpu)                                                                                                           
#   except:
#       print('(Step 17Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS: ', set2kernelarg4hpu)  
#
#">

# -------------------------------------------------------------------------------------------------   
def set2kernelarg4hpu(task4kernelargset2hpu=None):

    '''
    sets kernel arguments for HPU
    '''
    global hpu2kernel4xi  
    global folder2lib4hpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2kernelarg4hpu"
    method2print = "set2kernelarg4hpu" 

    message2print = "{(Step 1A/33) started" + "; set2kernelarg4hpu-started: " + str(set2kernelarg4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # <function set2kernelarg4hpu at 0x0000000003837948> 
    
    keys2task = task4kernelargset2hpu.keys()
    for key2task in sorted(keys2task):
        message2print = "{(Step 1B/33) passed" + "; key2task-passed-to-set2kernelarg4hpu: " + str(key2task) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # 
          
    code2ack  = ' '
    code2nack = ' '
    # -----------------------------------------------------------------------------------------
    # CREATE IF NECESSARY       
    # ----------------------------------------------------------------------------------------- 
    try:
        if hpu2kernel4xi is None:
            hpu2kernel4xi = create2kernel4hpu()                                                                              # INITIALIZE PROGRAM FOR HPU 
            message2print = "{(Step 1C/70) set" + "; hpu2kernel4xi-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        else:
            message2print = "{(Step 1D/70) skipped" + "; create2kernel4hpu-skipped-by-set2kernelarg4hpu: " + str(create2kernel4hpu) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #                                 
    except:
        try:
            hpu2kernel4xi = create2kernel4hpu()
            message2print = "{(Step 1E/70) set" + "; hpu2kernel4xi-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            #             
        except:
            hpu2kernel4xi = {}
            message2print = "{(Step 1Z/70) yielded" + "; hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '1Z-' 
                
    # ---------------------------------------------------------------------------------------------
    # SET       
    # ---------------------------------------------------------------------------------------------     
    message2print = "{(Step 22A0/70) try" + "; data2callback-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    #     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 21A/70) - DATA2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['DATA2CALLBACK'] = task4kernelargset2hpu['DATA2CALLBACK']
                                        
        message2print = "{(Step 21A1/70) set" + "; data2callback-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['DATA2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        
        code2ack  = code2ack + '21A1-'
    except: 
        message2print = "{(Step 21Z1/70) yielded" + "; data2callback-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '21Z1-'
    
    message2print = "{(Step 22B0/70) try" + "; function2callback-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22B/70) - FUNCTION2CALLBACK - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['FUNCTION2CALLBACK'] = task4kernelargset2hpu['FUNCTION2CALLBACK']
        
        message2print = "{(Step 22B1/70) set" + "; function2callback-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['FUNCTION2CALLBACK'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #  
        code2ack  = code2ack + '22B1-'
    except: 
        message2print = "{(Step 22Z2/70) yielded" + "; function2callback-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '22Z2-' 
    
    message2print = "{(Step 22C0/70) try" + "; platform2callback-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    # 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 22C/70) - PLATFORM - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['PLATFORM'] = task4kernelargset2hpu['PLATFORM']
        
        message2print = "{(Step 2C1/70) set" + "; platform-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['PLATFORM'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #   
        code2ack  = code2ack + '2C1-'
    except: 
        message2print = "{(Step 22Z3/70) yielded" + "; platform-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # yielded
        code2nack  = code2nack + '22Z3-' 
        
        
      
    message2print = "{(Step 23A/70) try" + "; context2hpu-try-by-set2kernelarg4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 23/70) - CONTEXT - REQUIRED
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['CONTEXT'] = task4kernelargset2hpu['CONTEXT']
        
        message2print = "{(Step 23B/70) set" + "; context-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['CONTEXT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '23B-'
    except: 
        message2print = "{(Step 23Z1/70) yielded" + "; context-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
    
        code2nack  = code2nack + '23Z1-' 
        
    message2print = "{(Step 24A/70) try" + "; device-try-by-set2kernelarg4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)    
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 24/70) - DEVICE - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['DEVICE'] = task4kernelargset2hpu['DEVICE']
        
        message2print = "{(Step 24B/70) set" + "; device-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['DEVICE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        
        code2ack  = code2ack + '24B-'
    except: 
        message2print = "{(Step 24Z1/70) yielded" + "; device-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '24Z1-'
                 
    message2print = "{(Step 25A/70) try" + "; code2error-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 25/70) - ERROR CODE - REQUIRED
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['CODE2ERROR'] = task4kernelargset2hpu['CODE2ERROR']
        
        message2print = "{(Step 25B/70) set" + "; code2error-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['CODE2ERROR'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
        
        code2ack  = code2ack + '25B-'
    except: 
        message2print = "{(Step 25Z1/70) yielded" + "; code2error-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '25Z1-'                
                
          
    message2print = "{(Step 26A/70) try" + "; queue-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 26/70) - QUEUE - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['QUEUE'] = task4kernelargset2hpu['QUEUE']
        
        message2print = "{(Step 26B/70) set" + "; queue-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['QUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '26B-'
    except: 
        message2print = "{(Step 26Z1/70) yielded" + "; queue-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '26Z1-' 
                                
    message2print = "{(Step 27A/70) try" + "; pipe-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                     
    try:
        # -----------------------------------------------------------------------------------------
        # (Step 27/70) - PIPE - EXTRA
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['PIPE'] = task4kernelargset2hpu['PIPE']
        
        message2print = "{(Step 27B/70) set" + "; pipe-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['PIPE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        code2ack  = code2ack + '27B-'
    except: 
        message2print = "{(Step 27Z1/70) yielded" + "; pipe-hpu2kernel4xi-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '27Z1-'   

    message2print = "{(Step 28A/70) try" + "; commandqueue-try-by-set2kernelarg4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (28) COMMAND QUEUE - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['COMMANDQUEUE']  = task4kernelargset2hpu['COMMANDQUEUE']  
 
        message2print = "{(Step 28B/70) set" + "; commandqueue-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['COMMANDQUEUE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        code2ack  = code2ack + '28B-'
    except: 
        message2print = "{(Step 28Z1/70) yielded" + "; commandqueue-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '28Z1-'    

    message2print = "{(Step 29A/70) try" + "; bufferinfo-try-by-set2kernelarg4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (29) BUFFER INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['BUFFER']  = task4kernelargset2hpu['BUFFER']  
 
        message2print = "{(Step 29B/70) set" + "; bufferinfo-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['BUFFER'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #  
        code2ack  = code2ack + '29B-'
    except: 
        message2print = "{(Step 29Z1/70) yielded" + "; bufferinfo-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        code2nack  = code2nack + '29Z1-'            

    message2print = "{(Step 30A/70) try" + "; eventinfo-try-by-set2kernelarg4hpu: {}" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) EVENT INFO - EXTRA                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['EVENT']  = task4kernelargset2hpu['EVENT']  
 
        message2print = "{(Step 30B/70) set" + "; eventinfo-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['EVENT'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '30B-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; eventinfo-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '30Z1-'            
                
    message2print = "{(Step 31A/70) try" + "; count4source-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (31)  - COUNT4SOURCE                           
        # ---------------------------------------------------------------------------------------------             
        hpu2kernel4xi['COUNT4SOURCE']  = task4kernelargset2hpu['COUNT4SOURCE']  
 
        message2print = "{(Step 31B/70) set" + "; count4source-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['COUNT4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 1
        code2ack  = code2ack + '31B-'
    except: 
        message2print = "{(Step 31Z1/70) yielded" + "; count4source-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '31Z1-'  

    message2print = "{(Step 32A/70) try" + "; directory-try-by-set2kernelarg4hpu: " + str(task4kernelargset2hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
    # {'CODE2ERROR': 0 ... 'DIRECTORY4SOURCE': '...//a' ... 

    try:            
        # ---------------------------------------------------------------------------------------------
        # (32) DIRECTORY - REQUIRED                     
        # ---------------------------------------------------------------------------------------------                                    
        hpu2kernel4xi['DIRECTORY4SOURCE']  = task4kernelargset2hpu['DIRECTORY4SOURCE'] 
        
        message2print = "{(Step 32B/70) set" + "; directory-set-by-set2kernelargwithdirectory4hpu to: " + str(hpu2kernel4xi['DIRECTORY4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK
        code2ack  = code2ack + '32B-'
    except: 
        message2print = "{(Step 32Z1/70) yielded" + "; directory-yielded-by-set2kernelargwithdirectory4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '32Z1-' 
        
    message2print = "{(Step 33A/70) try" + "; code-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (33) CODE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['CODE4SOURCE']  = task4kernelargset2hpu['CODE4SOURCE']  
 
        message2print = "{(Step 33B/70) set" + "; code-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['CODE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # {folder2lib4hpu + 'hpu2image4xi5test.py': 
        #  {1: '... profile = "11" />\n', 
        #   2: '... kernelarg = "hpu2image4xi5test.py">\n'}
 
        code2ack  = code2ack + '33B-'
    except: 
        message2print = "{(Step 33Z1/70) yielded" + "; code-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '33Z1-'             
        
    message2print = "{(Step 34A/70) try" + "; size-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (34) SIZE - REQUIRED                         
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['SIZE4SOURCE']  = task4kernelargset2hpu['SIZE4SOURCE']  
 
        message2print = "{(Step 34B/70) set" + "; size-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['SIZE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '34B-'
    except: 
        message2print = "{(Step 34Z1/70) yielded" + "; size-yielded-by-set2kernelarg4hpu: " + str(task4kernelargset2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '34Z1-'    
                
    message2print = "{(Step 35A/70) try" + "; language-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (35) LANGUAGE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['LANGUAGE4SOURCE']  = task4kernelargset2hpu['LANGUAGE4SOURCE']  
 
        message2print = "{(Step 35B/70) set" + "; language-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['LANGUAGE4SOURCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '35B-'
    except: 
        message2print = "{(Step 35Z1/70) yielded" + "; language-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '35Z1-'          
                        
    message2print = "{(Step 36A/70) try" + "; count2reference-try-by-set2kernelarg4hpu: None" + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    try:            
        # ---------------------------------------------------------------------------------------------
        # (36) COUNT2REFERENCE - REQUIRED                              
        # ---------------------------------------------------------------------------------------------             
                        
        hpu2kernel4xi['COUNT2REFERENCE']  = task4kernelargset2hpu['COUNT2REFERENCE']  
 
        message2print = "{(Step 36B/70) set" + "; count2reference-set-by-set2kernelarg4hpu to: " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        code2ack  = code2ack + '36B-'
    except: 
        message2print = "{(Step 36Z1/70) yielded" + "; count2reference-yielded-by-set2kernelarg4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
        
        code2nack  = code2nack + '36Z1-'                           

    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack 
    
     
    keys2kernelarg4hpu = hpu2kernel4xi.keys()
    for key2kernelarg4hpu in keys2kernelarg4hpu:
        message2print = "{(Step 70/70) returning" + "; key2kernelarg4hpu-returning-by-set2kernelarg4hpu: " + str(key2kernelarg4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 

    return hpu2kernel4xi

           
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "release2kernel4hpu" usage = "
#
#   task4release2kernel  = {} 
#   task4release2kernel  ['COUNT2REFERENCE'] = 1 
#   response4release2kernel = {}
#   
#   print('(Step 18A/700) OF HPU2KERNEL4XI5TEST - TRYING TO RELEASE KERNEL OF HPU DEVICE ', time4xi())    
#   try:                               
#       response4release2kernel = release2kernel4hpu(task4release2kernel)
#       print('(Step 18B/700) OF HPU2KERNEL4XI5TEST - RELEASED KERNEL OF HPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 18Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL OF HPU DEVICE ', time4xi())                                                                                                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def release2kernel4hpu(task4release2hpu=None):

    '''
    releases kernel for HPU
    '''
    global hpu2kernel4xi  
    global folder2lib4hpu  
        
    # -----------------------------------------------------------------------------------------
    # (Step 1/33) PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "release2kernel4hpu"
    method2print = "release2kernel4hpu" 

    message2print = "{(Step 1A/33) started" + "; release2kernel4hpu-started: " + str(release2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4release2hpu-to-release2kernel4hpu: " + str(task4release2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    

    code2ack  = ' '
    code2nack = ' '

    try:
        if hpu2kernel4xi is None:
            hpu2kernel4xi = create2kernel4hpu()                                                                       # INITIALIZE KERNEL                 
    except:
        try:
            hpu2kernel4xi = create2kernel4hpu()
        except:
            hpu2kernel4xi = {}
            message2print = "{(Step 2Z0/70) yielded" + "; hpu2kernel4xi-yielded-by-release2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '2Z0-' 
                
    message2print = "{(Step 1A/70) try" + "; release-try-by-release2kernel4hpu: None"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    if task4release2hpu is None:
        task4release2hpu = {}
        task4release2hpu['COUNT2REFERENCE'] = 1
           
    try:
        # -----------------------------------------------------------------------------------------
        # RELEASE
        # -----------------------------------------------------------------------------------------               
        hpu2kernel4xi['COUNT2REFERENCE'] = hpu2kernel4xi['COUNT2REFERENCE'] - task4release2hpu['COUNT2REFERENCE']
        
        message2print = "{(Step 1A/70) calculated" + "; count2reference-calculated-by-release2kernel4hpu: " + str(hpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        if hpu2kernel4xi['COUNT2REFERENCE'] < 0:
            hpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 1B/70) warning" + "; count2reference-warning-by-release2kernel4hpu: " + " ** " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            # 
             
            code2nack  = code2nack + '1B-'
        else:
            code2ack  = code2ack + '1B-'
    except:
        try:
            hpu2kernel4xi['COUNT2REFERENCE'] = 0
            
            message2print = "{(Step 8Z1/70) warning" + "; count2reference-warning-by-release2kernel4hpu: " + " ** " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # 
            code2nack  = code2nack + '8Z1-'
            
        except:
            message2print = "{(Step 8Z2/70) yielded" + "; hpu2kernel4xi-yielded-by-release2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '8Z2-'
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    keys2program4hpu = hpu2kernel4xi.keys()
    for key2program4hpu in keys2program4hpu:
        message2print = "{(Step 70/70) returning" + "; key2program4hpu-returning-by-release2kernel4hpu: " + str(key2program4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return hpu2kernel4xi

#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "retain2kernel4hpu" usage = "
#
#   task4retain2kernel  = {} 
#   task4retain2kernel  ['COUNT2REFERENCE'] = 1 
#   response4retain2kernel = {}
#   
#   print('(Step 19A/700) OF HPU2KERNEL4XI5TEST - TRYING TO RETAIN PROGRAM OF HPU DEVICE ', time4xi())    
#   # 
#   try:                               
#       response4retain2kernel = retain2kernel4hpu(task4retain2kernel)
#       print('(Step 19B/700) OF HPU2KERNEL4XI5TEST - RETAINED PROGRAM OF HPU DEVICE ', time4xi()) 
#   except:
#       print('(Step 19Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO RETAIN PROGRAM OF HPU DEVICE ', time4xi())                                                                                                  
#
#">

# -------------------------------------------------------------------------------------------------   
def retain2kernel4hpu(task4retain2hpu=None):

    '''
    retains kernel of HPU
    '''
    global hpu2kernel4xi 
    global folder2lib4hpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "retain2kernel4hpu"
    method2print = "retain2kernel4hpu"

    message2print = "{(Step 1A/33) started" + "; retain2kernel4hpu-started: " + str(retain2kernel4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                                     #  
    # 
    
    
    message2print = "{(Step 1B/33) passed" + "; task4retain2hpu-to-retain2kernel4hpu: " + str(task4retain2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 
    
    code2ack  = ' '
    code2nack = ' '
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/70) - PROVIDE TASKS, IF NECESSARY AND CHECK GIVEN TASKS 
    # -----------------------------------------------------------------------------------------    
    if task4retain2hpu is None:
        task4retain2hpu = {}
        task4retain2hpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 2A/33) set" + "; task4retain2hpu-set-by-retain2kernel4hpu to: " + str(task4retain2hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
    else:
        pass

    
    # -----------------------------------------------------------------------------------------
    # (Step 3/70) - CHECK COUNT2REFERENCE
    # -----------------------------------------------------------------------------------------         
    if 'COUNT2REFERENCE' in task4retain2hpu.keys():
        pass
    else:
        task4retain2hpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3A/33) set" + "; count2reference-set-by-retain2kernel4hpu to: " + str(task4retain2hpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
                                   
    if task4retain2hpu['COUNT2REFERENCE'] < 1:
        task4retain2hpu['COUNT2REFERENCE'] = 1
        message2print = "{(Step 3B/33) set" + "; count2reference-set-by-retain2kernel4hpu to: " + str(task4retain2hpu['COUNT2REFERENCE'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #           
        
    # -----------------------------------------------------------------------------------------
    # (Step 4/70) - INITIALIZE PROGRAM IF NECESSARY
    # -----------------------------------------------------------------------------------------
    try:
        if hpu2kernel4xi is None:
            hpu2kernel4xi = create2kernel4hpu()
            message2print = "{(Step 4A/70) created" + "; hpu2kernel4xi-created-by-retain2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                                                                          
    except:
        try:
            hpu2kernel4xi = create2kernel4hpu()
            message2print = "{(Step 4B/70) created" + "; hpu2kernel4xi-created-by-retain2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
        except:
            hpu2kernel4xi = {}
            message2print = "{(Step 4Z/70) yielded" + "; hpu2kernel4xi-yielded-by-retain2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '4Z-' 


    # -----------------------------------------------------------------------------------------
    # (Step 5/70) - RETAIN
    # -----------------------------------------------------------------------------------------             
    try:
        hpu2kernel4xi['COUNT2REFERENCE'] = hpu2kernel4xi['COUNT2REFERENCE'] + task4retain2hpu['COUNT2REFERENCE']
        message2print = "{(Step 6A/70) calculated" + "; count2reference-calculated-by-retain2kernel4hpu: " + str(hpu2kernel4xi['COUNT2REFERENCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 1            
        if hpu2kernel4xi['COUNT2REFERENCE'] <= 0:
            hpu2kernel4xi['COUNT2REFERENCE'] = 1
            message2print = "{(Step 6Z1/70) warning" + "; count2reference-warning-by-retain2kernel4hpu: " + " ** " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            code2nack  = code2nack + '6Z1-'
        else:
            code2ack  = code2ack + '6C-'

    except:
        try:
            hpu2kernel4xi['COUNT2REFERENCE'] = 1
        
            message2print = "{(Step 7Z1/70) warning" + "; count2reference-warning-by-retain2kernel4hpu: " + " ** " + str(hpu2kernel4xi['COUNT2REFERENCE'])  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            code2nack  = code2nack + '7Z1-'
        
        except:
            message2print = "{(Step 7Z2/70) yielded" + "; hpu2kernel4xi-yielded-by-retain2kernel4hpu: " + str(hpu2kernel4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
            code2nack  = code2nack + '7Z2-'
        
                                                                                          
            
    # -----------------------------------------------------------------------------------------
    # (Step 70/70) - RETURN           
    # -----------------------------------------------------------------------------------------
    
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack     
     
    keys2program4hpu = hpu2kernel4xi.keys()
    for key2program4hpu in keys2program4hpu:
        message2print = "{(Step 70/70) returning" + "; key2program4hpu-returning-by-retain2kernel4hpu: " + str(key2program4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
    
    return hpu2kernel4xi

#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelinfo4hpu" usage = "
#
#   print('(Step 3B1/700) OF HPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFORMATION FOR HPU ', time4xi())     
#   try:
#       response4kernelinfo2hpu = get2kernelinfo4hpu() 
#       print('(Step 3B2/700) OF HPU2KERNEL4XI5TEST - GOT KERNEL INFORMATION FOR HPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF HPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFORMATION FOR HPU', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelinfo4hpu(task4getinfo2kernel=None):

    '''
    gets kernel information of HPU
    '''
    
    global hpu2kernel4xi
    global folder2lib4hpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelinfo4hpu"
    method2print = "get2kernelinfo4hpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelinfo4hpu-started: " + str(get2kernelinfo4hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelinfo4hpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    hpu2kernel = {}
    try: 
        if hpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR HPU           
            # -------------------------------------------------------------------------------------           
            hpu2kernel = create2kernel4hpu()
            message2print = "{(Step 1B2/33) initialized" + "; hpu2kernel-initialized-by-get2kernelinfo4hpu to: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; hpu2kernel4xi-using-by-get2kernelinfo4hpu: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF HPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            hpu2kernel = hpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; hpu2kernel-got-by-get2kernelinfo4hpu: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF HPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4hpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                hpu2kernel [key2task] = hpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-hpu2kernel-set-by-get2kernelinfo4hpu to: " + str(hpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4hpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4hpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; hpu2kernel4xi-using-by-get2kernel4hpu: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            hpu2kernel = create2kernel4hpu()
            
            message2print = "{(Step 1F/33) initialized" + "; hpu2kernel-initialized-by-get2kernelinfo4hpu to: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                hpu2kernel = hpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; hpu2kernel-set-by-get2kernelinfo4hpu to: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4hpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        hpu2kernel [key2task] = hpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-hpu2kernel -set-by-get2kernelinfo4hpu to: " + str(hpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4hpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            hpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; hpu2kernel-yielded-by-get2kernel4hpu: " + str(hpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4hpu = hpu2kernel4xi.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4hpu-returning-by-get2kernelinfo4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # CODE2ERROR ...
        
    return hpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelarginfo4hpu" usage = "
#
#   print('(Step 3B1/700) OF HPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENTGS INFO FOR HPU ', time4xi())     
#   try:
#       response4kernelinfo2hpu = get2kernelarginfo4hpu(task4getinfo2kernel) 
#       print('(Step 3B2/700) OF HPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENTGS INFO FOR HPU ', time4xi())
#   except:
#       print('(Step 3Z3/700) OF HPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENTGS INFO FOR HPU ', time4xi())                  
#   
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelarginfo4hpu(task4getinfo2kernel=None):

    '''
    gets kernel argument information of HPU
    '''
    
    global hpu2kernel4xi
    global folder2lib4hpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelarginfo4hpu"
    method2print = "get2kernelarginfo4hpu"

    message2print = "{(Step 0A/33) started" + "; get2kernelarginfo4hpu-started: " + str(get2kernelarginfo4hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2kernel-passed-to-get2kernelarginfo4hpu: " + str(task4getinfo2kernel) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    hpu2kernel = {}
    try: 
        if hpu2kernel4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR HPU           
            # -------------------------------------------------------------------------------------           
            hpu2kernel = create2kernel4hpu()
            message2print = "{(Step 1B2/33) initialized" + "; hpu2kernel-initialized-by-get2kernelarginfo4hpu to: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; hpu2kernel4xi-using-by-get2kernelarginfo4hpu: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF HPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2kernel is None:
            task4getinfo2kernel = {}
            hpu2kernel = hpu2kernel4xi
            message2print = "{(Step 1C/33) using" + "; hpu2kernel-got-by-get2kernelarginfo4hpu: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4kernelinfo = task4getinfo2kernel.keys()
        keys2task = task4getinfo2kernel.keys()
            
        # -------------------------------------------------------------------------------------
        # SOURCE OR BINARY PROGRAM INFO OF HPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2kernel4hpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                hpu2kernel [key2task] = hpu2kernel4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-hpu2kernel-set-by-get2kernelarginfo4hpu to: " + str(hpu2kernel [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2kernel4hpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2kernel-using-by-get2kernel4hpu: " + str(task4getinfo2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; hpu2kernel4xi-using-by-get2kernel4hpu: " + str(hpu2kernel4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE PROGRAM WITH SOURCE DATA           
            # -------------------------------------------------------------------------------------           
            hpu2kernel = create2kernel4hpu()
            
            message2print = "{(Step 1F/33) initialized" + "; hpu2kernel-initialized-by-get2kernelarginfo4hpu to: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2kernel is None:
                hpu2kernel = hpu2kernel4xi
                message2print = "{(Step 1G/33) set" + "; hpu2kernel-set-by-get2kernelarginfo4hpu to: " + str(hpu2kernel)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2kernel.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2kernel4hpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        hpu2kernel [key2task] = hpu2kernel4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-hpu2kernel -set-by-get2kernelarginfo4hpu to: " + str(hpu2kernel  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2kernel4hpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            hpu2kernel = {}
            message2print = "{(Step 1Z3/70) yielded" + "; hpu2kernel-yielded-by-get2kernel4hpu: " + str(hpu2kernel) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
     
    keys2kernel4hpu = hpu2kernel4xi.keys()
    for key2kernel4hpu in keys2kernel4hpu:
        message2print = "{(Step 70/70) returning" + "; key2kernel4hpu-returning-by-get2kernelarginfo4hpu: " + str(key2kernel4hpu) + "; time: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)
        # 
        
    return hpu2kernel
            
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2buildinfo4hpu" usage = "
#
#   response4get2buildinfo = get2buildinfo4hpu()
#            
#">

# -------------------------------------------------------------------------------------------------   
def get2buildinfo4hpu(task4getinfo2build=None):

    '''
    gets hpu2build4xi and hpu2build4xi
    '''
    
    global hpu2build4xi
    global folder2lib4hpu  
    
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/33)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2buildinfo4hpu"
    method2print = "get2buildinfo4hpu"

    message2print = "{(Step 0A/33) started" + "; get2buildinfo4hpu-started: " + str(get2buildinfo4hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # 
                                                                
    
    message2print = "{(Step 0B/33) passed" + "; task4getinfo2build-passed-to-get2buildinfo4hpu: " + str(task4getinfo2build) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # 
    
    
    hpu2build = {}
    try: 
        if hpu2build4xi is None:
            # -------------------------------------------------------------------------------------
            # INITIALIZE SOURCE DATA FOR PROGRAM FOR HPU           
            # -------------------------------------------------------------------------------------           
            hpu2build = {}
            message2print = "{(Step 1B2/33) initialized" + "; hpu2build-initialized-by-get2buildinfo4hpu to: " + str(hpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
        else:
            message2print = "{(Step 1B3/33) using" + "; hpu2build4xi-using-by-get2buildinfo4hpu: " + str(hpu2build4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # 
            
        # -------------------------------------------------------------------------------------
        # RETURN THE WHOLE OR PART OF PROGRAM INFO OF HPU          
        # -------------------------------------------------------------------------------------     
        if task4getinfo2build is None:
            task4getinfo2build = {}
            hpu2build = hpu2build4xi
            message2print = "{(Step 1C/33) using" + "; hpu2build-got-by-get2buildinfo4hpu: " + str(hpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
        else:
            pass    

        keys2task4buildinfo = task4getinfo2build.keys()
        keys2task = task4getinfo2build.keys()
            
        # -------------------------------------------------------------------------------------
        # BUILD INFO OF HPU          
        # -------------------------------------------------------------------------------------         
        for key2task in keys2task:
            try:
                message2print = "{(Step 2D2/33) using" + "; key2task-using-by-get2build4hpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                 
                hpu2build [key2task] = hpu2build4xi[key2task]
                
                message2print = "{(Step 2D3/33) set" + "; info-of-hpu2build-set-by-get2buildinfo4hpu to: " + str(hpu2build [key2task])  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            except:
                message2print = "{(Step 2Z/70) yielded" + "; key2task-yielded-by-get2build4hpu: " + str(key2task) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                               
                # 
                                   
                message2print = "{(Step 2Z2/70) using" + "; task4getinfo2build-using-by-get2build4hpu: " + str(task4getinfo2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)  
                # 
                
                message2print = "{(Step 2Z3/70) using" + "; hpu2build4xi-using-by-get2build4hpu: " + str(hpu2build4xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 

    except:
        try:
            # -------------------------------------------------------------------------------------
            # INITIALIZE BUILD           
            # -------------------------------------------------------------------------------------           
            hpu2build = {}
            message2print = "{(Step 1F/33) initialized" + "; hpu2build-initialized-by-get2buildinfo4hpu to: " + str(hpu2build)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            if task4getinfo2build is None:
                hpu2build = hpu2build4xi
                message2print = "{(Step 1G/33) set" + "; hpu2build-set-by-get2buildinfo4hpu to: " + str(hpu2build)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
                 
            else:
                keys2task = task4getinfo2build.keys()
                for key2task in keys2task:
                    try:
                        message2print = "{(Step HD2/33) using" + "; key2task-using-by-get2build4hpu: " + str(key2task)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # 
                        hpu2build [key2task] = hpu2build4xi[key2task]
                    
                        message2print = "{(Step HD2/33) set" + "; info-of-hpu2build -set-by-get2buildinfo4hpu to: " + str(hpu2build  [key2task])  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #   
                    except:
                        message2print = "{(Step HZ/70) yielded" + "; key2task-yielded-by-get2build4hpu: " + str(key2task) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                                                                            
        except:
            hpu2build = {}
            message2print = "{(Step 1Z3/70) yielded" + "; hpu2build-yielded-by-get2build4hpu: " + str(hpu2build) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)  
                        
    message2print = "{(Step 33/33) returning" + "; hpu2build-returning-by-get2buildinfo4hpu: " + str(hpu2build) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)
    # 
    
    return hpu2build
            
#</function4xi> 


# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2kernelworkgroupinfo4hpu" usage = "
#     
#   print('(Step 2AB2/700) OF HPU2KERNEL4XI5TEST - TRYING TO GET KERNEL WORK GROUP INFORMATION ', time4xi())           
#   try:
#       response4link = get2kernelworkgroupinfo4hpu()
#       print('(Step 2BB2/700) OF HPU2KERNEL4XI5TEST - GOT KERNEL WORK GROUP INFORMATION ', time4xi()) 
#   except:
#       print('(Step 2Z2/700) OF HPU2KERNEL4XI5TEST *** FAILED TO KERNEL WORK GROUP INFORMATION ', time4xi())                                                                     
#          
#">

# -------------------------------------------------------------------------------------------------   
def get2kernelworkgroupinfo4hpu(task4kernelworkgroupinfo2hpu=None):

    '''
    gets kernel workgroup info of HPU
    '''
    global hpu2kernel4xi                                                                                            # Kernel of HPU    
    global import2use4hpu                                                                                           # Imports of HPU
    global target2function4hpu                                                                                      # Target function of Process4Xi
    global folder2lib4hpu  
            
    # -----------------------------------------------------------------------------------------
    # (Step 1/70) - CHECK PARAMETERS           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2kernelworkgroupinfo4hpu" 
    method2print = "get2kernelworkgroupinfo4hpu"

    message2print = "{(Step 1A/70) started" + "; get2kernelworkgroupinfo4hpu-started: " + str(get2kernelworkgroupinfo4hpu)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)
    # 
  
             
    message2print = "{(Step 1B/70) passed" + "; task4kernelworkgroupinfo2hpu-to-get2kernelworkgroupinfo4hpu: " + str(task4kernelworkgroupinfo2hpu) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              
    # 

    code2ack  = ' '
    code2nack = ' '    
    
    process2kernelworkgroupinfo4hpu = {}                                                                                       # INITIALIZES TO EMPTY DICTIONARY
               
    try:             
        if task4kernelworkgroupinfo2hpu is None:
            # -----------------------------------------------------------------------------------------
            # NO PARAMETERS GIVEN BY CALLER
            # -----------------------------------------------------------------------------------------    
            pass                                                                       
        else:
            # -----------------------------------------------------------------------------------------
            # PARAMETERS GIVEN ARE OMITTED 
            # -----------------------------------------------------------------------------------------         
            pass                                                                                                    # PARAMETER DATA RECEIVED                       
    except: 
        message2print = "{(Step 1Z1/70) yielded" + "; task4kernelworkgroupinfo2hpu-yielded-by-get2kernelworkgroupinfo4hpu: " + str(task4kernelworkgroupinfo2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 
       
        code2nack  = code2nack + '1Z1-' 

    
    # ---------------------------------------------------------------------------------------------
    # (Step 20A/70) - LINK SOURCES INSIDE PROGRAM OBJECT FOR HPU ! 
    # ---------------------------------------------------------------------------------------------    
    process2kernelworkgroupinfo4hpu = {}                                                                                                                                                                               
    message2print = "{(Step 20A/70) initialized" + "; process2kernelworkgroupinfo4hpu-initialized-by-get2kernelworkgroupinfo4hpu to: " + str(process2kernelworkgroupinfo4hpu)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    # {}

    try:            
        # ---------------------------------------------------------------------------------------------
        # (30) - SOURCE CODE WITHOUT EOL CHARACTERS                  
        # ---------------------------------------------------------------------------------------------             
        keys2code4hpu = hpu2kernel4xi['CODE4SOURCE'].keys()
        message2print = "{(Step 30A/70) using" + "; keys2code4hpu-using-by-get2kernelworkgroupinfo4hpu: " + str(keys2code4hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # dict_keys([folder2lib4hpu + 'hpu2sampler4xi5test.py'])
        
        unit4processing = "hpu"
        
        for key2code4hpu in keys2code4hpu:
            index2search=str.find(key2code4hpu,unit4processing) 
            if index2search == -1:
                pass
            else:
                target2link = key2code4hpu[index2search:]                                                          # hpu2sampler4xi5test.py
                index2search=str.find(target2link,".py")
                if index2search == -1:
                    pass
                else:
                    target2link4hpu = target2link[:index2search]                                                  
                    message2print = "{(Step 32A/70) set" + "; target2link4hpu-set-by-get2kernelworkgroupinfo4hpu to: " + str(target2link4hpu)  + "; time: " + time4xi() + "}"  
                    print4xi(class2print, method2print, message2print)
                    # hpu2sampler4xi5test

                    p2code4hpu = None    
                    try:
                        # ---------------------------------------------------------------------------------------------    
                        # IMPORT TARGET FUNCTION FROM ITS MODULE AS TARGET2FUNCTION4HPU 
                        # ---------------------------------------------------------------------------------------------    
      
                        try:
                            import2use4hpu.get(target2link4hpu, handle2error4hpu) ()
                            
                            message2print = "{(Step 32B/70) imported" + "; target2link4hpu-imported-by-get2kernelworkgroupinfo4hpu: " + str(target2link4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # hpu2sampler4xi5test
                            code2ack  = code2ack + '32B-'
                        except:
                            message2print = "{(Step 32Z1/70) failed" + "; import2use4hpu-failed-by-get2kernelworkgroupinfo4hpu: " + str(import2use4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)                            
                            # 
                            message2print = "{(Step 32Z2/70) used" + "; target2link4hpu-used-by-get2kernelworkgroupinfo4hpu: " + str(target2link4hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                            code2nack  = code2nack + '32Z2-'
                                    
                        # ---------------------------------------------------------------------------------------------    
                        # CREATE PROCESS WITH TARGET2FUNCTION4HPU
                        # ---------------------------------------------------------------------------------------------                          
                        p2hpu = Process4Xi(target=target2function4hpu, args=())                                
                        message2print = "{(Step 33A/70) created" + "; p2hpu-created-by-get2kernelworkgroupinfo4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        # <Process4Xi(Process4Xi-2, initial)>
                        
                        process2kernelworkgroupinfo4hpu[key2code4hpu] = p2hpu
                        
                        code2ack  = code2ack + '33A-'
                        try:
                            # ---------------------------------------------------------------------------------------------    
                            # START PROCESS
                            # --------------------------------------------------------------------------------------------- 
                            p2hpu.start()
                            message2print = "{(Step 34A/70) started" + "; p2hpu-started-by-get2kernelworkgroupinfo4hpu: " + str(p2hpu.name) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # Process4Xi-2
                            
                            try:
                                # ---------------------------------------------------------------------------------------------    
                                # STATUS OF PROCESS
                                # ---------------------------------------------------------------------------------------------                             
                                status2process4hpu = p2hpu.is_alive()
                                message2print = "{(Step 35A/70) got" + "; status-got-by-get2kernelworkgroupinfo4hpu: " + str(status2process4hpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)
                                # True
                                
                                try:
                                    # ---------------------------------------------------------------------------------------------    
                                    # RUN PROCESS
                                    # ---------------------------------------------------------------------------------------------                                  
                                    p2hpu.run()
                                    message2print = "{(Step 36A/70) run" + "; p2hpu-run-by-get2kernelworkgroupinfo4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)
                                    # <Process4Xi(Process4Xi-1, stopped[1])>
                                except:
                                    message2print = "{(Step 36Z/70) failed" + "; run-failed-by-get2kernelworkgroupinfo4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                                    print4xi(class2print, method2print, message2print)  
                                    code2nack  = code2nack + '36Z-'            
                                    # 
                            except:
                                message2print = "{(Step 35Z/70) failed" + "; status-failed-by-get2kernelworkgroupinfo4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)  
                                # 
                                code2nack  = code2nack + '35Z-'                                   
                                
                        except:
                            message2print = "{(Step 33Z/70) failed" + "; start-failed-by-get2kernelworkgroupinfo4hpu: " + str(p2hpu) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)  
                            code2nack  = code2nack + '33Z-'     
                        
                    except:
                        message2print = "{(Step 32Z/70) failed" + "; p2code4hpu-failed-by-get2kernelworkgroupinfo4hpu: " + str(p2code4hpu) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)  
                        code2nack  = code2nack + '32Z-' 
                                                                                    

 
        message2print = "{(Step 38A/70) set" + "; process2kernelworkgroupinfo4hpu-set-by-get2kernelworkgroupinfo4hpu to: " + str(process2kernelworkgroupinfo4hpu)  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
         
        code2ack  = code2ack + '38A-'
    except: 
        message2print = "{(Step 30Z1/70) yielded" + "; code-yielded-by-get2kernelworkgroupinfo4hpu: " + str(hpu2kernel4xi['CODE4SOURCE']) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '30Z1-'     

                                                                                                               
    # -----------------------------------------------------------------------------------------
    # (Step 70/70)           
    # -----------------------------------------------------------------------------------------
    hpu2kernel4xi ['ACK2RETURN']  = code2ack
    hpu2kernel4xi ['NACK2RETURN'] = code2nack  
    
    message2print = "{(Step 70/70) returning" + "; process2kernelworkgroupinfo4hpu-returning-by-get2kernelworkgroupinfo4hpu: " + str(process2kernelworkgroupinfo4hpu) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              
    # 
    return process2kernelworkgroupinfo4hpu
            
#</function4xi> 
 
                                        
# =================================================================================================
#<class4xi class = "HPU2Kernel4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for HPU kernels" usage = "Kernel4Xi of HPU"
#>

# =================================================================================================
class HPU2Kernel4Xi(object): 
    ''' 
    HPU2Kernel4Xi offers  methods for HPU kernels
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2hpu = cpu_corecount4xi()
    #"
    #/>
       
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
            'add2kernel',                      # ACK              

            'execute2kernel',                  # ACK 5.8    p169                                             
            'execute2task',                    # ACK 5.8    p172   
            'execute2nativekernel',            # ACK 5.8    p174     
            
            'create2kernel',                   # ACK 5.7.1  p157   
            'create2kernelsinprogram',         # ACK 5.7.1  p158  
                       
            'delete2kernel',                   # ACK

            'fetch2kernel',                    # ACK 
            
            'get2kernelinfo',                  # ACK 5.7.3  p162  
            'get2kernelworkgroupinfo',         # ACK 5.7.3  p164  
            'get2kernelarginfo',               # ACK 5.7.3  p166                                  
            
            'release2kernel',                  # ACK 5.7.1  p159                                         
            'retain2kernel',                   # ACK 5.7.1  p159   
 
            'set2kernel',                      # ACK 
            'set2kernelcallback',              # ACK 
            'set2kernelarg',                   # ACK 5.7.2  p160 
                                          
            'trace2kernel',                    # ACK 
            
            'sense',                           # ACK
            'reason',                          # ACK
            'ace')                             # ACK   
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 110A/700) OF HPU2KERNEL4XI5TEST - CREATING KERNEL OBJECT OF HPU ', time4xi())        
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # CREATE WITH OBJECT                  
    #       # ---------------------------------------------------------------------------------------------        
    #       kernelobject2hpu = HPU2Kernel4Xi()
    #       print('(Step 110B/700) OF HPU2KERNEL4XI5TEST - CREATED KERNEL OBJECT OF HPU: ', kernelobject2hpu)                                  
    #       # 
    #   except:
    #       print('(Step 110Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL OBJECT OF HPU') 
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4kernel2hpu = None):
        '''
        _init__ method initializes HPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "HPU2Kernel4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1A/33) started" + "; init-of-HPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 

        message2print = "{(Step 1B/33) borning" + "; hpu2kernel2xi-of-HPU2Kernel4Xi-borning: None" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 1C/33) inheriting" + "; object-inheriting-by-hpu2kernel2xi-of-HPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <class 'object'>
        
        message2print = "{(Step 1D/33) sharing" + "; classvariable2hpu-sharing-by-hpu2kernel2xi-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi.classvariable2hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 4        
                                
        message2print = "{(Step 1E/33) passed" + "; task4kernel2hpu-passed-to-init-of-HPU2Kernel4Xi: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None                      
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)             
        # -----------------------------------------------------------------------------------------
    
        message2print = "{(Step 2A/33) passing" + "; task4kernel2hpu-passing-to-create2kernel4hpu-by-init-of-HPU2Kernel4Xi: " + str(task4kernel2hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None  
                
        hpu2kernel2xi = create2kernel4hpu(task4kernel2hpu)
        
        message2print = "{(Step 2B/33) performed" + "; create2kernel4hpu-performed-by-init-of-HPU2Kernel4Xi: " + str(create2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # <function create2kernel4hpu at 0x00000000041E54C8>
       
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3A/33) activated" + "; hpu2kernel2xi-of-HPU2Kernel4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
                
        message2print = "{(Step 3B/33) inherited" + "; object-inherited-by-hpu2kernel2xi-of-HPU2Kernel4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        message2print = "{(Step 3C/33) shared" + "; classvariable2hpu-shared-by-hpu2kernel2xi-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi.classvariable2hpu)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        #     
       
        message2print = "{(Step 3D/33) returning" + "; init-of-HPU2Kernel4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "add2kernel-of-HPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 132A/700) OF HPU2KERNEL4XI5TEST - TRYING TO ADD KERNEL TO HPU  WITH METHOD', time4xi())         
    #   try:
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'hpu2dummy4xi.py'] = {}
    #       task4add2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'hpu2dummy4xi.py'] [1] = '... profile = "11" />'
    #
    #       response4add2kernel = programobject2hpu.add2kernel(task4add2kernel) 
    #       print('(Step 132B/700) OF HPU2KERNEL4XI5TEST - ADDED KERNEL TO HPU  WITH METHOD', time4xi())
    #   except:
    #       print('(Step 132Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO ADD KERNEL TO HPU WITH METHOD *** ', time4xi())
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def add2kernel(self, task4add2kernel = None):
        '''
        adds kernel to HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "add2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; add2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4add2kernel-passed-to-add2kernel-of-HPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4add2kernel-passing-to-add2kernel4hpu-by-add2kernel-of-HPU2Kernel4Xi: " + str(task4add2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4add2kernel = add2kernel4hpu(task4add2kernel)

        message2print = "{(Step 2B/33) performed" + "; add2kernel4hpu-performed-by-add2kernel-of-HPU2Kernel4Xi: " + str(add2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4add2kernel-returning-by-add2kernel-of-HPU2Kernel4Xi: " + str(response4add2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4add2kernel
                                
                            
    #</methodize4xi>    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2task-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 240A/700) OF HPU2KERNEL4XI5TEST - TRYING TO EXECUTE TASK OF HPU WITH METHOD ', time4xi())    
    #   try:                               
    #       response4execute2task = programobject2hpu.execute2task() 
    #       print('(Step 240B/700) OF HPU2KERNEL4XI5TEST - EXECUTED TASK OF HPU WITH METHOD ', time4xi())
    #   except:
    #       print('(Step 240Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO EXECUTE TASK OF HPU WITH METHOD ', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2task(self, task4execute = None):
        '''
        executes task of kernel of HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "execute2task"
                     
        message2print = "{(Step 1A/33) started" + "; execute2task-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute-passed-to-create-of-HPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute-passing-to-execute2task4hpu-by-execute2task-of-HPU2Kernel4Xi: " + str(task4execute) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #    
  
        hpu2program2xi = execute2task4hpu(task4execute)

        message2print = "{(Step 2B/33) performed" + "; execute2task4hpu-performed-by-execute2task-of-HPU2Kernel4Xi: " + str(execute2task4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; hpu2program2xi-returning-by-execute2task-of-HPU2Kernel4Xi: " + str(hpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return hpu2program2xi
                     
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2nativekernel-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121A1/700) OF HPU2KERNEL4XI5TEST - TRYING TO EXECUTE KERNEL OF HPU ', time4xi())      
    #   try:
    #       # ---------------------------------------------------------------------------------------------
    #       # COMPILE                        
    #       # ---------------------------------------------------------------------------------------------        
    #       response4compile = executeobject2hpu.execute2nativekernel()
    #       print('(Step 121A2/700) OF HPU2KERNEL4XI5TEST - EXECUTED KERNEL OF HPU', time4xi())                                   
    #   except:
    #       print('(Step 121AZ1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO EXECUTE KERNEL OF HPU', time4xi())   
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def execute2nativekernel(self, task4execute2kernel = None):
        '''
        executes native kernel of HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "execute2nativekernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2nativekernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-create-of-HPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2nativekernel4hpu-by-execute2nativekernel-of-HPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        hpu2execute2xi = execute2nativekernel4hpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2nativekernel4hpu-performed-by-execute2nativekernel-of-HPU2Kernel4Xi: " + str(execute2nativekernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; hpu2execute2xi-returning-by-execute2nativekernel-of-HPU2Kernel4Xi: " + str(hpu2execute2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return hpu2execute2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelworkgroupinfo-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 121C1/700) OF HPU2KERNEL4XI5TEST - TRYING TO GET WORK GROUP INFOR OF HPU WITH METHOD ', time4xi())      
    #   try:
    #      
    #       response4getworkgroupinfo = programobject2hpu.get2kernelworkgroupinfo()
    #       print('(Step 121C2/700) OF HPU2KERNEL4XI5TEST - GOT WORK GROUP INFOR OF HPU WITH METHOD ', time4xi())                                   
    #   except:
    #       print('(Step 121CZ1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO GET WORK GROUP INFOR OF HPU WITH METHOD ', time4xi())  
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelworkgroupinfo(self, task4getworkgroupinfo = None):
        '''
        get kernel work group info OF HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "get2kernelworkgroupinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelworkgroupinfo-of-HPU2Kernel4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4getworkgroupinfo-passed-to-create-of-HPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # None
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4getworkgroupinfo-passing-to-get2kernelworkgroupinfo4hpu-by-get2kernelworkgroupinfo-of-HPU2Kernel4Xi: " + str(task4getworkgroupinfo) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        hpu2program2xi = get2kernelworkgroupinfo4hpu(task4getworkgroupinfo)

        message2print = "{(Step 2B/33) performed" + "; get2kernelworkgroupinfo4hpu-performed-by-get2kernelworkgroupinfo-of-HPU2Kernel4Xi: " + str(get2kernelworkgroupinfo4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; hpu2program2xi-returning-by-get2kernelworkgroupinfo-of-HPU2Kernel4Xi: " + str(hpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return hpu2program2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernel-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 190A/700) OF HPU2KERNEL4XI5TEST - TRYING TO CREATE KERNEL FOR HPU ', time4xi()) 
    #   try:
    #       kernelobject2hpu = HPU2Kernel4Xi()                            
    #       response4create2kernel = kernelobject2hpu.create2kernel()
    #       print('(Step 190B/700) OF HPU2KERNEL4XI5TEST - CREATED KERNEL FOR HPU ', time4xi())
    #   except:
    #       print('(Step 190Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO CREATE KERNEL FOR HPU ', time4xi())                                    
    #           
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernel(self, task4kernel2create = None):
        '''
        create2kernel method creates kernel objects of HPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "create2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #  
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-HPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernel4hpu-by-create2kernel-of-HPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #  
  
        hpu2kernel2xi = create2kernel4hpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernel4hpu-performed-by-create2kernel-of-HPU2Kernel4Xi: " + str(create2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernel4hpu at 0x0000000003B0C5C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        keys2response4create = hpu2kernel2xi.keys() 
        message2print = "{(Step 33A/33) returning" + "; keys2response4create-returning-by-create2kernel-of-HPU2Kernel4Xi: " + str(keys2response4create) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                         
        # ['FUNCTION',
        #  'CODE2ERROR',
        #  'COUNT2REFERENCE',
        #  'DATA2CALLBACK',
        #  'BUFFER',
        #  'FUNCTION2CALLBACK',
        #  'ACK2RETURN',
        #  'QUEUE',
        #  'PLATFORM',
        #  'PROGRAM',
        #  'NACK2RETURN',
        #  'CONTEXT',
        #  'COMMANDQUEUE',
        #  'DEVICE',
        #  'EVENT',
        #  'PIPE']
        message2print = "{(Step 33B/33) returning" + "; function-returning-by-create2kernel-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi['FUNCTION']) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # hpu2sampler4xi5test 
        
        return hpu2kernel2xi
                                
    #                        
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "create2kernelsinprogram-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 130A/700) OF HPU2KERNEL4XI5TEST - CREATING KERNELS IN PROGRM FOR HPU ', time4xi())      
    #   try:
    #       response4create2kernelsinprogram = kernelobject2hpu.create2kernelsinprogram()
    #       print('(Step 130A/700) OF HPU2KERNEL4XI5TEST - CREATED KERNELS IN PROGRM FOR HPU ', time4xi())
    #   except:
    #       print('(Step 130Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO KERNELS IN PROGRM FOR HPU', time4xi())
    #                     
    #">   
    
    # ---------------------------------------------------------------------------------------------   
    def create2kernelsinprogram(self, task4kernel2create = None):
        '''
        creates kernels in program of HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "create2kernelsinprogram"
                     
        message2print = "{(Step 1A/33) started" + "; create2kernelsinprogram-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4kernel2create-passed-to-create-of-HPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4kernel2create-passing-to-create2kernelsinprogram4hpu-by-create2kernelsinprogram-of-HPU2Kernel4Xi: " + str(task4kernel2create) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        # 
  
        hpu2kernel2xi = create2kernelsinprogram4hpu(task4kernel2create)

        message2print = "{(Step 2B/33) performed" + "; create2kernelsinprogram4hpu-performed-by-create2kernelsinprogram-of-HPU2Kernel4Xi: " + str(create2kernelsinprogram4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function create2kernelsinprogram4hpu at 0x00000000040248C8>
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/33) returning" + "; hpu2kernel2xi-returning-by-create2kernelsinprogram-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # 
        # 

        return hpu2kernel2xi
                                
    #                        
    #</methodize4xi>
        

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "delete2kernel-of-HPU2Kernel4Xi" usage = "
    #  
    #   print('(Step 134A/700) OF HPU2KERNEL4XI5TEST - TRYING TO DELETE KERNEL IN PROGRAM OF HPU WITH METHOD ', time4xi())        
    #   try:
    #       task4delete2kernel = {}
    #       task4delete2kernel ['CODE4KERNEL'] = {}
    #       task4delete2kernel ['CODE4KERNEL'] [folder2lib4hpu + 'dummy3image4xi..py'] = 'Yes'
    #       task4delete2kernel ['SIZE4KERNEL'] = {}
    #       task4delete2kernel ['SIZE4KERNEL'] [folder2lib4hpu + 'dummy3image4xi..py'] = 'Yes'
    #       
    #       response4delete2kernel = programobject2hpu.delete2kernel(task4delete2kernel)
    #       print('(Step 134B/700) OF HPU2KERNEL4XI5TEST - DELETED DELETE KERNEL IN PROGRAM of HPUWITH METHOD ', time4xi())                                                                  
    #   except:
    #       print('(Step 134Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO DELETE DELETE KERNEL IN PROGRAM OF HPU WITH METHOD *** ', time4xi())
    #                  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def delete2kernel(self, task4delete2kernel = None):
        '''
        deletes kernel in program of HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "delete2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; delete2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4delete2kernel-passed-to-delete2kernel-of-HPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4delete2kernel-passing-to-delete2kernel4hpu-by-delete2kernel-of-HPU2Kernel4Xi: " + str(task4delete2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        response4delete2kernel = delete2kernel4hpu(task4delete2kernel)

        message2print = "{(Step 2B/33) performed" + "; delete2kernel4hpu-performed-by-delete2kernel-of-HPU2Kernel4Xi: " + str(delete2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; response4delete2kernel-returning-by-delete2kernel-of-HPU2Kernel4Xi: " + str(response4delete2kernel) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return response4delete2kernel
                                
                            
    #</methodize4xi>    


        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernel-of-HPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernel ...
    #   print('(Step 158A/700) OF HPU2KERNEL4XI5TEST - TRYING TO SET KERNEL OF HPU: ', time4xi()) 
    #   try: 
    #       response4set2kernel = kernelobject2hpu.set2kernel(task4set2kernel)
    #       print('(Step 158B/700) OF HPU2KERNEL4XI5TEST - SET KERNEL OF HPU: ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL OF HPU: ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernel(self, task4set2kernel = None):
        '''
        sets kernel HPU objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "set2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernel-passed-to-set2kernel-of-HPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernel-passing-to-set2kernel4hpu-by-set2kernel-of-HPU2Kernel4Xi: " + str(task4set2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        hpu2kernel2xi = set2kernel4hpu(task4set2kernel)

        message2print = "{(Step 2B/33) performed" + "; set2kernel4hpu-performed-by-set2kernel-of-HPU2Kernel4Xi: " + str(set2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; hpu2kernel2xi-returning-by-set2kernel-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return hpu2kernel2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelarg-of-HPU2Kernel4Xi" usage = "
    # 
    #   ... prepare task4set2kernelarg ...
    #   print('(Step 158A/700) OF HPU2KERNEL4XI5TEST - TRYING TO SET KERNEL ARGUMENTS FOR HPU: ', time4xi())
    #   try: 
    #       response4set2kernelarg = programobject2hpu.set2kernelarg(task4set2kernelarg)
    #       print('(Step 158B/700) OF HPU2KERNEL4XI5TEST - SET KERNEL ARGUMENTS FOR HPU ', time4xi())    
    #   except:
    #       print('(Step 158Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SET KERNEL ARGUMENTS FOR HPU ', time4xi())
    #       
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelarg(self, task4set2kernelarg = None):
        '''
        sets kernel arguments for HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "set2kernelarg"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelarg-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelarg-passed-to-set2kernelarg-of-HPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelarg-passing-to-set2kernelarg4hpu-by-set2kernelarg-of-HPU2Kernel4Xi: " + str(task4set2kernelarg) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        hpu2program2xi = set2kernelarg4hpu(task4set2kernelarg)

        message2print = "{(Step 2B/33) performed" + "; set2kernelarg4hpu-performed-by-set2kernelarg-of-HPU2Kernel4Xi: " + str(set2kernelarg4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; hpu2program2xi-returning-by-set2kernelarg-of-HPU2Kernel4Xi: " + str(hpu2program2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
                
        return hpu2program2xi
                             
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelinfo-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF HPU2KERNEL4XI5TEST - TRYING TO GET KERNEL INFO ', time4xi())    
    #   try:                               
    #       response4get2kernelinfo = kernelobject2hpu.get2kernelinfo()                                 
    #       print('(Step 106B/700) OF HPU2KERNEL4XI5TEST - GOT GET KERNEL INFO ', time4xi())                             
    #   except:
    #       print('(Step 106Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL INFO ', time4xi()) 
    #   
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelinfo(self, task4getinfo2kernel=None):
        '''
        gets kernel info of HPU 
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "get2kernelinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelinfo-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        hpu2kernel2xi = get2kernelinfo4hpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; hpu2kernel2xi-returning-by-get2kernelinfo-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return hpu2kernel2xi
                            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2kernelarginfo-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A/700) OF HPU2KERNEL4XI5TEST - TRYING TO GET KERNEL ARGUMENT INFO OF HPU ', time4xi())    
    #   try:                               
    #       response4get2kernelarginfo = kernelobject2hpu.get2kernelarginfo()
    #       print('(Step 106B/700) OF HPU2KERNEL4XI5TEST - GOT KERNEL ARGUMENT INFO OF HPU ', time4xi())                                   
    #   except:
    #       print('(Step 106Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO GET KERNEL ARGUMENT INFO OF HPU ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2kernelarginfo(self, task4getinfo2kernel=None):
        '''
        gets kernel argument info of HPU
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "get2kernelarginfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2kernelarginfo-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:01:22 11/17/11 Pacific Standard Time

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        hpu2kernel2xi = get2kernelarginfo4hpu(task4getinfo2kernel)
        
        message2print = "{(Step 2A/33) returning" + "; hpu2kernel2xi-returning-by-get2kernelarginfo-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 

        return hpu2kernel2xi
                            
    #</methodize4xi>
   
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2buildinfo-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 106A1/700) OF HPU2BUILD4XI5TEST - TRYING TO GET BUILD INFO ', time4xi())    
    #   try:                               
    #                               
    #       response4get2buildinfo = programobject2hpu.get2buildinfo()
    #       print('(Step 106A2/700) OF HPU2BUILD4XI5TEST - GOT BUILD INFO ', time4xi())    
    #   except:
    #       print('(Step 106Z1/700) OF HPU2BUILD4XI5TEST *** FAILED TO GET BUILD INFO ', time4xi()) 
    # 
    # ">
    
    # ---------------------------------------------------------------------------------------------   
    def get2buildinfo(self, task4getinfo2build=None):
        '''
        get2buildinfo method gets objects of HPU2Kernel4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "get2buildinfo"
                     
        message2print = "{(Step 1A/33) started" + "; get2buildinfo-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 

        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # ----------------------------------------------------------------------------------------- 
        hpu2build2xi = get2buildinfo4hpu(task4getinfo2build)
        
        message2print = "{(Step 2A/33) returning" + "; hpu2build2xi-returning-by-get2buildinfo-of-HPU2Kernel4Xi: " + str(hpu2build2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        return hpu2build2xi
                            
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "release2kernel-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 170A/700) OF HPU2KERNEL4XI5TEST - RELEASING KERNEL ', time4xi())  
    #   task4release2kernel  = {}
    #   task4release2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4release2kernel = kernelobject2hpu.release2kernel(task4release2kernel)
    #       print('(Step 170B/700) OF HPU2KERNEL4XI5TEST - RELEASED KERNEL ', time4xi())
    #   except:
    #       print('(Step 170Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO RELEASE KERNEL ', time4xi())                        
    #       keys2response = response4release2kernel.keys()
    #  
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def release2kernel(self, task4release2kernel = None):
        '''
        releases HPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "release2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; release2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
            
        message2print = "{(Step 1B/33) passed" + "; task4release2kernel-passed-to-release2kernel-of-HPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4release2kernel-passing-to-release2kernel4hpu-by-release2kernel-of-HPU2Kernel4Xi: " + str(task4release2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
  
        hpu2kernel2xi = release2kernel4hpu(task4release2kernel)

        message2print = "{(Step 2B/33) performed" + "; release2kernel4hpu-performed-by-release2kernel-of-HPU2Kernel4Xi: " + str(release2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; hpu2kernel2xi-returning-by-release2kernel-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #               
                
        return hpu2kernel2xi
                                                           
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "retain2kernel-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 180A/700) OF HPU2KERNEL4XI5TEST - RETAINING KERNEL ', time4xi())
    #   task4retain2kernel  = {}
    #   task4retain2kernel  ['COUNT2REFERENCE'] = 1
    #   try:
    #       response4retain2kernel = kernelobject2hpu.retain2kernel(task4retain2kernel)
    #       print('(Step 180B/700) OF HPU2KERNEL4XI5TEST - RETAINED KERNEL ', time4xi())
    #   except:
    #       print('(Step 180Z1/700) OF HPU2KERNEL4XI5TEST *** FAILED TO RETAIN KERNEL ', time4xi())                    
    # 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def retain2kernel(self, task4retain2kernel = None):
        '''
        retains HPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "retain2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; retain2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4retain-passed-to-retain2kernel-of-HPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4retain-passing-to-retain2kernel4hpu-by-retain-of-HPU2Kernel4Xi: " + str(task4retain2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
  
        hpu2kernel2xi = retain2kernel4hpu(task4retain2kernel)

        message2print = "{(Step 2B/33) performed" + "; retain2kernel4hpu-performed-by-retain2kernel-of-HPU2Kernel4Xi: " + str(retain2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; hpu2kernel2xi-returning-by-retain2kernel-of-HPU2Kernel4Xi: " + str(hpu2kernel2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 
            
                
        return hpu2kernel2xi
                                                           
    #</methodize4xi>   
    
 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "trace2kernel-of-HPU2Kernel4Xi" usage = "
    #     
    #   print('(Step 210A/25) OF HPU2KERNEL4XI5TEST - TRYING TO TRACE HPU: ', time4xi())      
    #   trace2hpu = None
    #   try:
    #       trace2hpu = programobject2hpu.trace2kernel() 
    #               print('(Step 210B/25) OF HPU2KERNEL4XI5TEST - TRACE2HPU: ', trace2hpu)  
    #       # {'MESSAGE': '{(Step 2Z0/33) failed; trace2kernel4hpu-failed {}; time: 04:40:24 11/16/11 Pacific Standard Time}', 'CLASS': 'trace2kernel4hpu', 'METHOD': 'trace2kernel4hpu'}
    #        except:
    #           print('(Step 210Z1/25) OF HPU2KERNEL4XI5TEST *** FAILED TO TRACE HPU: ', trace2hpu) 
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def trace2kernel(self, task4trace2kernel = None):
        '''
        traces HPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "trace2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; trace2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4trace2kernel-passed-to-trace-of-HPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4trace2kernel-passing-to-trace2kernel4hpu-by-trace2kernel-of-HPU2Kernel4Xi: " + str(task4trace2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = trace2kernel4hpu(task4trace2kernel)

        message2print = "{(Step 2B/33) performed" + "; trace2kernel4hpu-performed-by-trace2kernel-of-HPU2Kernel4Xi: " + str(trace2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-trace2kernel-of-HPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "execute2kernel-of-HPU2Kernel4Xi" usage = "
    #        
    #   print('(Step 220A/25) OF HPU2KERNEL4XI5TEST - TRYING TO UNLOAD COMPILER OF HPU: ', time4xi())      
    #   try:
    #       response4execute2kernel = programobject2hpu.execute2kernel() 
    #       print('(Step 220B/25) OF HPU2KERNEL4XI5TEST - UNLOADED COMPILER OF HPU: ', response4execute2kernel)  
    #       # 
    #   except:
    #       print('(Step 220Z1/25) OF HPU2KERNEL4XI5TEST *** FAILED TO TO UNLOAD COMPILER OF HPU: ', time4xi()) 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def execute2kernel(self, task4execute2kernel = None):
        '''
        executes kernel
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "execute2kernel"
                     
        message2print = "{(Step 1A/33) started" + "; execute2kernel-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
         
            
        message2print = "{(Step 1B/33) passed" + "; task4execute2kernel-passed-to-trace-of-HPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # 
         
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4execute2kernel-passing-to-execute2kernel4hpu-by-execute2kernel-of-HPU2Kernel4Xi: " + str(task4execute2kernel) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
         
  
        trace2xi = execute2kernel4hpu(task4execute2kernel)

        message2print = "{(Step 2B/33) performed" + "; execute2kernel4hpu-performed-by-execute2kernel-of-HPU2Kernel4Xi: " + str(execute2kernel4hpu) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 
        
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; trace2xi-returning-by-execute2kernel-of-HPU2Kernel4Xi: " + str(trace2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #       
                
        return trace2xi
                                                           
    #</methodize4xi>       

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2kernelcallback-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 200A/700) OF HPU2KERNEL4XI5TEST - TRYING TO SET KERNELCALLBACK WITH METHOD OF OBJECT XI2HPU: ', programobject2hpu) 
    #   try:
    #       callback2hpu = programobject2hpu.set2kernelcallback()                                  
    #       print('(Step 200B/700) OF HPU2KERNEL4XI5TEST - SET KERNELWITH CALLBACK TO: ', callback2hpu)
    #       # 
    #   except:
    #       print('(Step 200Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SET KERNELCALLBACK WITH METHOD ***', time4xi())
    #
    #">
    
    # ---------------------------------------------------------------------------------------------   
    def set2kernelcallback(self, task4set2kernelcallback = None): 
        '''
        set2kernelcallback of HPU2Kernel4Xi objects
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/33)           
        # -----------------------------------------------------------------------------------------              
        class2print = "HPU2Kernel4Xi"
        method2print = "set2kernelcallback"
                     
        message2print = "{(Step 1A/33) started" + "; set2kernelcallback-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
            
        message2print = "{(Step 1B/33) passed" + "; task4set2kernelcallback-passed-to-set2kernelcallback-of-HPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          
        # None 
           
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/33)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) passing" + "; task4set2kernelcallback-passing-to-set2kernelcallback-by-set2kernelcallback-of-HPU2Kernel4Xi: " + str(task4set2kernelcallback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                               
        # 
        
        
        callback2hpu4program = {} 
        try:
            callback2hpu4program = set2kernelcallback4hpu (task4set2kernelcallback)

            
        except:
            message2print = "{(Step 4A/33) failed" + "; callback2hpu4program-failed-by-set2kernelcallback-of-HPU2Kernel4Xi: " + str(callback2hpu4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                                            
        # -----------------------------------------------------------------------------------------
        # (Step 3/33)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 3A/33) returning" + "; callback2hpu4program-returning-by-set2kernelcallback-of-HPU2Kernel4Xi: " + str(callback2hpu4program) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # <function trace2kernel4hpu at 0x00000000038CF5C8> 
        
                                             
        return callback2hpu4program
                                                           
    #</methodize4xi>     
    
                                                              
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 310A/700) OF HPU2KERNEL4XI5TEST - SENSING ', time4xi())  
    #   try:
    #       print(programobject2hpu.sense())
    #       print('(Step 310B/700) OF HPU2KERNEL4XI5TEST - SENSED ', time4xi()) 
    #       # 
    #   except:
    #       print('(Step 310Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO SENSE ', time4xi())     
    #
    # ">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses HPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'HPU2Kernel4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1A/33) started" + "; sense-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2A/33) sensing" + "; HPU2Kernel4Xi-sensing-by-sense-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
            
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3A/33) got" + "; kb2xi-got-by-sense-of-HPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
         
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2hpu-of-HPU2Kernel4Xi'] = HPU2Kernel4Xi.classvariable2hpu
        except:
            message2print = "{(Step 4A/33) yielded" + "; kb2xi-yielded-by-sense-of-HPU2Kernel4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5A/33) sensed" + "; HPU2Kernel4Xi-sensed-by-sense-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6A/33) returning" + "; kb2xi-returning-by-sense-of-HPU2Kernel4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-HPU2Kernel4Xi" usage = "
    # 
    #   print('(Step 320A/700) OF HPU2KERNEL4XI5TEST - REASONING ', time4xi())
    #   try:
    #       print(programobject2hpu.reason())
    #       print('(Step 320B/700) OF HPU2KERNEL4XI5TEST - REASONED ', time4xi())
    #       # 
    #   except:
    #       print('(Step 320Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO REASON ', time4xi()) 
    #
    #">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons HPU2Kernel4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'HPU2Kernel4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1A/33) started" + "; reason-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) reasoning" + "; HPU2Kernel4Xi-reasoning-by-reason-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
        
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3A/33) got" + "; kb4xi-got-by-reason-of-HPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 
             
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-HPU2Kernel4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4Z/33) yielded" + "; kb4xi-yielded-by-reason-of-HPU2Kernel4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5A/33) reasoned" + "; HPU2Kernel4Xi-reasoned-by-reason-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        # 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6A/33) returning" + "; kb4xi-returning-by-reason-of-HPU2Kernel4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        #           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-HPU2Kernel4Xi" usage = "
    #
    #   print('(Step 330A/700) OF HPU2KERNEL4XI5TEST - ACING ', time4xi())   
    #   try:
    #       print(programobject2hpu.ace())
    #       print('(Step 330B/700) OF HPU2KERNEL4XI5TEST - ACED ', time4xi())                                                 
    #       # 
    #   except:
    #       print('(Step 330Z/700) OF HPU2KERNEL4XI5TEST *** FAILED TO ACE ', time4xi())                                 
    #    
    #">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces HPU2Kernel4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'HPU2Kernel4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1A/33) started" + "; ace-of-HPU2Kernel4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2A/33) acing" + "; HPU2Kernel4Xi-acing-by-ace-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #      
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3A/33) got" + "; kb8xi-got-by-ace-of-HPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['cores-of-HPU2Kernel4Xi'] = HPU2Kernel4Xi.classvariable2hpu
        except:
             message2print = "{(Step 4A/33) yielded" + "; kb8xi-yielded-by-ace-of-HPU2Kernel4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5A/33) aced" + "; HPU2Kernel4Xi-aced-by-ace-of-HPU2Kernel4Xi: " + str(HPU2Kernel4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'hpu2codeprogram4xi.HPU2Kernel4Xi'> 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6A/33) returning" + "; kb8xi-returning-by-ace-of-HPU2Kernel4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          
        # 
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   hpu2codeprogram4xi5test.txt
#   sense-hpu2codeprogram4xi5test.xml
#   reason-hpu2codeprogram4xi5test.xml
#   ace-hpu2codeprogram4xi5test.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>

# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# nothing
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of hpu2kernel4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
